c  VERSION  2.0, submitted 8 March 2006
c
c  Part of the SHAREv2.1 suite of programs by G. Torrieri, S. Jeon, 
c  J. Rafelski, and J. Lettesier, published as nucl-th/0603026
c  Based on the SHARE package, G. Torrieri, S. Steinke, W. Broniowski,
c  W. Florkowski, J. Rafelski, and J. Lettesier, published as
c  Comput.Phys.Commun.167:229-251,2005, nucl-th/0404083
c  AUTHOR OF CODE:   GIORGIO TORRIERI, torrieri@physics.mcgill.ca
c  Address: Department of Physics, McGill University, Montral, Quebec, H2X2T8, Canada
c  http:/www.physics.arizona.edu/~torrieri/SHARE/share.html
c---------------------------------------------
c  This version was certified to agree, to all decimal places, with SHAREv1.2.
c  Bugs corrected:
c
c--  In v2.0, The chemical potential was not calculated correctly for MIXED
c    quark states.  This could have had
c    an effect in the determination of GAMQ,GAMS,GAM3.  This has now been
c    fixed, and removed MOST of the disagreement between v2.0 and v1.2
c    (where this calculation was simpler since there was no distinction
c    between up and down quarks, hence no bug)
c
c--  no distinction was made in the decay tree between
c    KL -> pi e nu_e
c    and
c    KL -> pi mu nu_mu
c    The v2.0 program therefore disregared one of these decays.  This was
c    fixed by classifying e,mu,nu_e and nu_mu as different particles.
c
c--  v1.2 did not sum the B-E series correctly.  The effect of this turned
c    out to be fairly small, but it could make a difference at large
c    gamma_q
c
c--  A v1.2 patch treated Sigma weak decays as strong, since they are
c    experimentally undetectable (though NA49 measures them). 
c    v2.0 has no such patch.   In the present version of the v2.0 program,
c    the user should be careful to check that the weak feed-down file
c    gives the right coefficients for decays such as the Sigma.
c    Jan proposed automating this process, I might do it in the future,
c    but am a bit weary of this since, as we discovered, decay coefficients
c    are very experiment specific and SHOULD be set BY HAND by a CAREFUL
c    user.
c
c--  v2.0 disregarded a decay if decay products are heavier than the
c    resonance and the resonance has  no width.   v1.2 includes these
c    decays.   How one handles this is probably irrelevant for fits but 
c    quantitatively measurable, since the first decay of this type,
c    K(1210), is actually light enough to make a difference.
c
c---------------------------------------------
c--27/01/2006
c    a) A patch on the counting of degrees of freedom
c    b) Parameters are not anymore reset at the end of the fit
c    c) Fixed parameters are not "solved" anymore
c    On the 28th I also
c---------------------------------------------
c--29/01/2006
c    SHARE can now input experimental decays to particle correlations
c    (What we calculate in the fluctuations paper, http://arxiv.org/abs/nucl-th/0503026
c    NB: SHARE does NOT calculate these coefficients.  They are just put in by hand in the
c    input file.   See updated manual
c--29/01/2006  
c    A patch was put in to make sure that the particle and decays data-file is
c    loaded before the experimental weak decay corrections are loaded
c-------------------------------------------
c 31/01/2006: SHARE is now compatible with f95, and programming
c  issues which made it incompatible with an f95 compiler have been fixed
c--------------------------------------------------
c  6/02/2006:  Slightly modified way constrain parameters are treated.
c  Fixed bugs in decay tree treatment
c-----------------------------------------
c 4/03/2006: Fixed a bug dealing with fluctuations in decays with more than
c one identical decay product.   Only important in pi0 yields and fluctuations
c-----------------------------------------
c 5/03/2006 Fixed problem in QUARKFRACTION function, it was sometimes undefined.
c Revised and updated decay tree and particle data files
c------------------------------------------
c  8/03/2006 RELEASED TO PUBLIC
c------------------------------------------
c 9/03/2006 Added function DATCPRF,like RATCPRF but with datapoints
c------------------------------------------
c 11/03/2006 Fixed subtle issue with DATCPRF (not quite a bug)
c------------------------------------------
c 09/04/2006 Patched the PARTCORREL function to make SHARE do fluctuations
c of things like (K+ + K-)/(pi+ + pi-)
c--------------------------------------------------
c 19/04/2006   Added MINOS to fit algorithm, if needed (if MINUIT returns error)
c--------------------------------------------------
c 5/07/2006  Removed superfluous variables "NAMCHAR" and "XEQ" from "FCNRAT"
c subroutine
c----------------------------------
c 22/07/2006  Made the fit output format more flexible
c---------------------------------
c 24/08/2006  Fixed probable bug regarding CHTOI subroutine
c---------------------------------
c 15/09/2006 Added  'fluctdynv' fluctuation format:
c <N2>*sigma_{n1/n2}, independent of volume
c---------------------------------
c 19/09/2006 in profiles experimental datapoints now outputted just
c once
c---------------------------------
c 23/09/2006 Added some numerical intgrals for debugging. 
c still checking
c-------------------------------------------
c 2/10/2006 Bug fixed in entropy calculation, and numerical and
c Bessel series now agree.  Bug was due to incorrect power series summing
c of Gibbs-Durham
c---------------------------
c 13/10/2006 Reintroduced T*S (T_entropy option)
c--------------------------
c 16/11/2006 mnt now means "plus+minus",  not "plus-minus".
c For consistency with manual
c--------------------------
c 24/11/2006 Fixed a bug in 2D contour plots with mu_B.
c Also separated the exact-solving part from the fit part, thus 
c allowing for conservation laws to be solved in 2D profiles.
C Also added FITNMINOS option.   Like FITRATIOS, but MINOS is not used.
c--------------------------
c 15/05/2007
c a)updated particles data table
c b)Added 'fluctvdyn' $\nu_{dyn}=\sigma_{dyn}^2$
c------------------------------
c 16/05/2007
c SHARE now crashes with error message if particle line incomplete
c---------------------------------
c 19/05/2007
c Bug in input file and particle reader file fixed
c---------------------------------
c 28/08/2007
c Input format improved
c-------------------
c  1/11/2007
c  Bug fixed with "totstrong", Ambiguity with strong decaying particles resolved.
c  "totstrong" now refers to the particle multiplicity from strong decays ONLY,
c  with weakly decaying particles counted as 1 (rather than their accepted decay products,
c  which is the case of "tot_multi")
c-------------------
c  15/09/2007
c  (changed by Michal Petran)
c  a) Changed the time and date printout format to the output file to more human
c  readable format (changes made in routine DATETIME)
c  b) printing very large numbers in float format fixed in printout (FCNRAT subroutine)
c-------------------
c  12/07/2010
c  Increased IHDMX to 1000 to incorporate for newly implemented charm baryons
c  in the particle table.
c-------------------
c  07/04/2011
c=================================================
c  SHARE with CHARM released
c  SHAREv3.0.0
c-------------------
c  07/11/2013 -- v3.0.1
c  added variable TraceAnom = Trace anomaly = (epsilon - 3 pressure)/T^4
c-------------------
c  increased number of characters for the PDG code to allow for (hyper)nuclear PDG codes to 11
c-------------------
      PROGRAM SHARE 
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/   !! THERMAL PARAMETERS 
     1  T,GAMQ,GAMS,GAM3,LAMQ,LAMS    !! temperature in GeV, gamma_q, gamma_s, gamma_I3, lambda_q, lambda_s
     1 ,LAMC,NCBC,LMI3                !! lambda_c, Number of charm+anticharm quarks, lambda_I3
     1 ,CHEMFACT                      !! chemical factor, i.e. fugacity 
     1,DVOL,NORM,GAMU,GAMD,REALGAMC   !! dVol... Volume fluctuations, volume in fm3 (=normalization), gamma_u, gamma_d
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T  !! gamma_i's squared  
     1,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL   !!   Bose-Einstein condensation, using Boltzmann statistics, using gamma_s/gamma_q ratio rather then separately, canonical suppression flag
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/   !! PARTICLE PROPERTIES
     1 MHAD(IHDMX)  !! mass on the hadron in GeV
     1,WIDTH(IHDMX) !! width of the hadron in GeV
     1,CHEM(IHDMX)  !! 
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX)     !! number of up, down, strange and charm quarks in a hadron
     1,XAU(IHDMX),XAD(IHDMX),XAS(IHDMX),XACH(IHDMX) !! number of up, down, strange and charm anti-quarks in a hadron
     1,XB(IHDMX),XAB(IHDMX)  !! number of bottom quarks and anti-bottom quarks in a hadron
     1,XDEG(IHDMX),NAM,IBAR(IHDMX)
     1,INETQ(IHDMX)          !! electric charge of a hadron I am guessing
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/  !!  EXPERIMENTAL DATAPOINTS AND RATIOS THAT ARE FITTED/CALCULATED
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)   !! datapoint value, calculated value, chi term
     1,RATERR(IRATMX),DECDATA                           !! datapoint error, ??? DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW !! datapoint name, weak decay file, ??solving or fitting for a value??,
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)             !! 
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ !! HADRON DECAYS
     1 BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)  !! Branching ratios... in 5D array ?
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX) !! ?? how many possible decay channels, ????
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)   !! ????? !!????
      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT  !! MINUIT (the fitting package) NAMES FOR THERMAL PARAMETERS (I THINK)
      COMMON /MIPARSRAT_NUM/  !! MINUIT PARAMETERS AND OTHER FLAGS
     1 LLMRAT(IPRT),ULMRAT(IPRT)  !! lower and upper limit for fitting individual thermal parameters
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)  
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      COMMON /MINFLAGS/ IPRFMINOS
      CHARACTER*7 CHICONT
      CHARACTER*14 PARTFILE,TOTFILE
      CHARACTER*13 SETFILE
     1,CALCFILE,FITFILE,GRAPH_FIT,GRAPH_CLC,GRAPH_EXP
      CHARACTER*12 CHIPROFFILE,RATPROFFILE,FILE1,FILE2,FILE3,FOLDFILE
      CHARACTER*17 FILE1_PROF,FILE2_PROF
      CHARACTER*11 THERMOFILE,DECFILE
      CHARACTER*9 VERB,ACTION,CONTFILE
      CHARACTER*4 PARNAME,PARNAME1,PARNAME2
      DIMENSION GRAD(IPRT)
      EXTERNAL WLCM
C -------------  PRINTS WELCOME MESSAGE ----------------
      CALL WLCM
C--------------  COMMANDS ONE CAN ENTER ----------------
      OPEN(51,FILE='sharerun.data',STATUS='OLD')
      OPEN(61,FILE='sharerun.out',STATUS='UNKNOWN')
      IF(IRATMX.NE.IRATMX2) THEN
         WRITE(*,*) 'IRATMX!=IRATMX2, PLEASE CHANGE PROGRAM'
     1   ,IRATMX,IRATMX2
      ENDIF
      NAM(1)='nopart000'
      IBOLTZ=0
      CALL RANDOM_INIT
      IDEC(1)=-1
      MHAD(1)=-1D0
      PI=-1D0
      ICANONICAL=0
      IRATDAT=-1
      IFIXRAT(1)=-1
      ILAMQMUQ=0
      ILAMSMUS=0
      ILAMCMUC=0
      ILAM3MU3=0
      IPRFMINOS=0
      CALL DATETIME(61)
 110  CHEMFACT=1D0
      IF(IREADCOMMENT(51).GT.0) GO TO 111
 101  FORMAT(A4,2X,A9)
      READ(51,101,END=111) VERB,ACTION
      BACKSPACE 51
C
C---------------   SETTING PARAMETER
C
      IF(VERB.EQ.'PSET') THEN
 201     FORMAT(A4,2X,A4,2X,F10.5)
         READ(51,201) VERB,PARNAME,PARVAL
         WRITE(*,*) 'SETTING ',PARNAME,' TO ',PARVAL
         WRITE(61,*) 'SETTING ',PARNAME,' TO ',PARVAL
         CALL PARSET(PARNAME,PARVAL)
         PARRAT(IFINDPAR(PARNAME))=PARVAL
         PARSPARE(IFINDPAR(PARNAME))=PARVAL
C
C---------------   FIXING PARAMETER
C
      ELSEIF(VERB.EQ.'PFIX') THEN
 202     FORMAT(A4,2X,A4)
         READ(51,202) VERB,PARNAME
         IF((PARNAME.NE.'bltz').AND.(PARNAME.NE.'fdbe')
     1.and.(PARNAME.NE.'ce_b').and.(PARNAME.NE.'ce_s')
     1.and.(PARNAME.NE.'gcal')) THEN
         WRITE(61,*) 'FIXING ',PARNAME,' TO ',PARRAT(IFINDPAR(PARNAME))
         WRITE(*,*) 'FIXING ',PARNAME,' TO ',PARRAT(IFINDPAR(PARNAME))
            IFIXRAT(IFINDPAR(PARNAME))=0
         ELSEIF(PARNAME.EQ.'bltz') THEN
            WRITE(*,*) 'BOLTZMANN APPROXIMATION USED'
            WRITE(61,*) 'BOLTZMANN APPROXIMATION USED'
            IBOLTZ=1
         ELSEIF(PARNAME.EQ.'fdbe') THEN
            WRITE(*,*) 'BOLTZMANN APPROXIMATION TURNED OFF'
            WRITE(61,*) 'BOLTZMANN APPROXIMATION TURNED OFF'
            IBOLTZ=0
         ELSEIF(PARNAME.EQ.'ce_b') THEN
            WRITE(*,*) 'CANONICAL ENSEMBLE FOR BARYON#'
            WRITE(61,*) 'CANONICAL ENSEMBLE FOR BARYON#'
            ICANONICAL=1
         ELSEIF(PARNAME.EQ.'ce_s') THEN
            WRITE(*,*) 'CANONICAL ENSEMBLE FOR STRANGENESS'
            WRITE(61,*) 'CANONICAL ENSEMBLE FOR STRANGENESS'
            ICANONICAL=2
         ELSEIF(PARNAME.EQ.'gcal') THEN
            WRITE(*,*) 'GRAND CANONICAL ENSEMBLE FOR ALL'
            WRITE(61,*) 'GRAND CANONICAL ENSEMBLE FOR ALL'
            ICANONICAL=0
         ENDIF
C       
C---------------   RELEASING PARAMETER
C
      ELSEIF(VERB.EQ.'PREL') THEN
 203    FORMAT(A4,2X,A4,3X,2F7.2,F9.5)
 204    FORMAT(A4,3X,2F9.3,F9.5)
        READ(51,203) VERB,PARNAME,LLMRT,ULMRT,STPRT
        IPR=IFINDPAR(PARNAME)
        NAMRAT(IPR)=PARNAME
        LLMRAT(IPR)=LLMRT
        ULMRAT(IPR)=ULMRT
        STPRAT(IPR)=STPRT
        IFIXRAT(IPR)=1
        WRITE(61,*) 'RELEASING PARAMETER'
        WRITE(61,204) 
     1  NAMRAT(IPR),LLMRAT(IPR),ULMRAT(IPR),STPRAT(IPR)
        WRITE(*,*) 'RELEASING PARAMETER'
        WRITE(*,204) 
     1  NAMRAT(IPR),LLMRAT(IPR),ULMRAT(IPR),STPRAT(IPR)
C
C---------------   SETTING DATAPOINT
C
      ELSEIF(VERB.EQ.'DSET') THEN
 421     FORMAT(A4,2X,I5,2F10.5)
         READ(51,421) VERB,IPT,PARVAL,PARERR
         WRITE(*,*) 'SETTING DATAPOINT ',IPT,' CORRESPONDING TO '
     1,NAMDATA(IPT,1),'/',NAMDATA(IPT,2), ' TO ',PARVAL,'+/-',PARERR
         WRITE(61,*) 'SETTING DATAPOINT ',IPT,' CORRESPONDING TO '
     1,NAMDATA(IPT,1),'/',NAMDATA(IPT,2), ' TO ',PARVAL,'+/-',PARERR
         RATDATA(IPT)=PARVAL
         RATERR(IPT)=PARERR
C
C---------------   FIXING DATAPOINT
C
      ELSEIF(VERB.EQ.'DFIT') THEN
 422     FORMAT(A4,2X,2I5)
         READ(51,422) VERB,IPT,IFIT1
         IFIT(IPT)=IFIT1
         WRITE(*,*) 'SETTING IFIT FOR DATAPOINT ',IPT
     1,' CORRESPONDING TO ',NAMDATA(IPT,1),'/',NAMDATA(IPT,2)
     1,' TO ',IFIT1
         WRITE(61,*) 'SETTING IFIT FOR DATAPOINT ',IPT
     1,' CORRESPONDING TO ',NAMDATA(IPT,1),'/',NAMDATA(IPT,2)
     1,' TO ',IFIT1
      ELSEIF((VERB.EQ.'FOLD').OR.(VERB.EQ.'FLDP')) THEN
         READ(51,702) VERB,FILE1,FILE2,FOLDFILE
 702     FORMAT(A4,2X,A12,2X,A12,2X,A12)
         WRITE(*,*) 'FOLDING ',FILE1,' AND ',FILE2,' TO ',FOLDFILE
         WRITE(61,*) 'FOLDING ',FILE1,' AND ',FILE2,' TO ',FOLDFILE
         IF(VERB.EQ.'FLDP') THEN
            WRITE(*,*) '.prof EXTENSION USED'
            WRITE(61,*) '.prof EXTENSION USED'
            FILE1_PROF='gqgs1ydlm200.prof'
            FILE2_PROF='gqgs1ydlm200.prof'
            FILE1_PROF(1:12)=FILE1
            FILE2_PROF(1:12)=FILE2
            OPEN(31,FILE=FILE1_PROF,STATUS="OLD")
            OPEN(32,FILE=FILE2_PROF,STATUS="OLD")
         ELSE
            OPEN(31,FILE=FILE1,STATUS="OLD")
            OPEN(32,FILE=FILE2,STATUS="OLD")
         ENDIF
         OPEN(33,FILE=FOLDFILE,STATUS="UNKNOWN")
307      READ(31,*,END=703) X1,Y1
         READ(32,*,END=703) X1,Y2
         WRITE(33,*) Y1,Y2
         GO TO 307
703     WRITE(*,*) 'FOLDING COMPLETE'
         WRITE(61,*) 'FOLDING COMPLETE'
         CLOSE(31)
         CLOSE(32)
         CLOSE(33)
      ELSEIF((VERB.EQ.'3FLD').OR.(VERB.EQ.'3FLP')) THEN
         READ(51,802) VERB,FILE1,FILE2,FILE3,FOLDFILE
 802     FORMAT(A4,2X,A12,2X,A12,2X,A12,2X,A12)
         WRITE(*,*) 'FOLDING ',FILE1,' AND ',FILE2,' AND ',FILE3
     1   ,' TO ',FOLDFILE
         WRITE(61,*) 'FOLDING ',FILE1,' AND ',FILE2,' AND ',FILE3
     1   ,' TO ',FOLDFILE
         IF(VERB.EQ.'3FLP') THEN
            WRITE(*,*) '.prof EXTENSION USED'
            WRITE(61,*) '.prof EXTENSION USED'
            FILE1_PROF='gqgs1ydlm200.prof'
            FILE2_PROF='gqgs1ydlm200.prof'
            FILE1_PROF(1:12)=FILE1
            FILE2_PROF(1:12)=FILE2
            OPEN(31,FILE=FILE1_PROF,STATUS="OLD")
            OPEN(32,FILE=FILE2_PROF,STATUS="OLD")
            OPEN(33,FILE=FILE2_PROF,STATUS="OLD")
         ELSE
            OPEN(31,FILE=FILE1,STATUS="OLD")
            OPEN(32,FILE=FILE2,STATUS="OLD")
            OPEN(33,FILE=FILE3,STATUS="OLD")
         ENDIF
         OPEN(34,FILE=FOLDFILE,STATUS="UNKNOWN")
 807     READ(31,*,END=803) X1,Y1,Z1
         READ(32,*,END=803) X1,Y2,Z2
         READ(33,*,END=803) X1,Y2,Z3
         WRITE(34,*) Z1,Z2,Z3
c         write(*,*) x1,x2,y1,y2
         GO TO 807
 803     WRITE(*,*) '3D FOLDING COMPLETE'
         WRITE(61,*) '3D FOLDING COMPLETE'
         CLOSE(31)
         CLOSE(32)
         CLOSE(33)
         CLOSE(34)
      ELSEIF(VERB.EQ.'READ') THEN
         IF(ACTION.EQ.'THERM_INI') THEN
C------------------------------------  THERMO INPUT
 102        FORMAT(A4,2X,A9,2X,A11)
            READ(51,102) VERB,ACTION,THERMOFILE
            WRITE(*,*) 'READING THERMAL INPUT FROM ',THERMOFILE
            WRITE(61,*) 'READING THERMAL INPUT FROM ',THERMOFILE
            CALL READ_THERMO(THERMOFILE)
         ELSEIF(ACTION.EQ.'PARTICLES') THEN
C----------------------------------  PARTICLE INPUT
 103        FORMAT(A4,2X,A9,2X,A14,2X,A11)
            READ(51,103) VERB,ACTION,PARTFILE,DECFILE
            WRITE(*,*) 'READING PARTICLES FROM ',PARTFILE
     1,' DECAYS FROM ',DECFILE
            WRITE(61,*) 'READING PARTICLES FROM ',PARTFILE
     1,' DECAYS FROM ',DECFILE
            CALL READ_PARTICLES(PARTFILE,DECFILE)
         ELSEIF((ACTION.EQ.'RATIODATA').OR.(ACTION.EQ.'TOTALDATA')) THEN
C----------------------------------  EXPERIMENTAL DATA
 104        FORMAT(A4,2X,A9,2X,A14)
            READ(51,104) VERB,ACTION,TOTFILE
            WRITE(*,*) 'READING DATA FROM ',TOTFILE
            WRITE(61,*) 'READING DATA FROM ',TOTFILE
            CALL READ_RATIOS_DATA(TOTFILE)
        ELSEIF(ACTION.EQ.'FIT_PARAM') THEN
C----------------------------------  FIT PARAMETERS
 105        FORMAT(A4,2X,A9,2X,A13)
            READ(51,105) VERB,ACTION,SETFILE
            WRITE(*,*) 'READING FIT PARAMETERS FROM ',SETFILE
            WRITE(61,*) 'READING FIT PARAMETERS FROM ',SETFILE
            CALL READ_RATIO_SET(SETFILE)
        ELSE
            WRITE(*,*) 'UNKOWN READING ACTION ',ACTION
            CALL CRASHPROGRAM
        ENDIF
      ELSEIF(VERB.EQ.'CALC') THEN
         IF(ACTION.EQ.'RATIODATA') THEN
C------------------------------------  CALCULATE RATIOS FROM PARAMETERS
 106        FORMAT(A4,2X,A9,2X,A13)
            READ(51,106) VERB,ACTION,CALCFILE
            WRITE(61,*) 'CALCULATING OUTPUT, SAVING TO ',CALCFILE
            WRITE(*,*) 'CALCULATING OUTPUT, SAVING TO ',CALCFILE
            CALL WRITE_RATIOS(CALCFILE,-1D0)
         ELSEIF(ACTION.EQ.'REFITDATA') THEN
C-------CALCULATE RATIOS WITH GAUSSIAN ERRORS FOR REFITTING
 156        FORMAT(A4,2X,A9,2X,A13,F10.3)
            READ(51,156) VERB,ACTION,CALCFILE,ERROR
            WRITE(61,*) 'CALCULATING OUTPUT SAVING TO ',CALCFILE
            WRITE(*,*) 'CALCULATING OUTPUT, SAVING TO ',CALCFILE
            WRITE(61,*) 'ERROR OF ',ERROR,' INTRODUCED FOR REFIT'
            WRITE(*,*)  'ERROR OF ',ERROR,' INTRODUCED FOR REFIT'
            CALL WRITE_RATIOS(CALCFILE,ERROR)
        ELSEIF((ACTION.EQ.'FITRATIOS').OR.(ACTION.EQ.'FITNMINOS')) THEN
C----------------------------------  FIT THE EXPERIMENTAL RATIOS
 107        FORMAT(A4,2X,A9,2X,A13)
            IMINOS=0
            IF(ACTION.NE.'FITNMINOS') THEN
               WRITE(*,*) 'MINOS USED WHEN NECESSARY'
               IMINOS=1
               IPRFMINOS=1
            ELSE
              WRITE(*,*) 'MINOS NOT USED'
              IMINOS=0
              IPRFMINOS=0
            ENDIF
            READ(51,107) VERB,ACTION,FITFILE
            WRITE(61,*) 'FITTING DATA, OUTPUT TO ',FITFILE
            WRITE(*,*) 'FITTING DATA, OUTPUT TO ',FITFILE
c            WRITE(*,*) 'TEX FORMAT TO ',TEXFILE
c            TEXFILE='fit_nw20S.out.tex'
C            TEXFILE(1:13)=FITFILE
            OPEN(10,FILE=FITFILE,STATUS='UNKNOWN')
c            OPEN(27,FILE=TEXFILE,STATUS='UNKNOWN')
            CALL MIN_RATIOS(10,-1,IMINOS,27)
            CLOSE(10)
c            CLOSE(27)
        ELSEIF(ACTION.EQ.'PLOT_DATA') THEN
C----------------------------------  GRAPH THE FITTED RATIOS
 1070       FORMAT(A4,2X,A9,2X,A13,2X,A13,2X,A13)
            READ(51,1070) VERB,ACTION,GRAPH_FIT,GRAPH_CLC,GRAPH_EXP
            WRITE(*,*) 'PLOTTING DATA TO ',GRAPH_FIT,' ',GRAPH_CLC
     1,' ',GRAPH_EXP,' PARAMETERS: ',PARSPARE          
            WRITE(61,*) 'PLOTTING DATA TO  ',GRAPH_FIT,' ',GRAPH_CLC
     1,' ',GRAPH_EXP,' PARAMETERS: ',PARSPARE
            OPEN(11,FILE=GRAPH_FIT,STATUS='UNKNOWN')
            OPEN(12,FILE=GRAPH_CLC,STATUS='UNKNOWN')
            OPEN(13,FILE=GRAPH_EXP,STATUS='UNKNOWN')
            IPLOTRAT=1
            CALL FIXVALSRAT(PARSPARE)
            CALL FCNRAT(IFREERAT,GRAD,FMIN,PARSPARE,IFLAG,DBLE(0))
            IPLOTRAT=0    
            WRITE(11,*) ' '
            WRITE(12,*) ' '
            WRITE(13,*) ' '
            CLOSE(11)
            CLOSE(12)
            CLOSE(13)
c            write(61,*) 'plot done'
        ELSEIF((ACTION.EQ.'CHIPROFIL').OR.(ACTION.EQ.'SIGPROFIL')) THEN
C----------------------------------  DRAW CHI^2 PROFILE
c       wide format (better)
108        FORMAT(A4,2X,A9,2X,A12,2X,A4,2X,2F8.1,I5)
c       narrow format (website)
c 108        FORMAT(A4,2X,A9,2X,A12,2X,A4,2X,F6.1,F7.1,I5)
            CALL DATACHECK
            IDP=0
            READ(51,108) VERB,ACTION,CHIPROFFILE,PARNAME,LIM1,LIM2,IPTS
            WRITE(*,*) 'DRAWING CHI^2 PROFILE TO ',CHIPROFFILE
            WRITE(*,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(61,*) 'DRAWING CHI^2 PROFILE TO ',CHIPROFFILE
            WRITE(61,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            IF(ACTION.EQ.'CHIPROFIL') 
     1        CALL RATCPRF(CHIPROFFILE,PARNAME,LIM1,LIM2,IPTS,0,0,0)
            IF(ACTION.EQ.'SIGPROFIL') 
     1        CALL RATCPRF(CHIPROFFILE,PARNAME,LIM1,LIM2,IPTS,1,0,0)
        ELSEIF((ACTION.EQ.'DATPROFIL').OR.(ACTION.EQ.'FITPROFIL')
     1.OR.(ACTION.EQ.'SNSPROFIL')) THEN
C----------------------------------  DRAW DATAPOINT CHI^2 PROFILE
188         FORMAT(A4,2X,A9,2X,A12,2X,A4,2X,2F8.1,2I5)
            READ(51,188) 
     1      VERB,ACTION,CHIPROFFILE,PARNAME,LIM1,LIM2,IPTS,IDT
            WRITE(*,*) 'DRAWING CHI^2 PROFILE TO ',CHIPROFFILE,
     1      ' FOR DATAPOINT ',IDT,' CORRESPONDING TO ',
     1      NAMDATA(IDT,1),'/',NAMDATA(IDT,2)
            WRITE(*,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(61,*) 'DRAWING CHI^2 PROFILE TO ',CHIPROFFILE,
     1      ' FOR DATAPOINT ',IDT,' CORRESPONDING TO ',
     1      NAMDATA(IDT,1),'/',NAMDATA(IDT,2)
            WRITE(61,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            IF(ACTION.EQ.'DATPROFIL') THEN
               IDP=1
            ELSEIF(ACTION.EQ.'FITPROFIL') THEN
               IF(IFIT(IDT).LE.0) THEN
                  WRITE(*,*) 'POINT ',IDT,' IS NOT FITTED'
                  CALL CRASHPROGRAM
               ENDIF
               IDP=2
            ELSEIF(ACTION.EQ.'SNSPROFIL') THEN
               IDP=3
            ENDIF
            CALL RATCPRF(CHIPROFFILE,PARNAME,LIM1,LIM2,IPTS,0,IDT,IDP)
        ELSEIF((ACTION.EQ.'CHIDATPRF').OR.(ACTION.EQ.'SIGDATPRF')) THEN
C----------------------------------  DRAW CHI^2 DATA-POINT SENSITIVITY GRAPH
c       wide format (better)
708        FORMAT(A4,2X,A9,2X,A12,I5,2F5.1,I5)
            CALL DATACHECK
            IDP=0
            READ(51,708) 
     1VERB,ACTION,CHIPROFFILE,IDPT,LIM1,LIM2,IPTS
            WRITE(*,*) 'DRAWING CHI^2 DATA-POINT SENSITIVITY GRAPH TO '
     1      ,CHIPROFFILE
            WRITE(*,*) ' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(*,*) 'FOR POINT ',IDPT,' CORRESPONDING TO '
     1,NAMDATA(IDPT,1),'/',NAMDATA(IDPT,2)
            WRITE(61,*) 'DRAWING CHI^2 DATA-POINT SENSITIVITY GRAPH TO '
     1      ,CHIPROFFILE
            WRITE(61,*) ' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(61,*) 'FOR POINT ',IDPT,' CORRESPONDING TO '
     1,NAMDATA(IDPT,1),'/',NAMDATA(IDPT,2)
            IF(ACTION.EQ.'CHIDATPRF') 
     1       CALL DATCPRF(IDPT,CHIPROFFILE,LIM1,LIM2,IPTS,0,0,0)
            IF(ACTION.EQ.'SIGDATPRF') 
     1       CALL DATCPRF(IDPT,CHIPROFFILE,LIM1,LIM2,IPTS,1,0,0)
        ELSEIF((ACTION.EQ.'DATDATPRF').OR.(ACTION.EQ.'FITDATPRF')
     1.OR.(ACTION.EQ.'SNSDATPRF')) THEN
C----------------------------------  DRAW DATAPOINT CHI^2 DATA-POINT SENSITIVITY
  788       FORMAT(A4,2X,A9,2X,A12,I5,2F5.1,2I5)
            READ(51,788) 
     1      VERB,ACTION,CHIPROFFILE,IDPT,LIM1,LIM2,IPTS,IDT
            WRITE(*,*) 'DRAWING DATA-POINT SENSITIVITY CORRELATION TO '
     1,CHIPROFFILE,
     1      ' BETWEEN DATAPOINT ',IDT,' CORRESPONDING TO ',
     1      NAMDATA(IDT,1),'/',NAMDATA(IDT,2)
            WRITE(*,*) 'AND POINT ',IDPT,' CORRESPONDING TO '
     1,NAMDATA(IDPT,1),'/',NAMDATA(IDPT,2)
            WRITE(*,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(61,*) 'DRAWING DATA-POINT SENSITIVITY CORRELATION TO '
     1,CHIPROFFILE,
     1      ' BETWEEN DATAPOINT ',IDT,' CORRESPONDING TO ',
     1      NAMDATA(IDT,1),'/',NAMDATA(IDT,2)
            WRITE(61,*) 'AND POINT ',IDPT,' CORRESPONDING TO '
     1,NAMDATA(IDPT,1),'/',NAMDATA(IDPT,2)
            WRITE(61,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            IF(ACTION.EQ.'DATDATPRF') THEN
               IDP=1
            ELSEIF(ACTION.EQ.'FITDATPRF') THEN
               IDP=2
            ELSEIF(ACTION.EQ.'SNSDATPRF') THEN
               IDP=3
            ENDIF
         CALL DATCPRF(IDPT,CHIPROFFILE,LIM1,LIM2,IPTS,0,IDT,IDP) 
        ELSEIF(ACTION.EQ.'CHI2_CONT') THEN
C----------------------------------  DRAW CHI^2 CONTOUR
 109        FORMAT(A4,2X,A9,2X,A9,1X,F4.1,2X,A4,2X,A4)
            READ(51,109) VERB,ACTION,CONTFILE,CHIPREC,PARNAME1,PARNAME2
            WRITE(*,*) 'CHI^2 CONTOUR FOR ',PARNAME1,' ',PARNAME2
            WRITE(*,*) 'OUTPUT TO ',CONTFILE,' DEVIATION: ',CHIPREC
            WRITE(61,*) 'CHI^2 CONTOUR FOR ',PARNAME1,' ',PARNAME2
            WRITE(61,*) 'OUTPUT TO ',CONTFILE,' DEVIATION: ',CHIPREC
            CALL RATIOCONTOUR(CONTFILE,PARNAME1,PARNAME2,CHIPREC)
        ELSEIF(ACTION.EQ.'RATIOPLOT') THEN
C----------------------------------- PLOT 1D FUNCTION
 208        FORMAT(A4,2X,A9,2X,A12,2X,A4,2X,2F5.1,2I5)
            READ(51,208) 
     1      VERB,ACTION,RATPROFFILE,PARNAME,LIM1,LIM2,IPTS,IDAT
            WRITE(*,*) 'PLOTTING 1D FUNCTION TO ',RATPROFFILE
            WRITE(*,*) 'RATIO: ',NAMDATA(IDAT,1),' TO ',NAMDATA(IDAT,2)
            WRITE(*,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            WRITE(61,*) 'RATIO: ',NAMDATA(IDAT,1),' TO ',NAMDATA(IDAT,2)
            WRITE(61,*) 'SAVING 1D FUNCTION TO ',RATPROFFILE
            WRITE(61,*) 'PAR. ',PARNAME,' LIMS ',LIM1,LIM2,' PTS# ',IPTS
            CALL DATACHECK
            IPAR=IFINDPAR(PARNAME)
            CALL 
     1     PROF1D(RATPROFFILE,IDAT,IPAR,LIM1,LIM2,IPTS)
        ELSEIF(ACTION.EQ.'RATIOCONT') THEN
C----------------------------------  PLOT 2D FUNCTION
 209        FORMAT(A4,2X,A9,I5,A12,2X,A4,2X,F5.1,2X,F5.1,2X,I3
     1            ,2X,A4,2X,F5.1,2X,F5.1,2X,I3)
            READ(51,209) VERB,ACTION,IDAT,RATPROFFILE,PARNAME1
     1,LIM11,LIM12,IPT1,PARNAME2,LIM21,LIM22,IPT2
            WRITE(*,*) 'PLOTTING 2D FUNCTION FOR ',PARNAME1,' ',PARNAME2
            WRITE(*,*) 'RATIO: ',NAMDATA(IDAT,1),' TO ',NAMDATA(IDAT,2)
            WRITE(*,*) 'OUTPUT TO ',RATPROFFILE
            WRITE(*,*) 'LIMITS FOR PAR1 ',LIM11,LIM12,' POINTS: ',IPT1
            WRITE(*,*) 'LIMITS FOR PAR2 ',LIM21,LIM22,' POINTS: ',IPT2
            WRITE(61,*) 'PLOT 2D FUNCTION FOR ',PARNAME1,' ',PARNAME2
            WRITE(*,*) 'RATIO: ',NAMDATA(IDAT,1),' TO ',NAMDATA(IDAT,2)
            WRITE(61,*) 'OUTPUT TO ',RATPROFFILE
            WRITE(61,*) 'LIMITS FOR PAR1 ',LIM11,LIM12,' POINTS: ',IPT1
            WRITE(61,*) 'LIMITS FOR PAR2 ',LIM21,LIM22,' POINTS: ',IPT2
            CALL DATACHECK
            IPAR1=IFINDPAR(PARNAME1)
            IPAR2=IFINDPAR(PARNAME2)
            CALL
     1      PROF2D
     1(RATPROFFILE,IDAT,IPAR1,IPAR2,LIM11,LIM12,LIM21,LIM22,IPT1,IPT2)
        ELSEIF(ACTION.EQ.'SPHERICAL') THEN
 210        FORMAT(A4,2X,A9,2X,A7) 
            READ(51,210) VERB,ACTION,CHICONT
            IF(CHICONT.EQ.'CHICKEN') CALL EASTER
        ELSE
            WRITE(*,*) 'UNKOWN CALCULATING ACTION ',ACTION
            CALL CRASHPROGRAM
        ENDIF
      ELSE
         WRITE(*,*) 'UNKOWN VERB ',VERB
         CALL CRASHPROGRAM
      ENDIF
      GO TO 110
 111  CLOSE(51)
      WRITE(*,*) 'RUN TERMINATED SUCCESSFULLY'
      WRITE(61,*) 'RUN TERMINATED SUCCESSFULLY'
      CLOSE(61)
      END

      SUBROUTINE DATACHECK
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      TBEFORE=1D-1
      IF(PI.LT.0D0) THEN
         WRITE(*,*) 'NO THERMAL PARAMETERS FILE,USE thermo.data'
         WRITE(61,*) 'NO THERMAL PARAMETERS FILE,USE thermo.data'
         CALL READ_THERMO('thermo.data')
      ENDIF
      IF(IFIXRAT(1).LT.0) THEN
         WRITE(*,*) 'NO FIT PARAMETERS FILE,USE ratioset.data'
         WRITE(61,*) 'NO FIT PARAMETERS FILE,USE ratioset.data'
         CALL READ_RATIO_SET('ratioset.data')
      ENDIF
      IF((MHAD(1).LT.0D0).OR.(IDEC(1).LT.0)) THEN
       WRITE(*,*) 'NO PARTICLES FILE,USE particles.data, decays.data'
       WRITE(61,*) 'NO PARTICLES FILE,USE particles.data, decays.data'
       CALL READ_PARTICLES('particles.data','decays.data')
      ENDIF
      IF(IRATDAT.LT.0) THEN
        WRITE(*,*) 'NO DATA FILE SPECIFIED, USING totratios.data'
        WRITE(61,*) 'NO DATA FILE SPECIFIED, USING totratios.data'
        CALL READ_RATIOS_DATA('totratios.data')
      ENDIF
      RETURN
      END
c---------------------------------------------------------------------------------------
c----------  READER SUBROUTINE   (formerly reader.f)
c------------------------------------------------------------------------------------
C---------------------  READS THERMODYNAMICS PARAMETERS (T,V,ETC.) 
      SUBROUTINE READ_THERMO(THERMOFILE)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3

      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      CHARACTER*4 TAG
      CHARACTER*11 THERMOFILE
      ITHERM=1
      IGSGQ=0
      IF(THERMOFILE(8:11).NE.'HERE') THEN
        IUNIT=1
        OPEN(1,FILE=THERMOFILE,STATUS="OLD")
      ELSE
        IUNIT=51
      ENDIF
 114  FORMAT(A4,4X,F31.19)
 110  IF(IREADCOMMENT(IUNIT).GT.0) GO TO 111
      READ(IUNIT,114,END=111) TAG,VALUE
      WRITE(61,114) TAG,VALUE
      IF(ITHERM.LE.IPRT) THEN
         NAMRAT(ITHERM)=TAG
      ENDIF
      IF(TAG.NE.'accu') ITHERM=ITHERM+1
      CALL PARSET(TAG,VALUE)
      GO TO 110
 111  PI=DACOS(-1D0)
      HC  =0.1973269602D0
C      TWOPI=2D0*PI
C      PI_2=PI/2D0
      NORMFACT=4D0*PI/(2D0*PI*HC)**3
      ACX=1D0-AC
      CHEMFACT=1D0
      REALGAMC=1
      IF(THERMOFILE(8:11).NE.'HERE') CLOSE(1)
      DO 112 I=1,IPRT
         PARORIG(I)=-1D0
 112     PARRAT(I)=-1D0
      CALL FIXVALSRAT(PARRAT)
      CALL FIXVALSRAT(PARORIG)
      RETURN
      END

      SUBROUTINE PARSET(PARNAME,VALUE)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      CHARACTER*4 PARNAME
      IF(PARNAME.EQ.'temp') THEN
         T=VALUE
      ELSEIF(PARNAME.EQ.'lamq') THEN
         LAMQ=VALUE
      ELSEIF(PARNAME.EQ.'mu_b') THEN
         LAMQ=LAMQFUNC(T,VALUE)
         ILAMQMUQ=1
      ELSEIF(PARNAME.EQ.'lams') THEN
         LAMS=VALUE
      ELSEIF(PARNAME.EQ.'mu_s') THEN
         LAMS=LAMSFUNC(T,LAMQ,VALUE)
         ILAMSMUS=1
      ELSEIF(PARNAME.EQ.'lmi3') THEN
         LMI3=VALUE
      ELSEIF(PARNAME.EQ.'gam3') THEN
         GAM3=VALUE
      ELSEIF(PARNAME.EQ.'mui3') THEN
         LMI3=DEXP(VALUE/T)
         ILAM3MU3=0
      ELSEIF(PARNAME.EQ.'lamc') THEN
         LAMC=VALUE
      ELSEIF(PARNAME.EQ.'mu_c') THEN
         LAMC=DEXP(VALUE/T)
         ILAMCMUC=0
      ELSEIF(PARNAME.EQ.'gamq') THEN
         GAMQ=VALUE
      ELSEIF(PARNAME.EQ.'gams') THEN
         GAMS=VALUE
      ELSEIF(PARNAME.EQ.'gsgq') THEN
         IGSGQ=1
         GAMS=GAMQ*VALUE
      ELSEIF(PARNAME.EQ.'Ncbc') THEN
         NCBC=VALUE
      ELSEIF(PARNAME.EQ.'tc2t') THEN
         TC2T=VALUE
      ELSEIF(PARNAME.EQ.'norm') THEN
         NORM=VALUE
      ELSEIF(PARNAME.EQ.'dvol') THEN
         DVOL=VALUE
      ELSEIF(PARNAME.EQ.'accu') THEN
         AC=VALUE
         IF(AC.LE.0D0) THEN
            WRITE(*,*) 'AC<0'
            CALL CRASHPROGRAM
         ENDIF
      ELSE
         WRITE(*,*) 'PARSET: UNKNOWN THERMAL PARAMETER ',PARNAME
         CALL CRASHPROGRAM
      ENDIF
      RETURN
      END

C------------------------ READS FILES WITH PARTICLE DATA ------------------

      SUBROUTINE READ_PARTICLES(PARTFILE,DECFILE)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      EXTERNAL RPFS  !! read particles from SHARE to charm module
!      EXTERNAL PRTC
      CHARACTER*14 PARTFILE
      CHARACTER*11 DECFILE
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
      CHARACTER*9 READNAME,READNAME1,READNAME2,READNAME3
C--------------    MASSES, WIDTHS, SPINS -----------------
C   NAM(I) NAME (9 CHARACTERS)
C   MHAD(I) MASS
C   WIDTH(I) WIDTH
C   XDEG(I) 2*SPIN+1
C   IBS(I) BOSON/FERMION
      IHADS=0
      DO 321 I=1,IHDMX
         NAM(I)='         '
         MHAD(I)=0D0
         XU(I)=0D0
         XAU(I)=0D0
         XD(I)=0D0
         XAD(I)=0D0
         XS(I)=0D0
         XAS(I)=0D0
         XCH(I)=0D0
         XACH(I)=0D0
         XB(I)=0D0
         XAB(I)=0D0
         IMIX(I)=0
 321  CONTINUE
      NAM(1)='nopart000'
      IF(PARTFILE(11:14).NE.'HERE') THEN
         IUNIT=1
         OPEN(1,FILE=PARTFILE,STATUS="OLD")
      ELSE
         IUNIT=51
      ENDIF
      WRITE(61,*) 'READING PARTICLES FROM FILE ',PARTFILE
      I=1
 110  IF(IREADCOMMENT(IUNIT).GT.0) GO TO 111
      READ(IUNIT,101,END=111) NAM(I),MHAD(I),WIDTH(I)
     1 ,SPIN,XISPN,XISPN3,XU(I),XD(I),XS(I)
     1 ,XAU(I),XAD(I),XAS(I),XCH(I),XACH(I),XB(I),XAB(I),IPN(I)
C      NAM(I),MHAD(I),WIDTH(I)
C     1,SPIN,XISPN,XISPN3,XU(I),XD(I),XS(I)
C     1,XAU(I),XAD(I),XAS(I),XCH(I),XACH(I)
C     1,XB,XAB,IPN(I)
      WRITE(61,101) NAM(I),MHAD(I),WIDTH(I)
     1,SPIN,XISPN,XISPN3,XU(I),XD(I),XS(I)
     1,XAU(I),XAD(I),XAS(I),XCH(I),XACH(I),XB(I),XAB(I),IPN(I)
      IF(IPN(I).EQ.0) THEN
         WRITE(*,*) 'ERROR: PARTICLE LINE INCOMPLETE FOR ',NAM(I)
         STOP
      ENDIF
101   FORMAT(A9,2(4X,F10.7),2X,3(F5.1,4X),10(F6.3,2X),I11)
      INETQ(I)=INT(XU(I)+XD(I)-XAU(I)-XAD(I))
      XTOT=XU(I)+XD(I)+XS(I)+XCH(I)
      XTOT2=XAU(I)+XAD(I)+XAS(I)+XACH(I)
      XINTTOT=DBLE(IAPPROX(XTOT))
      X2INTTOT=DBLE(IAPPROX(XTOT2))
      IF(XINTTOT.NE.XTOT) THEN
         XU(I)=XINTTOT*XU(I)/XTOT
         XD(I)=XINTTOT*XD(I)/XTOT
         XS(I)=XINTTOT*XS(I)/XTOT
         XCH(I)=XINTTOT*XCH(I)/XTOT
      ENDIF
      IF(X2INTTOT.NE.XTOT2) THEN
         XAU(I)=X2INTTOT*XAU(I)/XTOT2
         XAD(I)=X2INTTOT*XAD(I)/XTOT2
         XAS(I)=X2INTTOT*XAS(I)/XTOT2
         XACH(I)=X2INTTOT*XACH(I)/XTOT2
      ENDIF
      IMIX(I)=0
      IF(INTTEST(XU(I)).GT.0) THEN
         IMIX(I)=1
         IF(INTTEST(XS(I)).GT.0) IMIX(I)=2
          IF((XU(I)-XAU(I).NE.0D0)
     1   .OR.(XD(I)-XAD(I).NE.0D0).OR.(XS(I)-XAS(I).NE.0D0)) THEN
             WRITE(*,*) 'MIXING IN NON-SU(3) NEUTRAL PARTICLE ',NAM(I)
             WRITE(*,*) 'U-AU=',XU(I)-XU(I),' D-AD=',XD(I)-XAD(I)
     1       ,' S-AS=',XS(I)-XAS(I)
             CALL CRASHPROGRAM
          ENDIF
      ENDIF
      QNUM=XU(I)+XD(I)+XS(I)+XCH(I)-XAU(I)-XAD(I)-XAS(I)-XACH(I)
      IBAR(I)=INT(QNUM)/3
      IF(INTTEST(QNUM).NE.0) THEN
         WRITE(*,*) 'FRACTIONAL BARYON # ',NAM(I),' '
     1   ,IBAR(I),QNUM,XU(I),XD(I),XS(I),XAU(I),XAD(I),XAS(I)
         CALL CRASHPROGRAM
      ENDIF
C      IDEG(I)=INT(2D0*SPIN)+1
      XDEG(I)=2D0*SPIN+1D0
      IF(SPIN.EQ.DBLE(2*INT(SPIN)/2)) IBS(I)=1
      IF(SPIN.NE.DBLE(2*INT(SPIN)/2)) IBS(I)=-1

      I2ISPIN(I)=INT(XISPN*2D0)
      I2I3SPIN(I)=INT(XISPN3*2D0)
      CHARGE
     1=(2D0*(XU(I)-XAU(I)+XCH(I)-XACH(I))-XD(I)+XAD(I)-XS(I)+XAS(I))/3D0
C      WRITE(*,*) 'CHARGE ',NAM(I),' ',CHARGE    !!!! CHARGE DEBUG
      ICHARGE(I)=INT(CHARGE)
C--- check consistency for standard name ends and corresponding electric charge of a particle.
      IF(((NAM(I)(7:9).EQ.'plp').AND.(ICHARGE(I).NE.2)).OR.
     1 ((NAM(I)(7:9).EQ.'ppb').AND.(ICHARGE(I).NE.-2)).OR.
     1 ((NAM(I)(7:9).EQ.'plu').AND.(ICHARGE(I).NE.1)).OR.
     1 ((NAM(I)(7:9).EQ.'plb').AND.(ICHARGE(I).NE.-1)).OR.
     1 ((NAM(I)(7:9).EQ.'zer').AND.(ICHARGE(I).NE.0)).OR.
     1 ((NAM(I)(7:9).EQ.'zrb').AND.(ICHARGE(I).NE.0)).OR.
     1 ((NAM(I)(7:9).EQ.'min').AND.(ICHARGE(I).NE.-1)).OR.
     1 ((NAM(I)(7:9).EQ.'mnb').AND.(ICHARGE(I).NE.1))) THEN
         IF((NAM(I)(1:2).EQ.'el').OR.(NAM(I)(1:2).EQ.'mu')  !! skipping leptons. no quarks, but charge nevertheless
     1  .OR.(NAM(I)(1:3).EQ.'tau').OR.(NAM(I)(1:2).EQ.'nu')) GOTO 1997
         WRITE(*,*) 'ERROR: ',NAM(I),'  CHARGE=',ICHARGE(I)
         WRITE(*,*) 'Q(udsc) ',XU(I),XD(I),XS(I),XCH(I)
         WRITE(*,*) 'ANTI-Q  ',XAU(I),XAD(I),XAS(I),XACH(I)
1997     CONTINUE
      ENDIF
C--end consistency check
      IF(DBLE(ICHARGE(I)).NE.CHARGE) THEN
         WRITE(*,*) 'FRACTIONAL CHARGE ',NAM(I),CHARGE
         CALL CRASHPROGRAM
      ENDIF
c      if(itotq.gt.3) write(*,*) 'pnt ',itotq,u_ubar,d_dbar,s_sbar,charge
      I=I+1
      GO TO 110
 111  IF(PARTFILE(11:14).NE.'HERE') CLOSE(1)
      IHADS=I-1
      CALL SORT_MASSES
      WRITE(*,*) 'N OF HADRONS: ',IHADS,' ',NAM(IHADS),' ',NAM(1)
      WRITE(61,*) 'N OF HADRONS: ',IHADS,' ',NAM(IHADS),' ',NAM(1)
      WRITE(61,*) 'CHECKING NAME SYNTAX, NO EFFECT ON FURTHER RUNNING'
      DO 699 I=1,IHADS
 699     CALL NAMECHECK(I)
      WRITE(61,*) 'ALL NAMES CHECKED'
c-----------------------------------------
C----------------------- DECAYS --------------------------
c------------------------initializing arrays-------------
      DO 199 I=1,IHDMX
         DO 198 IJ=1,IRSMAX
            IBOD(I,IJ)=0
         BR(I,IJ,2)=0D0
         IPI0(I,IJ)=1
 198     BR(I,IJ,1)=0D0
 199  IDEC(I)=0
      I_READ_ERR=0
      IF(DECFILE(8:11).NE.'HERE') THEN
         IUNIT=1
         OPEN(1,FILE=DECFILE,STATUS="OLD")
      ELSE
         IUNIT=51
      ENDIF
      WRITE(61,*) 'READING DECAYS FROM FILE ',DECFILE
C----------------------- 2 BODY DECAYS --------------------------
C   IDEC(I)  N. OF POSSIBLE DECAYS OF PARTICLE I
C   IBOD(I,J) N. OF DAUGHTER PARTICLES IN JTH DECAY  OF PARTICLE I (2 OR 3)
C   BR(I,J)         BRANCHING RATIO    OF  "   "     "    "      "
C   IPROD(I,J,K)    IDENTITY OF KTH PARTICLE PRODUCED IN JTH DECAY OF PARTICLE I
C----------------------------------------------------------
 134  IF(IREADCOMMENT(IUNIT).GT.0) GO TO 117
 114  READ(IUNIT,103,END=117,ERR=122) 
     1READNAME,READNAME1,READNAME2,BR_N,ICG
 103  FORMAT(A9,3X,A9,3X,A9,F9.4,I4)
      IH=IMATCHNAME(1,READNAME)
      IF(IH.EQ.0) GO TO 114
      IH1=IMATCHNAME(1,READNAME1)
      IH2=IMATCHNAME(1,READNAME2)
C--------------------------------------------------
      IWKDEC=0
      IF((READNAME1(1:3).EQ.'gam').OR.(READNAME2(1:3).EQ.'gam')) THEN
         WRITE(61,*) READNAME,'->',READNAME1,' ',READNAME2
     1,' ASSUMED ELECTROMAGNETIC'
         IWKDEC=1
      ENDIF
      IF(ICHARGE(IH1)+ICHARGE(IH2).NE.ICHARGE(IH)) THEN
        WRITE(*,*) 'CHARGE NOT CONSERVED ',NAM(IH),' ',ICHARGE(IH),' '
     1 ,NAM(IH1),' ',ICHARGE(IH1),' ',NAM(IH2),' ',ICHARGE(IH2)
        CALL CRASHPROGRAM
      ENDIF
      IF(IBAR(IH1)+IBAR(IH2).NE.IBAR(IH)) THEN
       WRITE(*,*) 'BARYON N NOT CONSERVED ',NAM(IH),' ',IBAR(IH),' '
     1 ,NAM(IH1),' ',IBAR(IH1),' ',NAM(IH2),' ',IBAR(IH2)
       CALL CRASHPROGRAM
      ENDIF
      IF(NETSTRANGE(IH1)+NETSTRANGE(IH2).NE. NETSTRANGE(IH)) THEN
       WRITE(61,*) 'STRANGENESS NOT CONSERVED '
     1,NAM(IH),' '
     1,NETSTRANGE(IH),' ',NAM(IH1),' ',NETSTRANGE(IH1)
     1,' ',NAM(IH2),' ',NETSTRANGE(IH2)
       IWKDEC=2
      ENDIF
      IF(XCH(IH1)-XACH(IH1)+XCH(IH2)-XACH(IH2).NE.XCH(IH)-XACH(IH)) THEN
       WRITE(61,*) 'CHARM NOT CONSERVED '
     1,NAM(IH),' ',NAM(IH1),' ',NAM(IH2)
       IWKDEC=2
      ENDIF
      IF(I2I3SPIN(IH1)+I2I3SPIN(IH2).NE.I2I3SPIN(IH)) THEN
       WRITE(61,*) 'I3 NOT CONSERVED ',NAM(IH),' ',I2I3SPIN(IH),' '
     1 ,NAM(IH1),' ',I2I3SPIN(IH1),' ',NAM(IH2),' ',I2I3SPIN(IH2)
       IWKDEC=2
      ENDIF
      IF(MHAD(IH1)+MHAD(IH2).GT.MHAD(IH)) THEN
         WRITE(61,*) 'PRODUCTS HEAVIER THAN RESONANCE'
         WRITE(61,*) NAM(IH),' ',NAM(IH1),' ',NAM(IH2)
          IF(WIDTH(IH).LE.0D0) THEN
            WRITE(61,*) 'AND WIDTH<=0, IGNORED ' 
c      CALL CRASHPROGRAM        
c            GO TO 134
         ENDIF
      ENDIF
C----------------------------------------------
      IDEC(IH)=IDEC(IH)+1
      IBOD(IH,IDEC(IH))=2
      IWEAK(IH,IDEC(IH))=IWKDEC
      IPROD(IH,IDEC(IH),1)=IH1
      IPROD(IH,IDEC(IH),2)=IH2
      IPROD(IH,IDEC(IH),3)=0
      IF(READNAME1.EQ.READNAME2) THEN
         IPI0(IH,IDEC(IH))=IPI0(IH,IDEC(IH))+1
c         WRITE(*,*) 'EQUALITY ',READNAME1,' ',READNAME2
c     1,' ',IPI0(IH,IDEC(IH))
      ENDIF
      IF(BR_N.LE.0D0) THEN
         WRITE(61,*) 'BRANCHING RATIO=0 FOR ',NAM(IH),'->',NAM(IH1)
     1,' ',NAM(IH2)
         WRITE(61,*) 'PUTTING=0.001'
         BR_N=DBLE(0.001)
      ENDIF
      BR(IH,IDEC(IH),1)=BR_N
C----------------------------2 BODY CLEBSH-GORDAN----------------------------
      IF(ICG.GT.0) THEN
         IF(NETSTRANGE(IH1)+NETSTRANGE(IH2).NE.NETSTRANGE(IH)) THEN
            WRITE(*,*) 'C-G IN WEAK 2B DECAY ',NAM(IH),' ',NAM(IH1)
     1,' ',NAM(IH2)
            CALL CRASHPROGRAM
         ENDIF
         J1=DBLE(0.5)*DBLE(I2ISPIN(IH1))
         J2=DBLE(0.5)*DBLE(I2ISPIN(IH2))
         J=DBLE(0.5)*DBLE(I2ISPIN(IH))
         M1=DBLE(0.5)*DBLE(I2I3SPIN(IH1))
         M2=DBLE(0.5)*DBLE(I2I3SPIN(IH2))
         M=DBLE(0.5)*DBLE(I2I3SPIN(IH))
         C_G=DCLEBG(J1,J2,J,M1,M2,M)**2 
         IF(IEXCH(IH1,IH2).GT.0) C_G=C_G+DCLEBG(J2,J1,J,M2,M1,M)**2 
         IF(C_G.LE.0D0) THEN
            WRITE(*,*) '2B CLEBSH=0 '
     1      ,NAM(IH),' ',NAM(IH1),' ',NAM(IH2),J1,M1,J2,M2,J,M,C_G
             CALL CRASHPROGRAM
         ENDIF
         BR(IH,IDEC(IH),1)=BR(IH,IDEC(IH),1)*C_G
      ENDIF
      WRITE(61,103) 
     1READNAME,READNAME1,READNAME2,BR(IH,IDEC(IH),1),ICG
      GO TO 134
C----------------------- 3 BODY DECAYS --------------------------
 136  IF(IREADCOMMENT(IUNIT).GT.0) GO TO 117
 116  READ(IUNIT,104,END=117,ERR=121) 
     1 READNAME,READNAME1,READNAME2,READNAME3,BR_N,ICG
c      WRITE(*,104) 
c     1 READNAME,READNAME1,READNAME2,READNAME3,BR_N,ICG
      WRITE(61,104) 
     1 READNAME,READNAME1,READNAME2,READNAME3,BR_N,ICG
 104  FORMAT(A9,3X,A9,3X,A9,3X,A9,F9.4,I4)
      IF(IMATCHNAME(0,READNAME3).LT.0) GO TO 121
C         CALL CCOPYL (READNAME3,THREEBCHECK,1)
C         CALL CHTOI(THREEBCHECK,IT,121)
C         write(*,*) 'chtoi ',THREEBCHECK
C         IF((IT.EQ.46).OR.((IT.GE.48).AND.(IT.LE.57))) THEN
C            GO TO 121
C         ELSE
C            IDUMB=IMATCHNAME(1,READNAME3)
C         ENDIF
c      ENDIF
      IH=IMATCHNAME(1,READNAME)
      IDEC(IH)=IDEC(IH)+1
      IBOD(IH,IDEC(IH))=3
      IF(IH.EQ.0) GO TO 116
      IH1=IMATCHNAME(1,READNAME1)
      IH2=IMATCHNAME(1,READNAME2)
      IH3=IMATCHNAME(1,READNAME3)
C--------------------------------------------------
      IF((ICHARGE(IH1)+ICHARGE(IH2)+ICHARGE(IH3).NE.ICHARGE(IH))
     1.OR.(IBAR(IH1)+IBAR(IH2)+IBAR(IH3).NE.IBAR(IH)))
     1 THEN
         WRITE(*,*) 'SOMETHING NOT CONSERVED IN THIS DECAY'
         WRITE(*,*) 'FOLLOWS: CHARGE, BARYON N.'
         WRITE(*,*) 
     1   NAM(IH),ICHARGE(IH),IBAR(IH)
         WRITE(*,*) '---->'
         WRITE(*,*) NAM(IH1),ICHARGE(IH1),IBAR(IH1)
         WRITE(*,*) NAM(IH2),ICHARGE(IH2),IBAR(IH2)
         WRITE(*,*) NAM(IH3),ICHARGE(IH3),IBAR(IH3)
         CALL CRASHPROGRAM
      ENDIF
      IF((NETSTRANGE(IH1)+NETSTRANGE(IH2)+NETSTRANGE(IH3).NE
     1.NETSTRANGE(IH)).OR.(I2I3SPIN(IH1)+I2I3SPIN(IH2)+I2I3SPIN(IH3)
     1.NE.I2I3SPIN(IH))) THEN
         WRITE(61,*) 'DECAY ASSUMED WEAK, I3, STRANGENESS BROKEN'
         WRITE(61,*) 'FOLLOWS: STRANGENESS,I3   '
         WRITE(61,*) 
     1   NAM(IH),ICHARGE(IH),NETSTRANGE(IH),IBAR(IH),I2I3SPIN(IH)
         WRITE(61,*) '---->'
         WRITE(61,*) NAM(IH1),NETSTRANGE(IH1),I2I3SPIN(IH1)
         WRITE(61,*) NAM(IH2),NETSTRANGE(IH2),I2I3SPIN(IH2)
         WRITE(61,*) NAM(IH3),NETSTRANGE(IH3),I2I3SPIN(IH3)
         IWEAK(IH,IDEC(IH))=2
      ENDIF
      IF((READNAME1(1:3).EQ.'gam').OR.(READNAME2(1:3).EQ.'gam')
     1.OR.(READNAME3(1:3).EQ.'gam')) THEN
         WRITE(61,*) READNAME,'->',READNAME1,' ',READNAME2
     1,' ',READNAME3,' ASSUMED ELECTROMAGNETIC'
         IWEAK(IH,IDEC(IH))=1
      ENDIF
      IF(MHAD(IH1)+MHAD(IH2)+MHAD(IH3).GT.MHAD(IH)) THEN
         WRITE(61,*) 'PRODUCTS HEAVIER THAN RESONANCE'
         WRITE(61,*) NAM(IH),' ',NAM(IH1),' ',NAM(IH2),' ',MHAD(IH3)
         IF(WIDTH(IH).EQ.0D0) THEN
            WRITE(61,*) 'AND WIDTH<=0, PARTICLE IGNORED'         
C            CALL CRASHPROGRAM
             GO TO 134
         ENDIF
      ENDIF
C----------------------------------------------
C      IF((NAM(IH).EQ.'Ka0492zrb').OR.(NAM(IH).EQ.'Ka0492zer'))
c      WRITE(*,*) 'blaa ',NAM(IH),' ',IDEC(IH),IWEAK(IH,IDEC(IH))
      IPROD(IH,IDEC(IH),1)=IH1
      IPROD(IH,IDEC(IH),2)=IH2
      IPROD(IH,IDEC(IH),3)=IH3
      IF(READNAME1.EQ.READNAME2) IPI0(IH,IDEC(IH))=IPI0(IH,IDEC(IH))+1
      IF(READNAME2.EQ.READNAME3) THEN
        IPI0(IH,IDEC(IH))=IPI0(IH,IDEC(IH))+1
      ELSEIF(READNAME3.EQ.READNAME1) THEN
        IPI0(IH,IDEC(IH))=IPI0(IH,IDEC(IH))+1
      ENDIF
      IF(IPI0(IH,IDEC(IH)).GT.1) THEN
c         WRITE(*,*) 'EQUALITY '
c     1,READNAME,' ',READNAME1,' ',READNAME2,' '
c     1,READNAME3,' ',IPI0(IH,IDEC(IH))
      ENDIF
      IF(BR_N.LE.0D0) THEN
         WRITE(61,*) 'BRANCHING RATIO=0 FOR ',NAM(IH),'->',NAM(IH1)
     1,' ',NAM(IH2),' ',NAM(IH3)
         WRITE(61,*) 'PUTTING=0.001'
         BR_N=DBLE(0.001)
      ENDIF
      BR(IH,IDEC(IH),1)=BR_N
C-----------------------3 BODY CLEBSH GORDAN---------------------

      IF(ICG.GT.0) THEN
         IF(NETSTRANGE(IH1)+NETSTRANGE(IH2)+NETSTRANGE(IH3)
     1.NE.NETSTRANGE(IH)) THEN
            WRITE(*,*) 'C-G IN WEAK 3B DECAY ',NAM(IH),' ',NAM(IH1)
     1,' ',NAM(IH2),' ',NAM(IH3)
            CALL CRASHPROGRAM
         ENDIF
         CG3=CLEBG3AV(IH,IH1,IH2,IH3)
         IF((BR(IH,IDEC(IH),1).LE.0D0).OR.(CG3.LE.0D0)) THEN
            WRITE(61,*) '3B CLEBSH=0 '
     1      ,NAM(IH),' ',NAM(IH1),' ',NAM(IH2),' ',NAM(IH3)     
C            CALL CRASHPROGRAM
         ENDIF
         BR(IH,IDEC(IH),1)=BR(IH,IDEC(IH),1)*CG3  
c         WRITE(*,*) '3B CG ',
c     1READNAME,' ',READNAME1,' ',READNAME2,' ',READNAME3,CG3
      ENDIF
      GO TO 136
c------------------------ SWITCHING 2 AND 3 BODY DECAYS
 121  BACKSPACE IUNIT
      I_READ_ERR=I_READ_ERR+1
      IF(I_READ_ERR.GT.10000) THEN
         WRITE(*,*) 'ERROR IN DECAYS FILE'
       WRITE(*,*) 'LAST READ ',NAM(IH),' ',NAM(IH1),' ',NAM(IH2)
         CALL CRASHPROGRAM
      ENDIF
      GO TO 114
 122  BACKSPACE IUNIT
      I_READ_ERR=I_READ_ERR+1
      GO TO 116
C-------------------------------------------------------      
 117  IF(DECFILE(8:11).NE.'HERE') CLOSE(1)
      CALL BRANCH_CHECK
      DO 191 I=1,IHADS
         IF((WIDTH(I).GT.0D0).AND.(IDEC(I).EQ.0)) THEN
           WRITE(61,*) 'WIDTH!=0 BUT NO DECAYS FOR ',NAM(I)
c           CALL CRASHPROGRAM      
         ENDIF
 191  CONTINUE
      WRITE(*,*) 'PARTICLES AND DECAYS READ'
!!      WRITE(*,*) 'CHARM : Transfering particle data to CHARM module...'
      CALL RPFS(IHADS)
!!      WRITE(*,*) 'CHARM : Done... '
      RETURN
      END



C----------------------- OUTPUTS PARTICLE NUMBER GIVEN THE NAME -------------

      FUNCTION IMATCHNAME(ICRASH,PARTNAME)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      CHARACTER*9 PARTNAME
      IMATCHNAME=-1
      IF(PARTNAME.EQ.'         ') IMATCHNAME=0
      DO 189 I=1,IHADS
      IF(PARTNAME.EQ.NAM(I)) THEN
       IF(IMATCHNAME.LT.0) THEN  
        IMATCHNAME=I
       ELSE
        WRITE(*,*) 'MORE THAN ONE PARTICLE IN LIST ',PARTNAME
        CALL CRASHPROGRAM
       ENDIF
      ENDIF
 189  CONTINUE
      IF(IMATCHNAME.LT.0) THEN
           IF((PARTNAME(7:9).EQ.'sht').OR.(PARTNAME(7:9).EQ.'lng')) THEN
              IMATCHNAME=1000
           ELSE
              IF(ICRASH.GT.0) THEN
                WRITE(*,*) 'PARTICLE ',PARTNAME,' NOT MATCHED '
                CALL CRASHPROGRAM
              ENDIF
           ENDIF
      ENDIF
      RETURN
      END

      FUNCTION IMATCHPART(I1,PARTNAME)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)

      CHARACTER*9 PARTNAME,XNAM1,XNAM2,ZER,ZRB
      CHARACTER*3 SHORT
      IF((I1.LT.1).OR.(I1.GT.2)) THEN
         WRITE(*,*) 'ILLEGAL I1 ',I1
         CALL CRASHPROGRAM
      ENDIF
      IMATCHPART=IMATCHNAME(0,PARTNAME)
      IF(IMATCHPART.GT.0) THEN
         IF(I1.GT.1) IMATCHPART=-13
      ELSE   
       SHORT=PARTNAME(7:9)
       XNAM1=PARTNAME
       XNAM2=PARTNAME
       IF((SHORT.EQ.'sht').OR.(SHORT.EQ.'tot').OR.(SHORT.EQ.'lng')) THEN
           ZER='      zer'
           ZRB='      zrb'
       ELSEIF((SHORT.EQ.'plt').OR.(SHORT.EQ.'pbn')) THEN
           ZER='      plu'
           ZRB='      plb'
       ELSEIF((SHORT.EQ.'mnt').or.(SHORT.EQ.'mnn')) THEN
           ZER='      min'
           ZRB='      mnb'
       ELSEIF((SHORT.EQ.'plm').OR.(SHORT.EQ.'pln'))  THEN
           ZER='      plu'
           ZRB='      min'          
       ELSEIF(SHORT.EQ.'pmb') THEN
           ZER='      plb'
           ZRB='      mnb'   
       ELSE
          WRITE(*,*) 'WRONG VALUE OF PARTICLE ENDING: ',SHORT
          CALL CRASHPROGRAM
       ENDIF
       CALL CCOPYL(XNAM1,ZER,6)
       CALL CCOPYL(XNAM2,ZRB,6)
       IF(I1.EQ.1) IMATCHPART=IMATCHNAME(1,ZER)
       IF(I1.EQ.2) IMATCHPART=IMATCHNAME(1,ZRB)
      ENDIF
      RETURN
      END


C---------- GIVES PARTICLE'S TOTAL BRANCHING RATIO (SHOULD BE 1) -------------

      SUBROUTINE BRANCH_CHECK
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
       BRT=1D0
      DO 107 I=1,IHDMX
       BRT=1D0
       IF((I.LT.IHADS-1).AND.(IDEC(I).GT.0)) THEN
         BRT=BRTOT(NAM(I))
         IF((BRT.NE.0D0).AND.(BRT.NE.1D0)) THEN            
            IF(DABS(BRT-1D0).GT.DBLE(0.001)) 
     1WRITE(61,*) 'WARNING: PARTICLE ',NAM(I),' BR NE 1: ',BRT
     1,' RENORMALIZED IN PROGRAM'
         ENDIF
       ENDIF
       DO 108 ID=1,IRSMAX
c           write(*,*) 'brtot1 ',NAM(I),I,ID,IHADS-1,BRT
           BR(I,ID,1)=BR(I,ID,1)/BRT
           BR(I,ID,2)=BR(I,ID,1)**2
           DO 391 I3=1,IRATMX2
             DO 392 I4=1,3
               BRFN(I,ID,I3,I4,1)=BR(I,ID,1)
               BRFN(I,ID,I3,I4,2)=BR(I,ID,2)
 392         CONTINUE
c             BRFN(I,ID,I3,4,1)=1.
c             BRFN(I,ID,I3,4,2)=1.
             BRFN(I,ID,I3,4,1)=0.2D0
             BRFN(I,ID,I3,4,2)=0.2D0
 391         CONTINUE
 108   CONTINUE
 107  CONTINUE
      RETURN
      END

      FUNCTION BRTOT(PARTNAME)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
      CHARACTER*9 PARTNAME
      IH=IMATCHNAME(1,PARTNAME)
      BRTOT=0D0
      DO 189 I=1,IRSMAX
 189    BRTOT=BRTOT+BR(IH,I,1)
      RETURN
      END

C----------------------- CLEBSH-GORDAN UTILITIES ---------------

      FUNCTION CLEBG3AV(IH,IH1,IH2,IH3)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      CLEBG3AV=0D0
      TERM1=0D0
      TERM2=0D0
      TERM3=0D0
      AV1=0D0
      AV2=0D0
      AV3=0D0
c      IEX=IEXCH(IH1,IH2)+IEXCH(IH2,IH3)+IEXCH(IH1,IH3)
      TERM1=TERM1+CLEBG3TRM(IH,IH1,IH2,IH3,AV1)
      TERM2=TERM2+CLEBG3TRM(IH,IH2,IH3,IH1,AV2)
      TERM3=TERM3+CLEBG3TRM(IH,IH3,IH1,IH2,AV3)
      CLEBG3AV=(TERM1/AV1+TERM2/AV2+TERM3/AV3)/3D0
c      write(*,*) 'average is ',nam(ih),' ',nam(ih1),' ',nam(ih2),' '
c     1,nam(ih3),' ',clebg3av,IEX
      RETURN
      END

      FUNCTION CLEBG3TRM(IH,IH1,IH2,IH3,AV)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      J =DBLE(0.5)*DBLE(I2ISPIN(IH))
      J1=DBLE(0.5)*DBLE(I2ISPIN(IH1))
      J2=DBLE(0.5)*DBLE(I2ISPIN(IH2))
      J3=DBLE(0.5)*DBLE(I2ISPIN(IH3))
      M= DBLE(0.5)*DBLE(I2I3SPIN(IH))
      M1=DBLE(0.5)*DBLE(I2I3SPIN(IH1))
      M2=DBLE(0.5)*DBLE(I2I3SPIN(IH2))
      M3=DBLE(0.5)*DBLE(I2I3SPIN(IH3))
      CLEBG3TRM=0D0
      AV=0D0
      M12=M1+M2
      IF(M12+M3.NE.M) THEN
         WRITE(61,*) 'MS DO NOT MATCH ',M1,M2,M3,M
c         CALL CRASHPROGRAM
      ENDIF
      DO 1001 IJ12=INT(DABS(J1-J2)),INT(J1+J2)
      J12=DBLE(IJ12)
      IF((DABS(M12).LE.J12).AND.
     1((J12+J3.GE.J).AND.(DABS(J12-J3).LE.J))) THEN
        C1=DCLEBG(J12,J3,J,M12,M3,M)**2
        C2=DCLEBG(J1,J2,J12,M1,M2,M12)**2
       IF(IEXCH(IH1,IH2).GT.0) C2=C2+DCLEBG(J2,J1,J12,M2,M1,M12)**2
       IF(IEXCH(IH1,IH3).GT.0) C2=C2+DCLEBG(J2,J1,J12,M2,M1,M12)**2
       IF(IEXCH(IH3,IH2).GT.0) C2=C2+DCLEBG(J2,J1,J12,M2,M1,M12)**2
        AV=AV+1D0
        CLEBG3TRM=CLEBG3TRM+C1*C2
      ENDIF
 1001 CONTINUE
C      AV=2D0
      RETURN
      END

      INTEGER FUNCTION IEXCH(IH1,IH2)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      IEXCH=0
      IF((XDEG(IH1).EQ.XDEG(IH2)).AND
     1.((MHAD(IH1)-MHAD(IH2))/(MHAD(IH1)+MHAD(IH2)).LT.5D-2) 
     1.AND.(NETSTRANGE(IH1).EQ.NETSTRANGE(IH2)) 
     1.AND.(I2ISPIN(IH1).EQ.I2ISPIN(IH2)) 
     1.AND.(I2I3SPIN(IH1).NE.I2I3SPIN(IH2))) IEXCH=1
      RETURN
      END

      SUBROUTINE SORT_MASSES
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      CHARACTER*9 NAMSPARE
 403  ISORTED=0
      DO 110 I=1,IHADS-1
         IF(MHAD(I+1).GT.MHAD(I)) THEN
            ISORTED=1
            IJUNK1=0
            IJUNK2=0
            NAMSPARE=NAM(I+1)
            NAM(I+1)=NAM(I)
            NAM(I)=  NAMSPARE
            CALL FLIP(MHAD(I),MHAD(I+1),IJUNK1,IJUNK2)
            CALL FLIP(XDEG(I),XDEG(I+1),IJUNK1,IJUNK2)
            CALL FLIP(WIDTH(I),WIDTH(I+1),IBAR(I),IBAR(I+1))
            CALL FLIP(CHEM(I),CHEM(I+1),IJUNK1,IJUNK2)
            CALL FLIP(XU(I),XU(I+1),IBS(I),IBS(I+1))
            CALL FLIP(XD(I),XD(I+1),IJUNK1,IJUNK2)
            CALL FLIP(XS(I),XS(I+1),I2ISPIN(I),I2ISPIN(I+1))
            CALL FLIP(XAU(I),XAU(I+1),I2I3SPIN(I),I2I3SPIN(I+1))
            CALL FLIP(XAD(I),XAD(I+1),IJUNK1,IJUNK2)
            CALL FLIP(XAS(I),XAS(I+1),ICHARGE(I),ICHARGE(I+1))
            CALL FLIP(XCH(I),XCH(I+1),IPN(I),IPN(I+1))
            CALL FLIP(XACH(I),XACH(I+1),IJUNK1,IJUNK2)
            CALL FLIP(XB(I),XB(I+1),INETQ(I),INETQ(I+1))
            CALL FLIP(XAB(I),XAB(I+1),IMIX(I),IMIX(I+1))
         ENDIF
 110  CONTINUE
      IF(ISORTED.GT.0) GO TO 403
      I=IHDMX
 111  I=I-1
      IF((XU(I).GT.0D0).AND.(XU(I).EQ.XAU(I))) THEN 
         MPI=MHAD(I)
      ELSE
         GO TO 111
      ENDIF
      RETURN
      END

      SUBROUTINE FLIP(DOUBLE1,DOUBLE2,INTEG1,INTEG2)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      DOUBLESPARE=DOUBLE1
      DOUBLE1=DOUBLE2
      DOUBLE2=DOUBLESPARE

      INTEGSPARE=INTEG1
      INTEG1=INTEG2
      INTEG2=INTEGSPARE

      RETURN
      END


C------------ PARTICLE NAME CHECK

      SUBROUTINE NAMECHECK(IP)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      CHARACTER*9 NAME
      CHARACTER*2 PREFIX
      CHARACTER*3 ENDING
      CHARACTER*1 APREFIX
C      INTEGER NUM(2),ND,NE,NF,NG
C      COMMON /SLATE/ ND,NE,NF,NG,NUM,DUMMY(34) !! for CERNLIB reference
C      INTEGER ID
      NAME=NAM(IP)
      PREFIX=NAME(1:2)
      APREFIX=NAME(1:1)
      ENDING=NAME(7:9)
      IUNKNOWN=0
      CHARGE2=-1D3
      XISPN2=-1D3
      XI3SPN2=-1D3
      SPIN2=-1D3
      N_S=0D0
      IF(ENDING.EQ.'plp') THEN
         IPARTANT=1
         CHARGE2=2D0
         XI3SPN2=DBLE(1.5)
      ELSEIF((ENDING.EQ.'plu').OR.(ENDING.EQ.'mnb')) THEN
         CHARGE2=1D0
         IF(ENDING.EQ.'plu') IPARTANT=1
         IF(ENDING.EQ.'mnb') IPARTANT=-1
      ELSEIF((ENDING.EQ.'zer').OR.(ENDING.EQ.'zrb')) THEN
         CHARGE2=0D0
         IF(ENDING.EQ.'zer') IPARTANT=1
         IF(ENDING.EQ.'zrb') IPARTANT=-1
      ELSEIF((ENDING.EQ.'min').OR.(ENDING.EQ.'plb')) THEN
         CHARGE2=-1D0
         IF(ENDING.EQ.'min') IPARTANT=1
         IF(ENDING.EQ.'plb') IPARTANT=-1
      ELSEIF(ENDING.EQ.'ppb') THEN
         CHARGE2=-2D0
         IPARTANT=-1
      ELSE
         WRITE(61,*) 'NONSTANDARD ENDING FOR ',NAM(IP)
         IUNKNOWN=1
      ENDIF
      IF(IUNKNOWN.EQ.0) THEN
        IF((APREFIX.EQ.'a').OR.(APREFIX.EQ.'f')) THEN
         IF(APREFIX.EQ.'a') XISPN2=1D0
         IF(APREFIX.EQ.'f') XISPN2=0D0
         XI3SPN2=CHARGE2*XISPN2
         IBS2=1
         SPIN2=DBLE(ICHAR(NAME(2:2)))
        ELSEIF(PREFIX.EQ.'pi') THEN
         XISPN2=1D0
         XI3SPN2=CHARGE2*XISPN2
         IBS2=1
        ELSEIF(PREFIX.EQ.'ph') THEN
         XISPN2=0D0
         CHARGE2=0D0
         IBS2=1
        ELSEIF(PREFIX.EQ.'rh') THEN
         XISPN2=1D0
         IBS2=1
         XI3SPN2=CHARGE2*XISPN2
        ELSEIF(PREFIX.EQ.'om') THEN
         XISPN2=0D0
         CHARGE2=0D0
         IBS2=1
        ELSEIF(PREFIX.EQ.'et') THEN
         XISPN2=0D0
         CHARGE2=0D0
         SPIN2=0D0
         IBS2=1
        ELSEIF(PREFIX.EQ.'Ka') THEN
         XISPN2=DBLE(0.5)
         IBS2=1
         IF((ENDING.EQ.'min').OR.(ENDING.EQ.'zrb')) THEN
           N_S=1D0
           IF(ENDING.EQ.'min') XI3SPN2=-DBLE(0.5)
           IF(ENDING.EQ.'zrb') XI3SPN2=DBLE(0.5)
         ELSE
           N_S=-1D0
           IF(ENDING.EQ.'plu') XI3SPN2=DBLE(0.5)
           IF(ENDING.EQ.'zer') XI3SPN2=-DBLE(0.5)
         ENDIF
        ELSEIF(PREFIX.EQ.'Ns') THEN
         XISPN2=DBLE(0.5)
         IBS2=-1   
         XI3SPN2=(CHARGE2-DBLE(IPARTANT)*DBLE(0.5))
        ELSEIF(PREFIX.EQ.'Dl') THEN
         XISPN2=DBLE(1.5)
         IBS2=-1
         XI3SPN2=(CHARGE2-DBLE(IPARTANT)*DBLE(0.5))
        ELSEIF(PREFIX.EQ.'Lm') THEN
         XISPN2=0D0
         IBS2=-1
         N_S=DBLE(IPARTANT)*1D0
        ELSEIF(PREFIX.EQ.'Sg') THEN
         XISPN2=1D0
         XI3SPN2=CHARGE2*XISPN2
C         WRITE(61,*) NAM(IP),IPARTANT,CHARGE2,XI3SPN2
         IBS2=-1
         N_S=DBLE(IPARTANT)*1D0
        ELSEIF(PREFIX.EQ.'Xi') THEN
         XISPN2=DBLE(0.5)
         XI3SPN2=CHARGE2+DBLE(IPARTANT)*DBLE(0.5)
         IBS2=-1
         N_S=DBLE(IPARTANT)*2D0
        ELSEIF(PREFIX.EQ.'UM') THEN
         XISPN2=0D0 
         IBS2=-1
         N_S=DBLE(IPARTANT)*3D0
        ELSE
         WRITE(61,*) 'NONSTANDARD PREFIX FOR ',NAM(IP)
         IUNKNOWN=1
        ENDIF
      ENDIF
      IF(IBS2.GT.0) IPARTANT=0
      IF(XISPN2.EQ.0D0) XI3SPN2=0D0
      IF(IUNKNOWN.EQ.0) THEN
        MASSPART=DBLE(ICHAR(NAME(3:3))-48+1.D-1
     1 *(ICHAR(NAME(4:4))-48)+1.D-2*(ICHAR(NAME(5:5))-48)
     1 +1.D-3*(ICHAR(NAME(6:6))-48))
        DEVIATION=(DBLE(0.5)*(MASSPART-MHAD(IP))/(MASSPART+MHAD(IP)))**2
        IF(DEVIATION.GT.DBLE(0.01)) THEN
          WRITE(61,*) 'MASS NOT WELL DEFINED FOR ',NAM(IP),' ',MHAD(IP),
     1  ' FROM NAME ',MASSPART
        ENDIF
         IF(DABS(XI3SPN2).GT.XISPN2) WRITE(61,*) 'I3>I FOR ',NAM(IP)
     1,' I3,I ',DABS(XI3SPN2),XISPN2
         IDEG2=INT(2D0*SPIN2+1)
         ISPN2=INT(2D0*XISPN2)
         I3SPN2=INT(2D0*XI3SPN2)
         IF((XDEG(IP).NE.IDEG2).AND.(IDEG2.GT.0)) WRITE(61,*)
     1       'WRONG SPIN FOR ',NAM(IP),' INPUT,NAME ',XDEG(IP),IDEG2
         IF(IBS(IP).NE.IBS2) WRITE(61,*)
     1       'WRONG STAT FOR ',NAM(IP),' INPUT,NAME ',IBS(IP),IBS2
         IF(I2ISPIN(IP).NE.ISPN2) WRITE(61,*)
     1       'WRONG I FOR ',NAM(IP),' INPUT,NAME ',I2ISPIN(IP),ISPN2
         IF(I2I3SPIN(IP).NE.I3SPN2) WRITE(61,*)
     1       'WRONG I3 FOR ',NAM(IP),' INPUT,NAME ',I2I3SPIN(IP),I3SPN2
         IF(ICHARGE(IP).NE.INT(CHARGE2)) WRITE(61,*)
     1       'WRONG CHARGE FOR ',NAM(IP),' INPUT,NAME '
     1,ICHARGE(IP),INT(CHARGE2)
         IF(XS(IP)-XAS(IP).NE.N_S) WRITE(61,*)
     1       'WRONG STRANGENESS FOR ',NAM(IP),' INPUT,NAME '
     1,XS(IP)-XAS(IP)
     1,N_S
      ENDIF
      RETURN
      END


      FUNCTION FINDYIELDS(IH)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX),WKBEF
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      IF(IH.EQ.1) WKBEF='UNCORRECT'
      IDVOL=0
      IFL_TST=0
      IF((IH.EQ.1).OR.(WKF(IH).NE.WKBEF)) THEN
         WKBEF=WKF(IH)
         CALL DECAY(IH)
      ENDIF
      IFL_TST=IFLTEST(NAMDATA(IH,2))
      IF(IFL_TST.LE.0) THEN         
           YLD1=YLDPART(0,NAMDATA(IH,1),IH)
           YLD2=YLDPART(0,NAMDATA(IH,2),IH)
      ELSE
           YLD1=YLDPART(IFL_TST,NAMDATA(IH,1),IH)      
           IF(IRATIONW.EQ.1) THEN
              YLD2=1D0
           ELSE
              IDVOL=1
              YLD2=YLDPART(0,NAMDATA(IH,1),IH)
           ENDIF
      ENDIF           
      IF(YLD2.NE.0D0) THEN
          FINDYIELDS=YLD1/YLD2
          IF(IDVOL.GT.0) THEN
c------------------------------------------------------------------------
c     Sigma = (<\delta X>^2 V + <X>^2 dV)/<X> = \Sigma_{stat}+<X> dV
c------------------------------------------------------------------------
             FINDYIELDS=FINDYIELDS+YLDPART(0,NAMDATA(IH,1),IH)*DVOL
             FINDYIELDS=FLCDYN(IFL_TST,FINDYIELDS,1D0)
          ENDIF
      ELSE 
c          WRITE(*,*) 'ONE OF THE YIELDS=0'
c          WRITE(*,*) NAMDATA(IH,1),' ',NAMDATA(IH,2)
          FINDYIELDS=0D0
      ENDIF
      RETURN
      END
c-----------------------------------------------------------------------------
c    RATIOS SUBROUTINE   (formerly ratios.f)
c-------------------------------------------------------------------------------
      SUBROUTINE WRITE_RATIOS(CALCFILE,ERRORF)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      CHARACTER*13 CALCFILE
      OPEN(2,FILE=CALCFILE,STATUS='unknown')
      CALL DATETIME(2)
      WRITE(2,*) 'TEMP ',T
      WRITE(2,*) 'LAMQ ',LAMQ,' (MUB: ',MUBFUNC(T,LAMQ),' )'
      WRITE(2,*) 'LAMS ',LAMS,' (MUS: ',MUSFUNC(T,LAMS,LAMQ),' )'
      WRITE(2,*) 'GAMQ ',GAMQ,' (PI CONDENSE AT~',DEXP(MPI/(2D0*T)),' )'
      WRITE(2,*) 'GAMS ',GAMS,' GAMS/GAMQ ',GAMS/GAMQ
      WRITE(2,*) 'LMI3 ',LMI3,' (MUI3:  ',T*DLOG(LMI3),' )'
      WRITE(2,*) 'GAM3 ',GAM3
      WRITE(2,*) 'NORM ',NORM,' (FLUCTUATION ON NORM: ',DVOL,')'
      WRITE(2,*) 'NCBC ',NCBC
      WRITE(2,*) 'GAMC ',REALGAMC
      WRITE(2,*) 'TC2T ',TC2T
      WRITE(2,*) ' '
      CALL DATACHECK
      CALL FILL_CHEM(1,1)
      CALL CALCYIELDS
      WRITE(2,*) 'UNITS:  ENERGY IN GeV, DENSITY IN 1/fm^3'
      DO 105 IH=1,IRATDAT
         RATDAT1=FINDYIELDS(IH)
         IF(RATDAT1.EQ.0D0) THEN
           WRITE(2,*) 'ONE OF THE YIELDS=0'
           WRITE(2,*) NAMDATA(IH,1),' ',NAMDATA(IH,2)
         ENDIF
         IF(ERRORF.LT.0) THEN
           WRITE(2,*) 
     1     'RATIO ',NAMDATA(IH,1),'/',NAMDATA(IH,2),RATDAT1
         ELSE
           ERR1=ERRORF*RATDAT1
           VALUE1=RANDOM_GAUSSIAN(RATDAT1,ERR1)
 113       FORMAT(A9,2X,A9,3F12.7,I17)
           WRITE(2,113) NAMDATA(IH,1),NAMDATA(IH,2),VALUE1,ERR1
     1     ,0D0,IFIT(IH)
         ENDIF
 105  CONTINUE
      CLOSE(2)
      RETURN
      END

      FUNCTION random_gaussian(mean,variance)
      IMPLICIT DOUBLE PRECISION(A-Z)
 1    CALL RM48(RANDNUM1,1)
      CALL RM48(RANDNUM2,1)
        v1=2D0*RANDNUM1-1D0
        v2=2D0*RANDNUM2-1D0
        rsq=v1**2+v2**2
        if((rsq.ge.1).or.(rsq.eq.0D0)) goto 1
        fac=DSqrt(-2D0*DLOG(rsq)/rsq)
        random_gaussian=mean+variance*v2*fac
        if(random_gaussian.lt.0D0) then

           write(*,*) 'random_gaussian<0 for ',mean,variance
           stop
        endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 412kL).

       FUNCTION INTTEST(X)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       INTTEST=0
       XINT=(X-DBLE(INT(X)))**2
       IF(XINT.GT.1D-8) INTTEST=1
       RETURN
       END

      SUBROUTINE CALCYIELDS
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
        COMMON /FLUCTS/ FLCTPR(IHDMX),FLCTST(IHDMX),
     1FLCTFN(IHDMX),IFLCTALL
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
        EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      PARAMETER(MMIN=1D-3)
c      WRITE(61,*) 'PRODUCING TOTAL RATIOS'
      

      ICONDENSE=0
      DO 302 IP=1,IHADS
         YLDCH(IP)=0.D0
         YLDST(IP)=0.D0
         YLDFN(IP)=0.D0
        IF(MHAD(IP).GT.MMIN) THEN
          IEPN=0
c  only non charm particles start with a thermal yeld here... 
c  charm particles calculated and decayed elsewhere, see subroutine CALCCHARMYIELDS
          IF((XCH(IP).LE.0).AND.(XACH(IP).LE.0)) THEN
             YLDPR(IP)=F_HAD(IP)    !! non-charm hadrons use old SHARE function
          ELSE
             YLDPR(IP)=0.D0         !! charm hadrons are reset to 0
          ENDIF
c-------------------------------------
          FLUCT=0D0
          IF(IFLCTALL.GT.0) THEN
            IEPN=4
            FLUCT=F_HAD(IP)
          ENDIF
          FLCTPR(IP)=FLUCT
C-------------------------------------
       ELSE !! IF MASS OF A PARTICLE IS LESS THAN MMIN. THIS IS USED FOR LEPTONS 
         YLDPR(IP)=0.D0
       ENDIF

 302  CONTINUE
      CALL CALCCHARMYIELDS  !! calculate charm hadrons yields and their decays
      RETURN
      END




      SUBROUTINE CALCCHARMYIELDS
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      EXTERNAL CALCULATECHARMYIELDS
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
c      WRITE(61,*) 'FEEDING CHARM'
      IF(NCBC.LE.0.D0) THEN  !! If no charm, skip the routine, set gamma_c to 1.000
         REALGAMC=1.D0
      ENDIF
      CALL CALCULATECHARMYIELDS            !! calculate the charm yields in the C++ module
      RETURN
      END




      SUBROUTINE DECAY(IDAT)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
        COMMON /FLUCTS/ FLCTPR(IHDMX),FLCTST(IHDMX),
     1FLCTFN(IHDMX),IFLCTALL
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
C      IF(ICONDENSE.GT.0) CALL VZERO(YLDST,IHADS)
C------------------ RESONANCE DECAYS -----------
c       WRITE(*,*) 'DECAYING RESONANCES'
       DO 302 IP=1,IHADS
          IF((XCH(IP).LE.0).AND.(XACH(IP).EQ.0)) THEN
            YLDST(IP)=YLDCH(IP)+YLDPR(IP) !! for non-charm hadrons
            YLDFN(IP)=YLDCH(IP)+YLDPR(IP)
          ELSE
            YLDST(IP)=YLDCH(IP)  !! for charm particles
            YLDFN(IP)=YLDCH(IP)
          ENDIF

         FLCTST(IP)=FLCTPR(IP)
         FLCTFN(IP)=FLCTPR(IP)
C         write(*,*) 'primo yield ',NAM(IP),' ',YLDPR(IP)
 302   CONTINUE
       DO 303 IP=1,IHADS
         IF(IDEC(IP).GT.0) THEN
           DO 305 IDC=1,IDEC(IP)
             BRSTR=BR(IP,IDC,1)
             BRSTR2=BR(IP,IDC,2)
             DO 306 I_RES=1,IBOD(IP,IDC)
               BRWK=BRFN(IP,IDC,IDAT,I_RES,1)
               BRWK2=BRFN(IP,IDC,IDAT,I_RES,2)
               XDEC_STRONG=YLDST(IP)*BRSTR
               XDEC_WEAK=YLDFN(IP)*BRWK
C----------------------------------- DEBUG---------------
c                  WRITE(*,*) 'DECAY ',NAM(IP),' -> '
c     1,NAM(IPROD(IP,IDC,I_RES)),' TOTPROD ',BRWK,YLDFN(IP)
C-------------------------------------------------------- 
               IH=IPROD(IP,IDC,I_RES)
               COEFFN=BRSTR-BRSTR2
               COEFFDN=BRSTR2
               COEFWN=BRWK-BRWK2
               COEFWDN=BRWK2
c               write(*,*) 'glob ',NAM(IP),'->',NAM(IH),IPI0(IH,IDC)
c     1,coeffn,coeffdn
c     1,coefwn,coefwdn
c---------------------------------------------------
               FDECST=(YLDST(IP)*COEFFN+COEFFDN*FLCTST(IP))*IPI0(IP,IDC)
               FDECWK=(YLDFN(IP)*COEFWN+COEFWDN*FLCTFN(IP))*IPI0(IP,IDC)
               IF(IWEAK(IP,IDC).LT.1) YLDST(IH)=YLDST(IH)+XDEC_STRONG
               IF(IWEAK(IP,IDC).LT.1) FLCTST(IH)=FLCTST(IH)+FDECST
               YLDFN(IH)=YLDFN(IH)+XDEC_WEAK
               FLCTFN(IH)=FLCTFN(IH)+FDECWK
 306         CONTINUE
 305       CONTINUE
         ENDIF
c         IF((YLDST(IP).LT.0D0).OR.(FLCTST(IP).LT.0D0).OR.
c     1      (YLDFN(IP).LT.0D0).OR.(FLCTFN(IP).LT.0D0)) THEN
c              WRITE(*,*) ' YIELDS OR FLUCTS<0 FOR ',NAM(IP),' '
c     1,YLDST(IP),FLCTST(IP),YLDFN(IP),FLCTFN(IP)
c	      WRITE(*,*) 'AT T,GAMQ=',T,GAMQ
c              CALL CRASHPROGRAM
c         ENDIF
 303   CONTINUE
       RETURN
       END

      FUNCTION YLDTOT(IFLUCT,IDECFD,IPART)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
        COMMON /FLUCTS/ FLCTPR(IHDMX),FLCTST(IHDMX),
     1FLCTFN(IHDMX),IFLCTALL
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      IF(IFLUCT.EQ.0) THEN
        IF(IDECFD.LT.0) YLDTOT=YLDPR(IPART)
        IF(IDECFD.EQ.0) YLDTOT=YLDST(IPART)
        IF(IDECFD.EQ.1) YLDTOT=YLDFN(IPART)
      ELSEIF(IFLUCT.GT.0) THEN
        IF(IDECFD.LT.0) YLDTOT=FLCTPR(IPART)
        IF(IDECFD.EQ.0) YLDTOT=FLCTST(IPART)
        IF(IDECFD.EQ.1) YLDTOT=FLCTFN(IPART)
c        write(*,*) 'yldtot ',nam(ipart),' ',idecfd,flctfn(ipart)
      ENDIF
      IF(YLDTOT.LT.0D0) THEN
        WRITE(*,*) 'YLDTOT<0,= ',YLDTOT
     1,' FOR ',NAM(IPART),' IFLUCT=',IFLUCT,' STOP'
        CALL CRASHPROGRAM
      ENDIF
      RETURN
      END

      FUNCTION YLDPART(IFLUCT,IPART,IDCFL)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      CHARACTER*9 IPART
      CHARACTER*11 FLUCTUATION_NAME
      PARAMETER(IRATMX=200)
      CHARACTER*9 
     1NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX),NAM1,NAM2
      EXTERNAL FINDYIELDS
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
           IRATIONW=0
c           CALL CHTOI(IPART(1:1),IDAT1,881)
c           CALL CHTOI(IPART(2:2),IDAT2,882)
           CALL CHTOI(IPART(1:1),IDAT1)
           CALL CHTOI(IPART(2:2),IDAT2)
           IDATAPT=10*(IDAT1-48)+IDAT2-48
           IF((IDATAPT.GT.0).AND.(IDATAPT.LE.IRATMX)) THEN
              IDATAPT2=0
              IRATIONW=1              
              IF(IFLUCT.EQ.0) THEN
                 YLDPART1=FINDYIELDS(IDATAPT)
               ELSE
C----------------------  RATIOS FLUCTUATIONS CALCULATION -------------- 
                 NAM1=NAMDATA(IDATAPT,1)
                 YLD1=YLDCALC(0,NAMDATA(IDATAPT,1),IDCFL)
                 NAM2=NAMDATA(IDATAPT,2)
                 YLD2=YLDCALC(0,NAMDATA(IDATAPT,2),IDCFL)
                 IF((YLD1.GT.0D0).AND.(YLD2.GT.0D0)) THEN
                   YLDPART1_TOT=(PARTCORREL(NAM1,NAM1,IDCFL)/YLD1)/YLD1
     1            +(PARTCORREL(NAM2,NAM2,IDCFL)/YLD2)/YLD2
     1            -2D0*(PARTCORREL(NAM1,NAM2,IDCFL)/YLD1)/YLD2
                   IF(IFLUCT.EQ.1) THEN
                      YLDPART1=YLDPART1_TOT
                   ELSE 
                   YLDPART1_STAT=1D0/YLDCALC(0,NAMDATA(IDATAPT,1),IDCFL)
     1              +1D0/YLDCALC(0,NAMDATA(IDATAPT,2),IDCFL)
                     YLDPART1=FLCDYN(IFLUCT,YLDPART1_TOT,YLDPART1_STAT)
                     IF(IFLUCT.EQ.6) YLDPART1=YLDPART1*DSQRT(YLD2)
c         write(*,*) 'dyn fluct ',T,GAMQ,' ',nam1,' ',nam2,' ',yldpart1
                   ENDIF
                 ELSE
                   YLDPART1=0D0
                 ENDIF
C---------------------------------------------------------------------
              ENDIF
              IF(IPART(3:3).EQ.' ') THEN
                 RESULT=YLDPART1
              ELSE
c                 CALL CHTOI(IPART(4:4),IDAT1,883)
c                 CALL CHTOI(IPART(5:5),IDAT2,884)
                 CALL CHTOI(IPART(4:4),IDAT1)
                 CALL CHTOI(IPART(5:5),IDAT2)
                 IDATAPT2=10*(IDAT1-48)+IDAT2-48
                 YLDPART2=FINDYIELDS(IDATAPT2)
                 IF(IPART(3:3).EQ.'+') RESULT=YLDPART1+YLDPART2
                 IF(IPART(3:3).EQ.'*') RESULT=YLDPART1*YLDPART2
                 IF(IPART(3:3).EQ.'-') RESULT=YLDPART1+YLDPART2
                 IF(IPART(3:3).EQ.'/') RESULT=YLDPART1/YLDPART2
c                 write(*,*) 'vq ',NAMDATA(IDATAPT,1),' '
c     1,NAMDATA(IDATAPT,2),' AND ',NAMDATA(IDATAPT2,1),' '
c     1,NAMDATA(IDATAPT2,2),YLDPART1,YLDPART2
                 IRATIONW=2
              ENDIF
              IF(IWRITTEN(IDATAPT).EQ.0) THEN
                  FLUCTUATION_NAME='           '
                 IF(IFLUCT.GE.1) FLUCTUATION_NAME='FLUCTUATION'       
                 IWRITTEN(IDATAPT)=1
                 WRITE(61,*) IPART,' REFERS TO RATIO '
     1,'[',NAMDATA(IDATAPT,1),'/',NAMDATA(IDATAPT,2),'] '
     1,FLUCTUATION_NAME
                 IF(IDATAPT2.NE.0) WRITE(61,*) IPART(3:3),
     1'[',NAMDATA(IDATAPT2,1),'/',NAMDATA(IDATAPT2,2),'] '
     1,FLUCTUATION_NAME
              ENDIF
           ELSE
              RESULT=YLDCALC(IFLUCT,IPART,IDCFL)
          ENDIF
          YLDPART=RESULT
      RETURN
      END

      FUNCTION YLDCALC(IFLUCT,IPART,IDCFL)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      CHARACTER*9 IPART,ZER,ZRB,PLU,PLB
     1,MIN,MNB
      CHARACTER*3 SHORT
      YLDCALC=0D0
c      WRITE(*,*) 'YLDCALC OF ',IPART
      ZER='      zer'
      ZRB='      zrb'
      PLU='      plu'
      PLB='      plb'
      MIN='      min'
      MNB='      mnb'
c      write(*,*) 'ipart ',ipart
      IF(IPART.EQ.'negatives') THEN
        YLDCALC=HADAV(IFLUCT,1,NEGATIVES)
      ELSEIF(IPART.EQ.'positives') THEN
        YLDCALC=HADAV(IFLUCT,1,POSITIVES) 
      ELSEIF(IPART.EQ.'chargmult') THEN
        YLDCALC=HADAV(IFLUCT,1,NEGATIVES)+HADAV(IFLUCT,1,POSITIVES)
      ELSEIF(IPART.EQ.'chargenet') THEN
        IF(IFLUCT.EQ.0) YLDCALC=HADAV(0,1,NETCHARGE)
        IF(IFLUCT.GE.1) YLDCALC=
     1  HADAV(1,1,POSCHARGE)+HADAV(1,1,NEGCHARGE)
     1  -2D0*HADCORREL(POSCHARGE,NEGCHARGE,IDCFL)
      ELSEIF(IPART.EQ.'neut_mult') THEN
        YLDCALC=HADAV(IFLUCT,1,NEUTMULTI)
      ELSEIF(IPART.EQ.'tot_multi') THEN
        YLDCALC=HADAV(IFLUCT,1,MULTIHAD)
      ELSEIF(IPART.EQ.'tot_prime') THEN
        YLDCALC=HADAV(IFLUCT,0,MULTIHAD)
      ELSEIF(IPART.EQ.'baryonnet') THEN
        IF(IFLUCT.EQ.0) YLDCALC=HADAV(IFLUCT,1,NETBAR)
      ELSEIF(IPART.EQ.'baryontot') THEN
        YLDCALC=HADAV(IFLUCT,1,BARHAD)
      ELSEIF(IPART.EQ.'strangtot') THEN
        IF(IFLUCT.EQ.0) YLDCALC=HADAV(0,1,TOTSTRANGE)
        IF(IFLUCT.GE.1) YLDCALC=
     1  HADAV(1,1,STRANGENESS)+HADAV(1,1,ANTISTRANGENESS)
     1  +2D0*HADCORREL(STRANGENESS,ANTISTRANGENESS,IDCFL)
      ELSEIF(IPART.EQ.'tot_light') THEN
        YLDCALC=HADAV(IFLUCT,0,TOTLIGHT)
      ELSEIF(IPART.EQ.'light_tot') THEN
        YLDCALC=HADAV(IFLUCT,1,TOTLIGHT)
      ELSEIF((IPART.EQ.'prt_yield').OR.(IPART(1:5).EQ.'solve')) THEN
        YLDCALC=1D0
      ELSEIF(IPART.EQ.'prdensity') THEN
        YLDCALC=NORM
      ELSEIF(IPART.EQ.'tot_value') THEN
        YLDCALC=NORM*NORMFACT
      ELSEIF(IPART.EQ.'stranghad') THEN
        YLDCALC=HADAV(IFLUCT,0,STRANGENESS)
      ELSEIF(IPART.EQ.'totstrong') THEN
        YLDCALC=HADAV(IFLUCT,3,MULTIHAD)
      ELSEIF(IPART.EQ.'totstrang') THEN
        YLDCALC=HADAV(IFLUCT,0,TOTSTRANGE)
      ELSEIF(IPART.EQ.'tot_q_qgp') THEN
        YLDCALC=HADAV(IFLUCT,0,TOT_Q_QGP)
      ELSEIF(IPART.EQ.'tot_s_qgp') THEN
        YLDCALC=HADAV(IFLUCT,0,TOTSTRQGP)
      ELSEIF(IPART.EQ.'tot_u_qgp') THEN
        YLDCALC=HADAV(IFLUCT,0,TOT_U_QGP)
      ELSEIF(IPART.EQ.'tot_d_qgp') THEN
        YLDCALC=HADAV(IFLUCT,0,TOT_D_QGP)
      ELSEIF(IPART.EQ.'netstrang') THEN
        YLDCALC=HADAV(IFLUCT,0,NETSTRANGE)
      ELSEIF(IPART.EQ.'strangnet') THEN
        IF(IFLUCT.EQ.0) YLDCALC=HADAV(0,1,NETSTRANGE)
        IF(IFLUCT.GE.1) YLDCALC=
     1  HADAV(1,1,STRANGENESS)+HADAV(1,1,ANTISTRANGENESS)
     1  -2D0*HADCORREL(STRANGENESS,ANTISTRANGENESS,IDCFL)
      ELSEIF(IPART.EQ.'tot_charm') THEN
        YLDCALC=NCBC
      ELSEIF(IPART.EQ.'net_charm') THEN
        YLDCALC=HADAV(IFLUCT,0,NETCHARM)
      ELSEIF(IPART.EQ.'totcharge') THEN
        YLDCALC=HADAV(IFLUCT,0,CHARGEHAD)
      ELSEIF(IPART.EQ.'chargetot') THEN
        IF(IFLUCT.EQ.0) YLDCALC=HADAV(0,1,CHARGEHAD)
        IF(IFLUCT.GE.1) YLDCALC=
     1  HADAV(1,1,NEGATIVES)+HADAV(1,1,POSITIVES)
     1  +2D0*HADCORREL(POSCHARGE,NEGCHARGE,IDCFL)
      ELSEIF(IPART.EQ.'netcharge') THEN
        YLDCALC=HADAV(IFLUCT,0,NETCHARGE)
c        write(*,*) 'netcharge ',IFLUCT,YLDCALC
      ELSEIF(IPART.EQ.'wrobratio') THEN
        YLDCALC=2D0*HADAV(IFLUCT,0,ANTISTRANGENESS)
     1/HADAV(IFLUCT,0,ANTIQUARKS)
      ELSEIF(IPART.EQ.'antiquark') THEN
        YLDCALC=HADAV(IFLUCT,0,ANTIQUARKS)
      ELSEIF(IPART.EQ.'antistran') THEN
        YLDCALC=HADAV(IFLUCT,0,ANTISTRANGENESS)
      ELSEIF(IPART.EQ.'totbaryon') THEN
         YLDCALC=HADAV(IFLUCT,0,BARHAD)
      ELSEIF(IPART.EQ.'netbaryon') THEN
         YLDCALC=HADAV(IFLUCT,0,NETBAR)
      ELSEIF(IPART.EQ.'totenergy') THEN
         YLDCALC=TOTBULK(IFLUCT,1,-1)
      ELSEIF(IPART.EQ.'entropy_t') THEN
          YLDCALC=TOTBULK(IFLUCT,3,-1)
      ELSEIF(IPART.EQ.'T_entropy') THEN
          YLDCALC=T*TOTBULK(IFLUCT,3,-1)
      ELSEIF(IPART.EQ.'pressuret') THEN
         YLDCALC=TOTBULK(0,2,-1)
      ELSEIF(IPART.EQ.'an_energy') THEN
         YLDCALC=TOTBULK(IFLUCT,1,1)
      ELSEIF(IPART.EQ.'anentropy') THEN
          YLDCALC=TOTBULK(IFLUCT,3,1)
      ELSEIF(IPART.EQ.'an_pressu') THEN
         YLDCALC=TOTBULK(0,2,1)
      ELSEIF(IPART.EQ.'an_multip') THEN
         YLDCALC=TOTBULK(0,0,1)
      ELSEIF(IPART.EQ.'T_______4') THEN
         YLDCALC=NORM*T**4/HC**3
      ELSEIF(IPART.EQ.'TraceAnom') THEN
         YLDCALC=(TOTBULK(IFLUCT,1,-1)-3*TOTBULK(0,2,-1))
     1 /(T**4/HC**3)
      ELSE
        XBS=-1D0
        IF(IFLUCT.GT.0) XBS=1D0
        SHORT=IPART(7:9)
        IF((SHORT.EQ.'sht').OR.(SHORT.EQ.'tot')) THEN
           CALL CCOPYL(IPART,ZER,6)
           CALL CCOPYL(IPART,ZRB,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,ZER))
     1+YLDTOT(IFLUCT,1,IMATCHNAME(1,ZRB))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC+PARTCORREL(ZER,ZRB,IDCFL)
           IF(SHORT.EQ.'sht') YLDCALC=DBLE(0.5)*YLDCALC
       ELSEIF(SHORT.EQ.'lng') THEN
           CALL CCOPYL(IPART,ZER,6)
           CALL CCOPYL(IPART,ZRB,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,ZER))
     1+YLDTOT(IFLUCT,1,IMATCHNAME(1,ZRB))
           YLDCALC=DBLE(0.5)*YLDCALC
       ELSEIF(SHORT.EQ.'plt') THEN
           CALL CCOPYL(IPART,PLU,6)
           CALL CCOPYL(IPART,PLB,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,PLU))
     1+YLDTOT(IFLUCT,1,IMATCHNAME(1,PLB))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC+PARTCORREL(PLU,PLB,IDCFL)
       ELSEIF(SHORT.EQ.'pbn') THEN
           CALL CCOPYL(IPART,PLU,6)
           CALL CCOPYL(IPART,PLB,6)
           YLDCALC=ABS(
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,PLU))
     1-YLDTOT(IFLUCT,1,IMATCHNAME(1,PLB)))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC-PARTCORREL(PLU,PLB,IDCFL)
       ELSEIF(SHORT.EQ.'mnt') THEN
           CALL CCOPYL(IPART,MIN,6)
           CALL CCOPYL(IPART,MNB,6)
           YLDCALC=YLDTOT(IFLUCT,1,IMATCHNAME(1,MIN))
     1        +YLDTOT(IFLUCT,1,IMATCHNAME(1,MNB))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC+PARTCORREL(MIN,MNB,IDCFL)
       ELSEIF(SHORT.EQ.'mnn') THEN
           CALL CCOPYL(IPART,MIN,6)
           CALL CCOPYL(IPART,MNB,6)
           YLDCALC=YLDTOT(IFLUCT,1,IMATCHNAME(1,MIN))
     1        -YLDTOT(IFLUCT,1,IMATCHNAME(1,MNB))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC-PARTCORREL(MIN,MNB,IDCFL)
       ELSEIF(SHORT.EQ.'plm') THEN
           CALL CCOPYL(IPART,PLU,6)
           CALL CCOPYL(IPART,MIN,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,PLU))
     1+YLDTOT(IFLUCT,1,IMATCHNAME(1,MIN))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC
     1+PARTCORREL(PLU,MIN,IDCFL)
       ELSEIF(SHORT.EQ.'pmb') THEN
           CALL CCOPYL(IPART,PLB,6)
           CALL CCOPYL(IPART,MNB,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,PLB))
     1+YLDTOT(IFLUCT,1,IMATCHNAME(1,MNB))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC
     1+PARTCORREL(MNB,PLB,IDCFL)
       ELSEIF(SHORT.EQ.'pnb') THEN
           CALL CCOPYL(IPART,PLB,6)
           CALL CCOPYL(IPART,MNB,6)
           YLDCALC=
     1 YLDTOT(IFLUCT,1,IMATCHNAME(1,PLB))
     1+XBS*YLDTOT(IFLUCT,1,IMATCHNAME(1,MNB))
           IF(IFLUCT.GE.1)
     1YLDCALC=YLDCALC
     1-PARTCORREL(MNB,PLB,IDCFL)
       ELSEIF(SHORT.EQ.'pln') THEN
           CALL CCOPYL(IPART,PLU,6)
           CALL CCOPYL(IPART,MIN,6)
           YLDCALC=
     1    YLDTOT(IFLUCT,1,IMATCHNAME(1,PLU))+
     1XBS*YLDTOT(IFLUCT,1,IMATCHNAME(1,MIN))
           IF(IFLUCT.GE.1) 
     1YLDCALC=YLDCALC
     1-PARTCORREL(PLU,MIN,IDCFL)
       ELSE
           YLDCALC=YLDTOT(IFLUCT,1,IMATCHNAME(1,IPART))
       ENDIF
      ENDIF
      RETURN
      END

     
c---------------- FITTING ----------------

C---------------- READING DATAFILE/SETTINGS

      SUBROUTINE READ_RATIOS_DATA(TOTFILE)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX),READNAME,READNAME1,READNAME2,READNAME3
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
        COMMON /FLUCTS/ FLCTPR(IHDMX),FLCTST(IHDMX),
     1FLCTFN(IHDMX),IFLCTALL
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      PARAMETER(IDECMX=200)      
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX),WEAKFILE
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      DIMENSION IX(3)
      CHARACTER*9 NAMDAT1,NAMDAT2
      CHARACTER*3 ORDER
      CHARACTER*14 TOTFILE
      DIMENSION DECFEED(IDECMX,4),IDECAYMATRIX(IDECMX,2),IDK(2)

      IF(NAM(1).EQ.'nopart000') THEN
         WRITE(*,*) 'FOR THE FUTURE, PLEASE READ PARTICLE DATA-FILE '
     1,'AND EXPERIMENTAL DECAY TREE FIRST! '
         WRITE(*,*) ' READING FILES partnowdt.data AND '
     1,'decay data AUTOMATICALLY'
         CALL READ_PARTICLES('partnowdt.data','decays.data')
      ENDIF
      CALL BRANCH_CHECK
C
      DO 155 IDX=1,IDECMX   !!!!! RESET ALL WEAK DECAYS  I THINK THIS DOES NOT HAVE TO BE HERE, BUT FOR THE SAKE OF THINGS I LEAVE IT
            DO 156 IPRAT=1,3
               DECFEED(IDX,IPRAT)=0.D0     !!! THIS DECAY CONTRIBUTION SET TO ZERO FOR ALL DAUGHTERS,
               DECFEED(IDX,4)=0.D0
               IF(IPRAT.LT.3) THEN
                  IDECAYMATRIX(IDX,IPRAT)=0  !!! BUT THIS IS ZERO. WHEN CHECKED LATER (IF>0), NO CORRECTION IS APPLIED
               ENDIF
 156        CONTINUE
 155  CONTINUE
C
C      WRITE(*,*) "START RESET INIT"
            IDX=1
            DO 1875 I=1,IHADS
               DO 1876 IB=1,IDEC(I)
                  IF(IWEAK(I,IB).EQ.2) THEN
                    IDECAYMATRIX(IDX,1)=I
                    IDECAYMATRIX(IDX,2)=IB
                    DO 1778 I1=1,4
1778                  DECFEED(IDX,I1)=0D0
                    IDX=IDX+1
                    IF(IDX.GT.IDECMX) THEN
                      WRITE(*,*) 'TOO MANY DECAYS, MAX= ',IDECMX
                      CALL CRASHPROGRAM
                    ENDIF
                  ENDIF
1876           CONTINUE
1875        CONTINUE
C      WRITE(*,*) "END RESET INIT"

C
C
C
      WEAKFILE='NOWK_FEED'
      IFLCTALL=0
      ISOLVMAX=1
      DO 321 I=1,IRATMX
         RATDATA(I)=0D0
         NAMDATA(I,1)='         '
         NAMDATA(I,2)='         '
         IWRITTEN(I)=0
 321  CONTINUE
      IF(TOTFILE(11:14).NE.'HERE') THEN
        IUNIT=1
        OPEN(1,FILE=TOTFILE,STATUS='OLD')
      ELSE
        IUNIT=51
      ENDIF
      I_NORM=0
      IRATDAT=1
 110  IF(IREADCOMMENT(IUNIT).GT.0) GO TO 104
      READ(IUNIT,102,END=104) NAMDAT1
 102  FORMAT(A9)
      BACKSPACE IUNIT
C
C
C  WHEN weakdecay DIRECTIVE IF FOUND.... THE FUN BEGINS!
      IF(NAMDAT1.EQ.'weakdecay') THEN
         I_READ_ERR=1
         READ(IUNIT,113,END=104) NAMDAT1,WEAKFILE
C
C  OLD SCHOOL WEAK DECAY TREATMENT, GIVE THE USER CRAP ABOUT UPDATING AND EXIT
         IF((WEAKFILE.EQ.'top      ').OR.(WEAKFILE.EQ.'bottom   ').OR. 
     1      (WEAKFILE.EQ.'all      ')) THEN
           WRITE(*,*) "OBSOLETE SHAREv1.2 STYLE WEAK FEED DOWN FILE"
           WRITE(*,*) "UPDATE YOUR WEAK DECAYS TO SHAREv2.x AND RE-RUN"
           CALL CRASHPROGRAM
         ELSE
          WRITE(61,*) 'FEED-DOWN CORRECTIONS READ FROM ',WEAKFILE
C
C
C   WEAKFILE CASES.
C        CASE = 'NOWK_FEED'   =  ALL YIELDS CORRECTED, NO WEAK DECAY ALLOWED
          IF(WEAKFILE.EQ.'NOWK_FEED') THEN                  !!!!
            WRITE(61,*) 'NO WEAK FEED-DOWN DECAYS'
            IDX=1
            DO 875 I=1,IHADS
               DO 876 IB=1,IDEC(I)
                  IF(IWEAK(I,IB).EQ.2) THEN
                    IDECAYMATRIX(IDX,1)=I
                    IDECAYMATRIX(IDX,2)=IB
                    DO 778 I1=1,4
 778                  DECFEED(IDX,I1)=0D0
                    IDX=IDX+1
                    IF(IDX.GT.IDECMX) THEN
                      WRITE(*,*) 'TOO MANY DECAYS, MAX= ',IDECMX
                      CALL CRASHPROGRAM
                    ENDIF
                  ENDIF
 876           CONTINUE
 875        CONTINUE
            GO TO 175
          ENDIF
C
C     CASE = 'UNCORRECT'   = ALL YIELDS UNCORRECED, ALL WEAK DECAYS ALLOWED
          IF(WEAKFILE.EQ.'UNCORRECT') THEN
          DO 1555 IDX=1,IDECMX
            DO 1556 IPRAT=1,3
               DECFEED(IDX,IPRAT)=1.D0
               DECFEED(IDX,4)=0.2D0
               IF(IPRAT.LT.3) THEN
                  IDECAYMATRIX(IDX,IPRAT)=0
               ENDIF
 1556        CONTINUE
 1555      CONTINUE
          GO TO 175
          ENDIF

C
C     CASE = "FILE NAME", AN ACTUAL FILE WITH USER SPECIFIC DECAYS TO BE ACCEPTED
          IF((WEAKFILE.NE.'NOWK_FEED')
     1               .AND.(WEAKFILE.NE.'UNCORRECT')) THEN
C            WRITE(*,*)"USER SPECIFIC FILE ",WEAKFILE
            !! RESET ALL WEAK DECAYS TO ZERO, AS IF WEAKFILE = 'NOWK_FILE'.
C
            IDX=1
            DO 2875 I=1,IHADS
               DO 2876 IB=1,IDEC(I)
                  IF(IWEAK(I,IB).EQ.2) THEN
                    IDECAYMATRIX(IDX,1)=I
                    IDECAYMATRIX(IDX,2)=IB
                    DO 2778 I1=1,4
 2778                  DECFEED(IDX,I1)=0D0
                    IDX=IDX+1
                    IF(IDX.GT.IDECMX) THEN
                      WRITE(*,*) 'TOO MANY DECAYS, MAX= ',IDECMX
                      CALL CRASHPROGRAM
                    ENDIF
                  ENDIF
 2876           CONTINUE
2875        CONTINUE
C
          ENDIF

C
          IF(WEAKFILE(6:9).NE.'HERE') THEN
            IUNIT2=81
            OPEN(IUNIT2,FILE=WEAKFILE,STATUS="OLD")
          ELSE
            IUNIT2=IUNIT
          ENDIF
          IDX=0
c================================================ READ DECAY FILE
 134      IF(IREADCOMMENT(IUNIT2).GT.0) GO TO 117
          IDX=0
!!!          IF(IDX.GT.IDECMX) THEN  !! CHECK IF THERE IS NOT TOO MUCH DECAYS
!!!             WRITE(*,*) 'TOO MANY FEED-DOWN CORRECTIONS: '
!!!     1       ,IDX,' MAX= ',IDECMX
!!!             CALL CRASHPROGRAM
!!!          ENDIF

!! READING EITHER 2 BODY
 114      READ(IUNIT2,103,END=117,ERR=122) READNAME,READNAME1,READNAME2
     1    ,ORDER,FEEDN
 103      FORMAT(A9,3X,A9,3X,A9,3X,A3,F9.4)
          WRITE(61,103) READNAME,READNAME1,READNAME2,ORDER,FEEDN
          IBD=2
          GO TO 617
C--------------------------------------------------
!! OR 3 BODY DECAY
 116      READ(IUNIT2,174,END=117,ERR=121)
     1    READNAME,READNAME1,READNAME2,READNAME3,ORDER,FEEDN
          IBD=3
          WRITE(61,174) 
     1    READNAME,READNAME1,READNAME2,READNAME3,ORDER,FEEDN
 174      FORMAT(A9,3X,A9,3X,A9,3X,A9,3X,A3,3X,F9.4)
          GO TO 617
c------------------------ filling in the values
 617      IF(IMATCHNAME(1,READNAME).NE.1000) THEN
            IENTRIES=1
            IDK(1)=IMATCHNAME(1,READNAME)
          ELSE
            IENTRIES=2
            IDK(1)=IMATCHNAME(1,'Ka0492zer')
            IDK(2)=IMATCHNAME(1,'Ka0492zrb')
          ENDIF
          DO 677 I=1,IENTRIES
           ID1=IDK(I)
           ID2=IMATCHNAME(1,READNAME1)
           ID3=IMATCHNAME(1,READNAME2)
           ID4=0
           IF(IBD.EQ.3) ID4=IMATCHNAME(1,READNAME3)
C-------------------------------   CHECKING THIS DECAY EXISTS
           ICHECKED=0
           IFOUNDPARENT=0     !! INDEX OF PARENT PARTICLE 
           ITHDECAY=0         !! INDEX OF ITS DECAY
           XDECFEED1=0.D0     !! TEMPORARY DECAY FEED COEFFICIENTS
           XDECFEED2=0.D0     !! INITIALIZED TO ZERO
           XDECFEED3=0.D0     !! 1st, 2nd, 3rd and fluctuations coefficient respectively
           XDECFEED4=0.D0
           DO 881 IPARENT=1,IHADS
              IF(IPARENT.EQ.ID1) THEN
                 DO 882 IB=1,IDEC(IPARENT)
                    DO 883 IDAUGH=1,3
                      IX(IDAUGH)=IPROD(IPARENT,IB,IDAUGH)
 883                ENDDO
           IF((ID2.EQ.IX(1)).AND.(ID3.EQ.IX(2)).AND.(ID4.EQ.IX(3))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
           IF((ID2.EQ.IX(1)).AND.(ID3.EQ.IX(3)).AND.(ID4.EQ.IX(2))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
           IF((ID2.EQ.IX(2)).AND.(ID3.EQ.IX(3)).AND.(ID4.EQ.IX(1))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
           IF((ID2.EQ.IX(3)).AND.(ID3.EQ.IX(2)).AND.(ID4.EQ.IX(1))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
           IF((ID2.EQ.IX(3)).AND.(ID3.EQ.IX(1)).AND.(ID4.EQ.IX(2))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
           IF((ID2.EQ.IX(2)).AND.(ID3.EQ.IX(3)).AND.(ID4.EQ.IX(1))) THEN
                      ICHECKED=ICHECKED+1
!!                      IDECAYMATRIX(IDX,1)=IPARENT
!!                      IDECAYMATRIX(IDX,2)=IB
                      IFOUNDPARENT=IPARENT
                      ITHDECAY=IB
        IF((ORDER.EQ.'1ST').OR.(ORDER.EQ.'1st')) XDECFEED2=FEEDN
        IF((ORDER.EQ.'2ND').OR.(ORDER.EQ.'2nd')) XDECFEED3=FEEDN
        IF((ORDER.EQ.'3RD').OR.(ORDER.EQ.'3rd')) XDECFEED1=FEEDN
        IF((ORDER.EQ.'COR').OR.(ORDER.EQ.'cor')) XDECFEED4=FEEDN
           ENDIF
 882             CONTINUE
c                 WRITE(*,*) 'ICHECKED ',ICHECKED
                 IF(ICHECKED.LT.1) THEN
                    IF(IBD.EQ.3) THEN
                       WRITE(*,*)  'PROBLEM WITH ',NAM(IDK(I)),'--->'
     1                 ,READNAME1,' ',READNAME2,' ',READNAME3
                    ELSE
                       WRITE(*,*)  'PROBLEM WITH ',NAM(IDK(I)),'--->'
     1                 ,READNAME1,' ',READNAME2
                    ENDIF
                    WRITE(*,*) 'EXPERIMENT DECAY CORRECTION (FILE '
     1              ,WEAKFILE,')'
                    IF(ICHECKED.EQ.0) WRITE(*,*) 'NOT IN PARTICLE TREE'
                    CALL CRASHPROGRAM
                 ENDIF
              ENDIF
 881       CONTINUE
           IF((ORDER.EQ.'ALL').OR.(ORDER.EQ.'all')) THEN
              DO 678 I1=1,3
                 XDECFEED1=FEEDN
                 XDECFEED2=FEEDN
                 XDECFEED3=FEEDN
                 XDECFEED4=FEEDN
 678          CONTINUE
           ENDIF
 677      CONTINUE
c
C  -- LOOKING FOR THE DECAY IN THE DECAY MATRIX...
          DO 1677 ID=1,IDECMX
            IF((IFOUNDPARENT.EQ.IDECAYMATRIX(ID,1)).AND.
     1 (ITHDECAY.EQ.IDECAYMATRIX(ID,2))) THEN 
               IDX=ID
C               WRITE(*,*) "FOUND DECAY ON ",IDX,"-TH PLACE IN MATRIX"
            ENDIF
1677      CONTINUE
C  -- NOW IDX CONTAINS THE DECAY POSITION in IDECAYMATRIX(IDX,*)
C     IF NOT FOUND, IDX CONTAINS ZERO AND PROGRAM WRITES OUT WHAT DECAY IT CRASHED ON (NEXT LINE)
          IF(IDX.EQ.0) THEN
            IF(IBD.EQ.3) THEN
               WRITE(*,*) "DECAY ",READNAME," --->  ",READNAME1,"  "
     1 ,READNAME2,"  ",READNAME3
            ELSE
               WRITE(*,*) "DECAY ",READNAME," --->  ",READNAME1,"  "
     1 ,READNAME2
            ENDIF
            WRITE(*,*) " NOT FOUND IN THE WEAK DECAY MATRIX."
            WRITE(*,*) " IS THE DECAY WEAK ?!?!."
            CALL CRASHPROGRAM
          ENDIF

C  -- THE DECAY IS FOUND, NOW THE CORRECTION COEFFICIENTS ARE CHANGED
            DECFEED(IDX,1)=XDECFEED1
            DECFEED(IDX,2)=XDECFEED2
            DECFEED(IDX,3)=XDECFEED3
            DECFEED(IDX,4)=XDECFEED4

          GO TO 134   !!! JUMP BACK TO READ ANOTHER LINE FROM THE WEAK DECAY FILE.

c------------------------ SWITCHING 2 AND 3 BODY DECAYS
 121      BACKSPACE IUNIT2
          I_READ_ERR=I_READ_ERR+1
          IF(I_READ_ERR.GT.10000) THEN
           WRITE(*,*) 'ERROR IN FEED-DOWN FILE'
           WRITE(*,*) 
     1     'LAST READ ',READNAME,' ',READNAME1,' ',READNAME2,FEEDN
           CALL CRASHPROGRAM
          ENDIF
          GO TO 114
 122      BACKSPACE IUNIT2
          I_READ_ERR=I_READ_ERR+1
          GO TO 116
 117      IF(WEAKFILE(6:9).NE.'HERE') CLOSE(IUNIT2)
 175      WRITE(61,*) 'INPUT FROM ',WEAKFILE,' READ SUCCESSFULLY'
        ENDIF
C==================================================================== 
C  END OF WEAK DECAY FILE READING
C==================================================================== 
      ELSE  !! I.E. IF SOMETHING ELSE THAN 'weakdecay" IS READ FROM THE EXPERIMENTAL DATA FILE
         READ(IUNIT,773,END=104) NAMDAT1,NAMDAT2,RATDAT1,ERR1,ERR2,IFIT1
         IF(NAMDAT2(1:5).EQ.'fluct') THEN
            IFLCTALL=1
            IF(NAMDAT2.NE.'fluct_yld') I_NORM=1
         ENDIF
c         write(*,*) 'nmdts: ',NAMDAT1,'/',NAMDAT2,' for ',iratdat
         NAMDATA(IRATDAT,1)=NAMDAT1
         NAMDATA(IRATDAT,2)=NAMDAT2
         RATDATA(IRATDAT)=RATDAT1
         DECDATA(IRATDAT)=WEAKFILE
         RATERR(IRATDAT)=ERR1+ERR2
         IF((NAMDAT2.EQ.'prt_yield').AND.(IFIT1.GT.0)) I_NORM=1
         IFIT(IRATDAT)=IFIT1
         WRITE(61,1031) NAMDATA(IRATDAT,1),NAMDATA(IRATDAT,2)
     1   ,RATDATA(IRATDAT),RATERR(IRATDAT),REAL(IFIT(IRATDAT))
         IF((RATERR(IRATDAT).LE.0D0).AND.(IFIT(IRATDAT).GT.0)) THEN
           WRITE(*,*) 'FIT DATAPOINT WITH ERROR=0 '
     1    ,NAMDATA(IRATDAT,1),NAMDATA(IRATDAT,2)
           CALL CRASHPROGRAM
         ENDIF
         IF(IRATDAT.GT.IRATMX) THEN
           WRITE(*,*) 'TOO MANY DATA POINTS'
           WRITE(*,*) 'TOO MANY DATA POINTS'
           CALL CRASHPROGRAM
         ENDIF
         IF((NAMDAT2(1:5).EQ.'solve').AND.(IRATDAT.GT.ISOLVMAX)) THEN
           WRITE(*,*) 'PLEASE PUT CONSERVATION EQUATIONS '
           WRITE(*,*) ' ON TOP OF EXPERIMENTAL INPUT FILE'
           CALL CRASHPROGRAM
         ENDIF
         WKF(IRATDAT)=WEAKFILE
C
!!   CORRECTING THE WEAK DECAY CHANNELS, MULTIPLYING BY A FACTOR DECFEED(IDX,1-4)
         DO 596 IDX=1,IDECMX
           DO 597 I1=1,4
             IF(IDECAYMATRIX(IDX,1).GT.0) THEN
!!      XBRFN1=BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,1)
              BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,1)
     1=       BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,1)
     1        *DECFEED(IDX,I1)
!!      XBRFN2=BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,2)
              BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,2)
     1=       BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,2)
     1        *DECFEED(IDX,I1)**2
c------------------------------------------------
!!      IF((WEAKFILE.NE.'NOWK_FEED').AND.(WEAKFILE.NE.'UNCORRECT'))THEN
!!            WRITE(*,*) "IDX = ",IDX
!!              IF(IBOD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2)).EQ.2) 
!!     1        WRITE(*,*) NAM(IDECAYMATRIX(IDX,1)),' -> '
!!     1       ,NAM(IPROD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),1))
!!     1,' ',NAM(IPROD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),2))
!!     1, ' decay put to ',DECFEED(IDX,I1)
!!     1, ' before branching= ',XBRFN1
!!!!     1,BR(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),1)
!!     1, ' now branching= '
!!     1,BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,1)
!!              IF(IBOD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2)).EQ.3) 
!!     1        WRITE(*,*) NAM(IDECAYMATRIX(IDX,1)),' -> '
!!     1       ,NAM(IPROD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),1))
!!     1,' ',NAM(IPROD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),2))
!!     1,' ',NAM(IPROD(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),3))
!!     1, ' decay put to ',DECFEED(IDX,I1)
!!     1, ' before branching= ',XBRFN2
!!!!     1,BR(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),1)
!!     1, ' now branching= '
!!     1,BRFN(IDECAYMATRIX(IDX,1),IDECAYMATRIX(IDX,2),IRATDAT,I1,1)
!!      ENDIF
c-----------------------------------------------
            ENDIF
 597       CONTINUE
 596     CONTINUE
         IF(NAMDAT2(1:5).EQ.'solve') ISOLVMAX=ISOLVMAX+1
         IRATDAT=IRATDAT+1
 773     FORMAT(A9,2X,A9,3F12.7,I17)
 113     FORMAT(A9,2X,A9)
 1031    FORMAT(A9,2X,A9,4F12.7,I17)
      ENDIF
      GO TO 110
 104  IF(TOTFILE(11:14).NE.'HERE') CLOSE(1)
      ISOLVMAX=ISOLVMAX-1
      IRATDAT=IRATDAT-1
c      write(*,*) 'irat ',isolvmax,iratdat
      RETURN
      END


      SUBROUTINE READ_RATIO_SET(SETFILE)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      CHARACTER*13 SETFILE
      CHARACTER*4  NAMRT
      IF(SETFILE(10:13).NE.'HERE') THEN
        IUNIT=1
        OPEN(1,FILE=SETFILE,STATUS="OLD")
      ELSE
        IUNIT=51
      ENDIF
      I=0
 177  I=I+1
        IF(IREADCOMMENT(IUNIT).GT.0) THEN
         IF(I.LE.IPRT) THEN
           WRITE(*,*) 'ERROR, SETFILE ENDED PREMATURELY'
           CALL CRASHPROGRAM
         ELSE
           GO TO 178
         ENDIF
        ENDIF
        READ(IUNIT,104) NAMRT,LLMRT,ULMRT,STPRT,IFIXRT
        WRITE(61,9104) 
     1  NAMRT,LLMRT,ULMRT,STPRT,IFIXRT
        LLMRAT(IFINDPAR(NAMRT))=LLMRT
        ULMRAT(IFINDPAR(NAMRT))=ULMRT
        STPRAT(IFINDPAR(NAMRT))=STPRT
        IFIXRAT(IFINDPAR(NAMRT))=IFIXRT
        IF((NAMRAT(I).EQ.'mui3').AND.(ILAM3MU3.EQ.0)) NAMRAT(I)='lmi3'
        IF((NAMRAT(I).EQ.'mu_b').AND.(ILAMQMUQ.EQ.0)) NAMRAT(I)='lamq'
        IF((NAMRAT(I).EQ.'mu_s').AND.(ILAMSMUS.EQ.0)) NAMRAT(I)='lams'
        IF((NAMRAT(I).EQ.'mu_c').AND.(ILAMCMUC.EQ.0)) NAMRAT(I)='lamc'
C-------------------------------------
        IF((NAMRAT(I).EQ.'lmi3').AND.(ILAM3MU3.EQ.1)) NAMRAT(I)='mui3'
        IF((NAMRAT(I).EQ.'lamq').AND.(ILAMQMUQ.EQ.1)) NAMRAT(I)='mu_b'
        IF((NAMRAT(I).EQ.'lamq').AND.(ILAMSMUS.EQ.1)) NAMRAT(I)='mu_s'
        IF((NAMRAT(I).EQ.'lamc').AND.(ILAMCMUC.EQ.1)) NAMRAT(I)='mu_c'
c---------------------------------------------
        IF((NAMRAT(I).EQ.'gamq').AND.(IFIXRT.EQ.2)) THEN
           LLMRAT(IFINDPAR(NAMRT))=0D0
           ULMRAT(IFINDPAR(NAMRT))=1D0
        ENDIF
        IF(NAMRAT(I).EQ.'gsgq') THEN
c           NAMRAT(I)='gams'
           WRITE(61,*) 'FITTING GAMS/GAMQ'
           IGSGQ=1
        ENDIF 
        WRITE(61,9105) 
     1  NAMRAT(I),LLMRAT(I),ULMRAT(I),STPRAT(I),IFIXRAT(I)
C        WRITE(61,*) ""
      GO TO 177
9104  FORMAT("READ    : ",A4,3X,F17.4,X,F17.4,X,F9.5,I4)
9105  FORMAT("WRITTEN : ",A4,3X,F17.4,X,F17.4,X,F9.5,I4)
 104  FORMAT(A4,3X,2F7.1,F7.4,I4)
 178  CONTINUE
      IF(SETFILE(10:13).NE.'HERE') CLOSE(1)
      RETURN
      END


c-------------------------- MINUIT INITIALIZATION AND NDOF CALCULATION

      SUBROUTINE MIN_INIT(INUM1,IDATCHK)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      CHARACTER*9 NAM1
      CHARACTER*4 NAMSOLVE
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      IERR=0
      IF(IDATCHK.EQ.1) CALL DATACHECK
      DO 106 I=1,IRATDAT
         NAM1=NAMDATA(I,2)
         IF(NAM1(1:5).EQ.'solve') THEN
            NAMSOLVE=NAM1(6:9)
            ISOLVE(I)=IFINDPAR(NAMSOLVE)
            IFIXRAT(ISOLVE(I))=0
         ELSE
            ISOLVE(I)=0
         ENDIF
 106  CONTINUE  
      IF(INUM1.NE.IFINDPAR('temp')) PARRAT(IFINDPAR('temp'))=T
      IF(INUM1.NE.IFINDPAR('lamq')) PARRAT(IFINDPAR('lamq'))=LAMQ
      IF(INUM1.NE.IFINDPAR('lams')) PARRAT(IFINDPAR('lams'))=LAMS
      IF(INUM1.NE.IFINDPAR('gamq')) PARRAT(IFINDPAR('gamq'))=GAMQ
      IF(INUM1.NE.IFINDPAR('gams')) PARRAT(IFINDPAR('gams'))=GAMS
      IF(INUM1.NE.IFINDPAR('lmi3')) PARRAT(IFINDPAR('lmi3'))=LMI3
      IF(INUM1.NE.IFINDPAR('norm')) PARRAT(IFINDPAR('norm'))=NORM
      IF(INUM1.NE.IFINDPAR('lamc')) PARRAT(IFINDPAR('lamc'))=LAMC
      IF(INUM1.NE.IFINDPAR('Ncbc')) PARRAT(IFINDPAR('Ncbc'))=NCBC
      IF(INUM1.NE.IFINDPAR('dvol')) PARRAT(IFINDPAR('dvol'))=DVOL
      IF(INUM1.NE.IFINDPAR('gam3')) PARRAT(IFINDPAR('gam3'))=GAM3
      IF(I_NORM.EQ.0) THEN
         IFIXRAT(IFINDPAR('norm'))=0
         WRITE(61,*) 'NORM FIXED'
      ENDIF
      IFREERAT=0
      IPLOTRAT=0
      IWRITERAT=0
!!      IEVAL=0
      FVALBEFORE=1D4
      DO 43 I=1,IPRT
         IF((IFIXRAT(I).LE.0).OR.(I.EQ.INUM1)) STPRAT(I)=0D0
         IF(IFIXRAT(I).GT.0) THEN
            IFREERAT=IFREERAT+1
C            WRITE(*,*) NAMRAT(I)," free"
         ENDIF
 43   CONTINUE
      IDATRATIOS=0
      DO 109 I=1,IRATMX
         IFITNOW=0    
         IF((IFIT(I).GT.0).AND.(ISOLVE(I).LE.0)) IFITNOW=1
 109     IDATRATIOS=IDATRATIOS+IFITNOW 
      IFDGRAT=IDATRATIOS-IFREERAT
      WRITE(61,*) IDATRATIOS,' DATA POINTS ',IFREERAT
     1,' FREE PARAMETERS ',IFDGRAT,' DoF'
      IF((IFDGRAT.LE.0).AND.(IDATRATIOS.GT.0)) THEN
       WRITE(*,*) 'DOF<0, POINTS: ',IDATRATIOS,'PARAMETERS ',IFREERAT
       CALL CRASHPROGRAM
      ENDIF
      CALL MNINIT(5,61,7)
      DO 47 I=1,IPRT
         IF(ULMRAT(I).LT.LLMRAT(I)) ULMRAT(I)=1D7
         IF((PARRAT(I).NE.0D0).AND.(INUM1.LT.0))
     1   STPRAT(I)=DABS(STPRAT(I)*PARRAT(I))
         IF((IFIXRAT(I).GT.0).AND.(I.NE.INUM1).AND.STPRAT(I).EQ.0D0) 
     1   STPRAT(I)=DBLE(0.001)
C         write(*,*) I,NAMRAT(I),PARRAT(I),STPRAT(I),LLMRAT(I),ULMRAT(I)
 47   CALL 
     1MNPARM(I,NAMRAT(I),PARRAT(I),STPRAT(I),LLMRAT(I),ULMRAT(I),IERR)
      RETURN
      END

C-------------------------- CHI**2 MINIMIZATION

      SUBROUTINE MIN_RATIOS(IUNIT,INUM1,IMINOS,ILATEX1)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      EXTERNAL FCNRAT
      DIMENSION GRAD(IPRT),PARRAT2(IPRT),STPRAT2(IPRT)
      REAL PROB,FITSIG
      ILATEX=ILATEX1
C      WRITE(*,*) 'FIT_RATIOS STARTED, DATACEHCK FOLLOWS'
      CALL DATACHECK
C      WRITE(*,*) 'DATACHECK DONE, FIXVALSRAT FOLLOWS'
      CALL FIXVALSRAT(PARRAT)
C      WRITE(*,*) 'FIXVALSRAT DONE'
         DO 616 I=1,IPRT
           PARRAT2(I)=PARRAT(I)
           STPRAT2(I)=STPRAT(I)
 616     CONTINUE
      IWRITERAT=0
      WRITE(IUNIT,*) 'MINIMIZATION BEGINNING: '
      CALL DATETIME(IUNIT)
      CALL MIN_INIT(INUM1,1)
C      CALL MNCOMD(FCNRAT,'MIGRAD 5000000',IERR,DBLE(0))
      CALL MNCOMD(FCNRAT,'MINIMIZE',IERR,DBLE(0))
c      CALL MNCOMD(FCNRAT,'MINOS 5000000',IERR,DBLE(0))
c      write(*,*) 'min complete ',T,FMIN
c      WRITE(IUNIT,*) 'MINIMIZATION ENDED: '
c      CALL DATETIME(IUNIT)
c      WRITE(IUNIT,*) 'UNITS:  ENERGY IN GeV, DENSITY IN 1/fm^3'
c      write(*,*) 'inums ',INUM1,IERR,IMINOS
      IF(IERR.NE.0) THEN
        IF(IMINOS.GT.0) THEN
          write(*,*) 'using minos now '
C          CALL MNCOMD(FCNRAT,'MINOS 5000000',IERR,DBLE(0))
          CALL MNCOMD(FCNRAT,'MINOS 5000000',IERR,DBLE(0))
          WRITE(IUNIT,*) 'MINOS USED'
        ENDIF
        IF(IERR.NE.0) THEN
          WRITE(IUNIT,*) 'MINUIT HAD TROUBLE FINDING CONTOUR'
          WRITE(IUNIT,*) 'CLOSE MULTIPLE MINIMA MIGHT BE PRESENT'
          WRITE(IUNIT,*)  
     1'IT IS SUGGESTED CONTOUR OR PROFILE BE CALCULATED EXPLICITLY'
          WRITE(IUNIT,*) 'OR MULTIPLE MINIMIZATION STRATEGIES BE TRIED'
          WRITE(61,*) 'MINUIT HAD TROUBLE FINDING CONTOUR'
          WRITE(61,*) 'CLOSE MULTIPLE MINIMA MIGHT BE PRESENT'
          WRITE(61,*)
     1'IT IS SUGGESTED CONTOUR OR PROFILE BE CALCULATED EXPLICITLY'
          WRITE(61,*) 'OR MULTIPLE MINIMIZATION STRATEGIES BE TRIED'
        ENDIF
      ENDIF
      WRITE(IUNIT,*) 'MINIMIZATION ENDED: '
      CALL DATETIME(IUNIT)
      WRITE(IUNIT,*) 'UNITS:  ENERGY IN GeV, DENSITY IN 1/fm^3'
      DO 116 I=1,IPRT
       CALL MNPOUT(I,TITRAT(I),MNVALRAT(I),MNRRAT(I),XLIML,XMLIMH,IV)
       PARRAT(I)=MNVALRAT(I)
 177   FORMAT(1X,A4,2X,F16.8,1X,A3,F16.8,A9,2F11.4)
       IF(STPRAT(I).NE.0D0) THEN
          WRITE(IUNIT,177) TITRAT(I),MNVALRAT(I),'+/-',0.5D0*MNRRAT(I)
     1,' limits: ',XLIML,XMLIMH
          WRITE(61,177) TITRAT(I),MNVALRAT(I),'+/-',0.5D0*MNRRAT(I)
     1,' limits: ',XLIML,XMLIMH
       ELSE
          WRITE(IUNIT,'(1X,A4,2X,F16.8)') TITRAT(I),PARRAT(I)
          WRITE(61,'(1X,A4,2X,F16.8)') TITRAT(I),PARRAT(I)
      ENDIF
C      IF(ILATEX.GT.0) 
C     1    CALL MULTIWRITE(ILATEX,TITRAT(I),PARRAT(I),0.5*MNNRAT(I))
 116  CONTINUE
C      WRITE(IUNIT,*) 'GAMQ ',GAMQ,' CONDENSATION AT ',GAMQLM(MPI,T,GAMQ)
      CALL FCNRAT(IFREERAT,GRAD,FMIN,PARRAT,IFLAG,DBLE(0))

      ERRTEMP=0.5D0*MNRRAT(IFINDPAR('temp'))
      ERRLAMQ=0.5D0*MNRRAT(IFINDPAR('lamq'))
      ERRLAMS=0.5D0*MNRRAT(IFINDPAR('lams'))
      ERRLMI3=0.5D0*MNRRAT(IFINDPAR('lmi3'))
C      ERRLAMC=0.5D0*MNRRAT(IFINDPAR('lamc'))
C      ERRLAMB=0.5*MNRRAT(IFANDPAR('lamb'))
      ERRMUB=DABS(3D0*(ERRTEMP*DLOG(LAMQ)+T*ERRLAMQ/LAMQ))
      ERRMUS=DABS(ERRTEMP*DLOG(LAMS/LAMQ)+T*(ERRLAMS/LAMS+ERRLAMQ/LAMQ))
      ERRMU3=DABS(ERRTEMP*DLOG(LMI3)+T*ERRLMI3/LMI3)
      ERRGAMQ=0.5D0*MNRRAT(IFINDPAR('gamq'))
      ERRGAM3=0.5D0*MNRRAT(IFINDPAR('gam3'))
      ERRGAMS=0.5D0*MNRRAT(IFINDPAR('gams'))
      ERRGAMU=GAMU*DSQRT((ERRGAMQ/GAMQ)**2+(ERRGAM3/GAM3)**2)
      ERRGAMD=GAMD/GAMU*ERRGAMU
      ERRNCBC=0.5D0*MNRRAT(IFINDPAR('Ncbc'))
      ERRGAMC=0.D0
      IF(NCBC>0.D-3) ERRGAMC=REALGAMC*0.5D0*(ERRNCBC/NCBC)
      ERRTC2T=0.5D0*MNRRAT(IFINDPAR('tc2t'))
C debug
C      WRITE(*,*) 'ERRTEMP = ',ERRTEMP
C      WRITE(*,*) 'ERRTC2T = ',ERRTC2T
C end debug
      ERRTCHARM=T*TC2T*DSQRT((ERRTEMP/T)**2+(ERRTC2T/TC2T)**2)
C      WRITE(*,*) 'ERRTCHARM = ',ERRTCHARM
C      ERRMUC=DABS(ERRTEMP*DLOG(LAMQ*LAMC)+T*(ERRLAMC/LAMC+ERRLAMQ/LAMQ))
C      ERRMUBOT=DABS(ERRTEMP*DLOG(LAMB/LAMQ)+T
C     1*(ERRLAMB/LAMB+ERRLAMQ/LAMQ))
      WRITE(IUNIT,'(/1X,A7,2X,F10.5,X,A3,X,F11.6)') 
     1 'T_charm ',T*TC2T,'+/-',ERRTCHARM
      WRITE(IUNIT,'(/X,A20)') 'CHEMICAL POTENTIALS:'
 193  FORMAT(1X,A4,2X,E11.4,1X,A3,1X,E11.4,A5)
      WRITE(IUNIT,193) 'MU_B   ',MUBFUNC(T,LAMQ),'+/-',ERRMUB,' GeV'
      WRITE(IUNIT,193) 'MU_S   ',MUSFUNC(T,LAMS,LAMQ),'+/-',ERRMUS
     1,' GeV'
C      WRITE(IUNIT,193) 'MU_C   ',MUCFUNC(T,LAMC,LAMQ),'+/-',ERRMUC
C     1,' GeV'
C      WRITE(IUNIT,193) 'MU_BOT ',MUBOTFUNC(T,LAMB,LAMQ),'+/-',ERRMUBOT
C     1,' GeV'
      WRITE(IUNIT,193) 'MUI3   ',T*DLOG(LMI3),'+/-',ERRMU3,' GeV'
9193  FORMAT(1X,A7,2X,F11.5,1X,A3,1X,F11.6)
      WRITE(IUNIT,'(/1X,A12)') 'PHASE SPACE:'
      WRITE(IUNIT,9193) 'gamma_u',GAMU,'+/-',ERRGAMU
      WRITE(IUNIT,9193) 'gamma_d',GAMD,'+/-',ERRGAMD
      WRITE(IUNIT,9193) 'gamma_s',GAMS,'+/-',ERRGAMS
      WRITE(IUNIT,9193) 'gamma_c',REALGAMC,'+/-',ERRGAMC
      WRITE(61,193) 'MU_B   ',MUBFUNC(T,LAMQ),'+/-',ERRMUB,' GeV'
      WRITE(61,193) 'MU_S   ',MUSFUNC(T,LAMS,LAMQ),'+/-',ERRMUS,' GeV'
C      WRITE(61,193) 'MU_C   ',MUCFUNC(T,LAMC,LAMQ),'+/-',ERRMUC,' GeV'
C      WRITE(61,193) 'MU_BOT ',MUBOTFUNC(T,LAMB,LAMQ),'+/-',ERRMUBOT
C     1,' GeV'
      WRITE(61,193) 'MU_I3  ',T*DLOG(LMI3),'+/-',ERRMU3,' GeV'
C      IF(ILATEX.GT.0) THEN
C       WRITE(ILATEX,*) '\multicolomn(6){|c|}{Chemical potentials (GeV)'
C         CALL MULTIWRITE(ILATEX,'$\mu_B$',MUBFUNC(T,LAMQ),ERRMUB)
C         CALL MULTIWRITE(ILATEX,'$\mu_s$',MUBSUNC(T,LAMQ),ERRMUS)
C         CALL MULTIWRITE(ILATEX,'$\mu_3$',T*DLOG(LMI3),ERRMU3
C      ENDIF
      WRITE(61,9193) 'gamma_u',GAMU,'+/-',ERRGAMU
      WRITE(61,9193) 'gamma_d',GAMD,'+/-',ERRGAMD
      WRITE(61,9193) 'gamma_s',GAMS,'+/-',ERRGAMS
      WRITE(61,9193) 'gamma_c',REALGAMC,'+/-',ERRGAMC
      IWRITERAT=IUNIT
      CALL FCNRAT(IFREERAT,GRAD,FMIN,PARRAT,IFLAG,DBLE(0))
      IWRITERAT=0
      WRITE(IUNIT,*)
     1 'DATA POINTS:',IDATRATIOS,' PARAMETERS:',IFREERAT
     1,' DoF:' ,IFDGRAT
      WRITE(61,*)
     1 'DATA POINTS:',IDATRATIOS,' PARAMETERS:',IFREERAT
     1,' DoF:' ,IFDGRAT
      WRITE(IUNIT,*) 'TOTAL CHI**2/DEG. OF FREEDOM',FMIN
      WRITE(IUNIT,*) 'TOTAL CHI**2',FMIN*IFDGRAT
      FITSIG=PROB(REAL(FMIN*DBLE(IFDGRAT)),IFDGRAT)
      WRITE(IUNIT,*) ' SIGNIFICANCE OF FIT: ',FITSIG
C      IF(ILATEX.GT.0) THEN
C         WRITE(ILATEX,*) '\hline'
C         WRITE(ILATEX,199) '\multicolumn{2}{|c|}{ DATA POINTS: '
C     1,IDATRATIOS
C     1,'} & \multicolumn{2}{|c|}{PARAMETERS:',IFREERAT
C     1,'} & \multicolumn{2}{|c|}{DoF ',IFDGRAT,'} \\'
C 199     FORMAT(1X,A40,I10,A40,I1,A40,I10,A5)
C         WRITE(ILATEX,201) 
C     1   '\multicolumn{3}{|c|}{$\chi^2$ } & \multicolumn{3}{|c|}{'
C     1   FMIN,'}  \\'
C         WRITE(ILATEX,201) 
C     1   '\multicolumn{3}{|c|}{$\chi^2$ } & \multicolumn{3}{|c|}{'
C     1   STATSIG,'}  \\'
C 201     FORMAT(1X,A50,F10.2,A7)
C      ENDIF
      SHADAV=1D0
      IF(HADAV(0,0,TOTSTRANGE).NE.0D0) 
     1 SHADAV=HADAV(0,0,TOTSTRANGE)
      WRITE(IUNIT,*) '[ (S-SBAR)/(S+SBAR) ] '
     1,HADAV(0,0,NETSTRANGE)/SHADAV
      WRITE(61,*) 'TOTAL CHI**2/DEG. OF FREEDOM',FMIN
      WRITE(61,*) 'TOTAL CHI**2',FMIN*IFDGRAT
      WRITE(61,*) '[ (S-SBAR)/(S+SBAR) ] '
     1,HADAV(0,0,NETSTRANGE)/SHADAV
         DO 617 I=1,IPRT
           PARSPARE(I)=PARRAT(I)
c           IF(STPRAT2(I).GT.0D0) PARRAT(I)=PARRAT2(I)
           IF(PARRAT2(I).GT.0D0) STPRAT(I)=STPRAT2(I)
 617    CONTINUE
C      IF(ILATEX.GT.0) THEN
C         WRITE(ILATEX,*) '\end{tabular}'
C         WRITE(ILATEX,*) '\end{table}'
C      ENDIF
      RETURN
      END

c       SUBROUTINE MULTIWRITE(ILATEX,TITLE,XDATA,ERROR)
c       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
c       IMPLICIT INTEGER(I)
c       CHARACTER*5 TITLE
c         WRITE(ILATEX,199) '\multicolumn{2}{|c|}{',TITLE
c     1,'} & \multicolumn{2}{|c|}{',XDATA
c     1,'} & \multicolumn{2}{|c|}{',ERROR,'} \\'
c 199     FORMAT(1X,A22,A7,A30,F10.2,A30,F10.2,A5)
c       RETURN
c       END

C-------------------------- 2D GRAPH

        SUBROUTINE PROF2D
     1(FLNAME,IPT,IPAR1,IPAR2,LIM11,LIM12,LIM21,LIM22,IPT1,IPT2)
         IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
        COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
        PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
        DIMENSION XVAL(IPRT)
        CHARACTER*12 FLNAME
        IWRITERAT=0
        DO 111 I=1,IPRT
 111       XVAL(I)=-1D0
        CALL MIN_INIT(-1,1)
        XVALBEFORE1=XVAL(IPAR1)
        XVALBEFORE2=XVAL(IPAR2)
        OPEN(3,FILE=FLNAME,STATUS='UNKNOWN')
        DO 112 I1=1,IPT1
           DO 113  I2=1,IPT2 
              XVAL(IPAR1)=LIM11+(LIM12-LIM11)*DBLE(I1-1)/DBLE(IPT1)
              XVAL(IPAR2)=LIM21+(LIM22-LIM21)*DBLE(I2-1)/DBLE(IPT2)
              CALL FIXVALSRAT(XVAL)
              CALL SOLVE_EXACT(XVAL)
              CALL FILL_CHEM(0,0)
              CALL CALCYIELDS
              DATAPT=FINDYIELDS(IPT)
 211          FORMAT(1X,3F15.5)
              IF(CHEMFACT.EQ.1.D0) THEN
                 WRITE(3,211) XVAL(IPAR1),XVAL(IPAR2),DATAPT
              ELSE
                 WRITE(61,*) 'CHEMICAL POTENTIAL ABOVE CRITICAL ',
     1' FOR ',NAMRAT(IPAR1),'=',XVAL(IPAR1),' ',NAMRAT(IPAR2),'=',
     1            XVAL(IPAR2)
                 WRITE(3,211) XVAL(IPAR1),XVAL(IPAR2),-1D0
              ENDIf
 113       CONTINUE
 112    CONTINUE
        CLOSE(3)
        XVAL(IPAR1)=XVALBEFORE1
        XVAL(IPAR2)=XVALBEFORE2
        RETURN
        END

C-------------------------- 1D GRAPH

      SUBROUTINE PROF1D(FLNAME,IPR,IPAR,LIM1,LIM2,IPT)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
        PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
        DIMENSION XVAL(IPRT)
        CHARACTER*12 FLNAME
        CALL DATACHECK
        IWRITERAT=0
        DO 111 I=1,IPRT
 111       XVAL(I)=-1D0
c        write(*,*) 'gams0 is ',GAMS
        CALL FIXVALSRAT(XVAL)
c        write(*,*) 'gams is ',GAMS
        XVALBEFORE=XVAL(IPAR)
        OPEN(3,FILE=FLNAME,STATUS='UNKNOWN')
        DO 112 I=1,IPT
              XVAL(IPAR)=LIM1+(LIM2-LIM1)*DBLE(I)/DBLE(IPT)
              CALL FIXVALSRAT(XVAL)
c        write(*,*) 'gams2 is ',GAMS
              CALL FILL_CHEM(0,0)
              CALL CALCYIELDS
              DATAPT=FINDYIELDS(IPR)
C 211          FORMAT(1X,2F15.5)
c              IF(CHEMFACT.EQ.1D0) THEN
                 WRITE(3,*) XVAL(IPAR),DATAPT
c              ENDIF
 112    CONTINUE
        XVAL(IPAR)=XVALBEFORE
        CALL FIXVALSRAT(XVAL)
c        write(*,*) 'gams3 is ',GAMS
        CLOSE(3)
        RETURN
        END

C-------------------------- CHI**2 CONTOUR

        SUBROUTINE RATIOCONTOUR(FLNAME,PARNAME1,PARNAME2,CHIPREC)
         IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
        PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
        PARAMETER(IPTNS=40)
        DIMENSION ARR1(IPTNS),ARR2(IPTNS)
        CHARACTER*9 FLNAME
        CHARACTER*4 PARNAME1,PARNAME2
        EXTERNAL FCNRAT
        INUM1=IFINDPAR(PARNAME1)
        INUM2=IFINDPAR(PARNAME2)
        IWRITERAT=0
        CALL DATACHECK
        DO 112 I=1,IPTNS
        ARR2(I)=0D0
 112    ARR1(I)=0D0
        IF((IFIXRAT(INUM1).LE.0D0).OR.(IFIXRAT(INUM2).LE.0)) THEN
            WRITE(61,*) 'ONE OR BOTH CONTOUR PARAMETERS FIXED '
     1,IFIXRAT(INUM1),IFIXRAT(INUM2)
            WRITE(61,*) 'FIXING THAT!'
            IFIXRAT(INUM1)=1
            IFIXRAT(INUM2)=1
        ENDIF
        CALL MIN_INIT(-1,1)
        WRITE(61,*) 'PLOTTING CONTOUR FOR ',INUM1,INUM2,' POINTS ',IPTNS
     1,' DEVIATION ',CHIPREC
        CALL MNEXCM(FCNRAT,'SET ERR',CHIPREC,1,IERR,DBLE(0))
        IF(IERR.GT.0) WRITE(61,*) 'WARNING: SET ERR ERROR ',IERR
        CALL MNCONT(FCNRAT,INUM1,INUM2,IPTNS,ARR1,ARR2,IFOUND,0)
        CALL MNEXCM(FCNRAT,'SET ERR',1D0,1,IERR,DBLE(0))
        OPEN(3,FILE=FLNAME,STATUS='UNKNOWN')
        DO 111 I=1,IPTNS
 111    IF((ARR1(I).GE.LLMRAT(INUM1))
     1  .AND.(ARR2(I).LE.ULMRAT(INUM2))) WRITE(3,*) ARR1(I),ARR2(I)
        CLOSE(3)
        RETURN
        END

C-------------------------- CHI**2 PROFILE

       SUBROUTINE RATCPRF(FLNAME,PARNAME,LOW,UP,IPTN,ICHISIG,IDT,IDP)
         IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
        COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
        PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      COMMON /MINFLAGS/ IPRFMINOS
        CHARACTER*12 FLNAME
        CHARACTER*17 FLNAME2,FLNAME3,FLNAME4,FLNAME5
     1,FLNAME6,FLNAME7,FLNAME8
        CHARACTER*4 PARNAME
        EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
        EXTERNAL FCNRAT
       REAL PROB
        MINPARVAL=1D0
C      
c---------------------global min-----------
        IF(IDP.EQ.3) THEN
          CALL MIN_RATIOS(61,0,1,-1)
          IF(IDT.GT.0) THEN
             MINPARVAL=RATTHEO(IDT)
             WRITE(61,*) 'MINPARVAL= ',MINPARVAL,' AT '
     1,NAMRAT(IFINDPAR(PARNAME)),'=',PARRAT(IFINDPAR(PARNAME))
          ENDIF
        ENDIF
c---------------------------------
        INUM1=IFINDPAR(PARNAME)
        IWRITERAT=0
        CALL DATACHECK
        FLNAME2='profvcblrsns_temp' 
        FLNAME3='profvcblrsns__log'
        FLNAME4='profvcblrsns_dat1'
        FLNAME5='profvcblrsns_dat2'
        FLNAME6='profvcblrsns.prof'
        FLNAME7='profvcblrsns.chi2'
        FLNAME8='profvcblrsns.stsg'
        WRITE(61,*) '================================='
        WRITE(61,*) 'PLOTTING PROFILE FOR ',INUM1
        WRITE(61,*) 'LOW, UP, POINTS ',REAL(LOW),REAL(UP),IPTN
        IF(IPRFMINOS.GT.0) THEN
           WRITE(61,*) '(MINOS USED WHEN NECESSARY)'
        ELSE
           WRITE(61,*) '(MINOS NOT USED)'
        ENDIF
        WRITE(61,*) '================================='
        CALL CCOPYL(FLNAME,FLNAME3,12)
        CALL CCOPYL(FLNAME,FLNAME4,12)
        CALL CCOPYL(FLNAME,FLNAME5,12)
        CALL CCOPYL(FLNAME,FLNAME6,12)
        CALL CCOPYL(FLNAME,FLNAME7,12)
        CALL CCOPYL(FLNAME,FLNAME8,12)
        WRITE(*,*) 'FIT LOG WRITTEN TO ',FLNAME3
        IF(IPRFMINOS.GT.0) THEN
           WRITE(*,*) " MINOS USED WHEN NECESSARY"
        ELSE
           WRITE(*,*) " MINOS NOT USED"
        ENDIF
        OPEN(10,FILE=FLNAME3,STATUS='UNKNOWN')   
        OPEN(3,FILE=FLNAME6,STATUS='UNKNOWN')
      IF(IDT.NE.0) THEN
          OPEN(4,FILE=FLNAME4,STATUS='UNKNOWN')
          OPEN(5,FILE=FLNAME5,STATUS='UNKNOWN')
          OPEN(16,FILE=FLNAME7,STATUS='UNKNOWN')
          OPEN(36,FILE=FLNAME8,STATUS='UNKNOWN')
        ENDIF
       WRITE(*,*) 'PROFILE TO FILE ',FLNAME6
        DO 117 I=1,IPRT
            IF((I.NE.INUM1).AND.(IFIXRAT(I).EQ.1)) THEN
              CALL CCOPYL(FLNAME,FLNAME2,12)
              FLNAME2(14:17)=NAMRAT(I)
              WRITE(*,*) 'CORRELATION FOR ',NAMRAT(I),' IS IN FILE '
     1,FLNAME2,' '
              OPEN(20+I,FILE=FLNAME2,STATUS='UNKNOWN')
 177          FORMAT(1X,5A20)
              WRITE(20+I,177) " PARAMETER "," PARAMETER2 "
     1," BULK "
     1, " CHI2/NDOF "," STAT.SIG. "
              WRITE(61,*) 'PARAMETER ',I,' TO ',FLNAME2
            ENDIF
 117    CONTINUE
C
        IFIXRAT(INUM1)=0 !! fixing the profile parameter
C        WRITE(*,*) "Fixed ",NAMRAT(INUM1)
C
        DO 121 IPT=0,IPTN
C-------------------- RESETTING PARAMETERS
c         CALL FIXVALSRAT(PARORIG)
c         DO 176 I=1,IPRT
c 176        STPRAT(I)=STPRAT2(I)
C----------------------------------------
         PARRAT(INUM1)=LOW+(UP-LOW)*DBLE(IPT)/DBLE(IPTN)
         IPOINT=0
         WRITE(61,*) '---------------------------------------------'
         WRITE(61,*) 'PLOTTING ',PARRAT(INUM1),' POINT ',IPT,' OF ',IPTN
         WRITE(10,*) '---------------------------------------------'
         WRITE(10,*) 'PLOTTING ',PARRAT(INUM1),' POINT ',IPT,' OF ',IPTN
c--------------------------- if one wants to reset parameters----------------
c         WRITE(*,*) 'PLOTTING ',PARRAT(INUM1),' POINT ',IPT,' OF ',IPTN
C         IF(IPT.EQ.1) THEN
C           CALL MIN_RATIOS(10,INUM1,0,-1)
C           FMIN=FVALBEFORE
C         ENDIF
c-----------------------------------------------
c         CALL MIN_RATIOS(10,INUM1,0,-1)
         CALL MIN_RATIOS(10,INUM1,IPRFMINOS,-1)
         IF(CHEMFACT.EQ.1D0) IPOINT=1
c         IF((CHEMFACT.EQ.1D0).AND.(IERR.EQ.0)) IPOINT=1
c         write(*,*) 'min_ratios finished'
         FMIN=FVALBEFORE
c         CALL FCNRAT(IFREERAT,GRAD,FMIN,PARRAT,IFLAG,DBLE(0))
c         WRITE(*,*) 'CHIPROF ',PARRAT(INUM1),CHEMFACT,FMIN
         STATSIG2=DBLE(PROB(REAL(FMIN*DBLE(IFDGRAT)),IFDGRAT))
         FMINTRUE=FMIN
         IF(ICHISIG.EQ.1) FMIN=STATSIG2
         IF(IDT.GT.0) THEN
           CHISQUARED=FMIN
           STATSIG=DBLE(PROB(REAL(FMIN*DBLE(IFDGRAT)),IFDGRAT))
           IF((IDP.EQ.1).OR.(IDP.EQ.3)) FMIN=RATTHEO(IDT)
           IF(IDP.EQ.2) FMIN=CHITRM(IDT)
           FMIN=FMIN/MINPARVAL
c           write(*,*) 'minparval ',IDT,IDP,FMIN,MINPARVAL
           IF(IPOINT.GT.0) WRITE(16,*) PARRAT(INUM1),CHISQUARED
           IF(IPOINT.GT.0) WRITE(36,*) PARRAT(INUM1),STATSIG
           IF((IPT.EQ.0).OR.(IPT.EQ.IPTN)) THEN
             WRITE(4,*) PARRAT(INUM1),RATDATA(IDT)-RATERR(IDT)
             WRITE(5,*) PARRAT(INUM1),RATDATA(IDT)+RATERR(IDT)
           ENDIF
         ENDIF
C         WRITE(3,*) PARRAT(INUM1),FMIN
c         IF((IPOINT.GT.0).AND.(IERR.EQ.0)) 
         IF((IPOINT.GT.0).AND.(FMIN.NE.0D0))
     1   WRITE(3,*) PARRAT(INUM1),FMIN
         WRITE(61,*) 'DATA POINT FOR ',INUM1,' IS ',PARRAT(INUM1),FMIN
c         WRITE(*,*) IPT,' PT OF ',IPTN,' IS ',INUM1,PARRAT(INUM1),FMIN
         DO 119 I=1,IPRT
C         IF((I.NE.INUM1).AND.(IFIXRAT(I).EQ.1)) THEN
            IF((I.NE.INUM1).AND.(IFIXRAT(I).EQ.1).AND.(CHEMFACT.EQ.1)) 
     1      THEN
                 EXTVAL=1
                 IF(NAMRAT(I).EQ."temp") EXTVAL=TOTBULK(0,1,-1)
               IF((NAMRAT(I).EQ."lamq").OR.(NAMRAT(I).EQ."mu_b")) 
     1           EXTVAL=HADAV(0,0,NETBAR)
                 IF((NAMRAT(I).EQ."lams").OR.(NAMRAT(I).EQ."mu_s"))     
     1           EXTVAL=HADAV(0,0,NETSTRANGE)
                 IF((NAMRAT(I).EQ."lmi3").OR.(NAMRAT(I).EQ."mui3"))     
     1           EXTVAL=HADAV(0,0,NETCHARGE)
                 IF((NAMRAT(I).EQ."gams").OR.(NAMRAT(I).EQ."gsgq"))     
     1           EXTVAL=HADAV(0,0,TOTSTRANGE)
                 IF(NAMRAT(I).EQ."gamq") EXTVAL=TOTBULK(0,3,-1)
                 IF(NAMRAT(I).EQ."norm") EXTVAL=TOTBULK(0,2,-1)
c	         IF((NAMRAT(I).EQ."norm").OR.
c     1((IFIXRAT(IFINDPAR("norm")).LT.1).AND.(PARNAME.NE."norm"))) 
                 IF((NAMRAT(I).EQ."norm").or.(NAMRAT(I).EQ."temp"))
     1EXTVAL=EXTVAL/NORM     
                 WRITE(20+I,171) 
     1           PARRAT(INUM1),PARRAT(I),EXTVAL,FMINTRUE,STATSIG2
 171             FORMAT(1X,5F20.10)
                 WRITE(61,*) 'AT ',INUM1,'=',PARRAT(INUM1)
     1,' MINUMUM FOR ',I,' IS ',PARRAT(I)
             ENDIF
 119         CONTINUE
         IF(IERR.NE.0) WRITE(61,*) 'MINUIT ERR '
     1,REAL(PARRAT(INUM1)),REAL(FMIN),IERR
c          write(*,*) 'datapoint finished'
121    CONTINUE
        CLOSE(3)
      IF(IDT.NE.0) THEN
          CLOSE(4)
          CLOSE(5)
        CLOSE(16)
        CLOSE(36)
      ENDIF
        DO 120 I=1,IPRT
         IF((I.NE.INUM1).AND.(IFIXRAT(I).EQ.1)) CLOSE(20+I)
 120    CONTINUE
         IFIXRAT(INUM1)=1  !! releasing profile parameter
        RETURN
        END

C-------------------------- DATA-POINT SENSITIVITY GRAPH

       SUBROUTINE DATCPRF(IDPT,FLNAME,LOW,UP,IPTN,ICHISIG,IDT,IDP)
         IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
        COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
        PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
        CHARACTER*12 FLNAME
        CHARACTER*17 FLNAME2,FLNAME3,FLNAME4,FLNAME5
     1,FLNAME6,FLNAME7,FLNAME8
        EXTERNAL FCNRAT
      REAL PROB
        MINPARVAL=1D0
        IF(IDP.EQ.3) THEN
          CALL MIN_RATIOS(10,0,0,-1)
          IF(IDT.GT.0) THEN
             MINPARVAL=RATTHEO(IDT)
             WRITE(61,*) 'MINPARVAL= ',MINPARVAL,' AT MIN '
          ENDIF
        ENDIF
        IWRITERAT=0
        CALL DATACHECK
        FLNAME2='profvcblrsns_temp' 
        FLNAME3='profvcblrsns__log'
        FLNAME4='profvcblrsns_dat1'
        FLNAME5='profvcblrsns_dat2'
        FLNAME6='profvcblrsns.prof'
        FLNAME7='profvcblrsns.chi2'
        FLNAME8='profvcblrsns.stsg'
        WRITE(61,*) '=============================='
        WRITE(61,*) 'PLOTTING DATA-POINT SENSITIVITY GRAPH FOR '
     1,NAMDATA(IDPT,1),'/',NAMDATA(IDPT,2)
        WRITE(61,*) 'LOW, UP, POINTS ',REAL(LOW),REAL(UP),IPTN
        WRITE(61,*) '=============================='
        CALL CCOPYL(FLNAME,FLNAME3,12)
        CALL CCOPYL(FLNAME,FLNAME4,12)
        CALL CCOPYL(FLNAME,FLNAME5,12)
        CALL CCOPYL(FLNAME,FLNAME6,12)
        CALL CCOPYL(FLNAME,FLNAME7,12)
        CALL CCOPYL(FLNAME,FLNAME8,12)
        WRITE(*,*) 'FIT LOG WRITTEN TO ',FLNAME3
        OPEN(10,FILE=FLNAME3,STATUS='UNKNOWN')   
        OPEN(3,FILE=FLNAME6,STATUS='UNKNOWN')
      IF(IDT.NE.0) THEN
          OPEN(4,FILE=FLNAME4,STATUS='UNKNOWN')
          OPEN(5,FILE=FLNAME5,STATUS='UNKNOWN')
          OPEN(16,FILE=FLNAME7,STATUS='UNKNOWN')
          OPEN(36,FILE=FLNAME8,STATUS='UNKNOWN')
        ENDIF
       WRITE(*,*) 'PROFILE TO FILE ',FLNAME6
        DO 117 I=1,IPRT
            IF(IFIXRAT(I).GE.1) THEN
              CALL CCOPYL(FLNAME,FLNAME2,12)
              FLNAME2(14:17)=NAMRAT(I)
              WRITE(*,*) 'CORRELATION FOR ',NAMRAT(I),' IS IN FILE '
     1,FLNAME2,' '
              OPEN(20+I,FILE=FLNAME2,STATUS='UNKNOWN')
              WRITE(61,*) 'PARAMETER ',I,' TO ',FLNAME2
            ENDIF
 117    CONTINUE
        ITRUEFIT=IFIT(IDPT)
        IFIT(IDPT)=1
        TRUEDATAPOINT=RATDATA(IDPT)
        DO 121 IPT=0,IPTN
         RATDATA(IDPT)=LOW+(UP-LOW)*DBLE(IPT)/DBLE(IPTN)
         IPOINT=0
         WRITE(61,*) '---------------------------------------------'
         WRITE(61,*) 'PLOTTING ',RATDATA(IDPT),' POINT ',IPT,' OF ',IPTN
         WRITE(10,*) '---------------------------------------------'
         WRITE(10,*) 'PLOTTING ',RATDATA(IDPT),' POINT ',IPT,' OF ',IPTN
         CALL MIN_RATIOS(10,0,0,-1)
c         IF((CHEMFACT.EQ.1D0).AND.(IERR.EQ.0)) IPOINT=1
         IF(CHEMFACT.EQ.1D0) IPOINT=1
         WRITE(*,*) 'CHEMerr ',IERR,CHEMFACT,IPOINT
         FMIN=FVALBEFORE
         IF(ICHISIG.EQ.1) FMIN=
     1 DBLE(PROB(REAL(FMIN*DBLE(IFDGRAT)),IFDGRAT))
c         write(*,*) 'minparval ',IDPT,RATDATA(IDPT),FMIN,CHITRM(IDPT)
         IF(IDT.GT.0) THEN
           CHISQUARED=FMIN
           STATSIG=DBLE(PROB(REAL(FMIN*DBLE(IFDGRAT)),IFDGRAT))
           IF((IDP.EQ.1).OR.(IDP.EQ.3)) FMIN=RATTHEO(IDT)
           IF(IDP.EQ.2) FMIN=CHITRM(IDT)
           FMIN=FMIN/MINPARVAL
           IF(IPOINT.GT.0) WRITE(16,*) RATDATA(IDPT),CHISQUARED
           IF((IPOINT.GT.0).AND.(STATSIG.GT.0D0)) 
     1     WRITE(36,*) RATDATA(IDPT),STATSIG
           WRITE(4,*) RATDATA(IDPT),RATDATA(IDT)-RATERR(IDT)
           WRITE(5,*) RATDATA(IDPT),RATDATA(IDT)+RATERR(IDT)
         ENDIF
         IF((IPOINT.GT.0).AND.(FMIN.NE.0D0))
     1   WRITE(3,*) RATDATA(IDPT),FMIN
         WRITE(61,*) 'DATA POINT FOR ',RATDATA(IDPT),' IS ',FMIN
         DO 119 I=1,IPRT
            IF((IFIXRAT(I).EQ.1).AND.(CHEMFACT.EQ.1)) 
     1      THEN
                 WRITE(20+I,171) RATDATA(IDPT),PARSPARE(I),FMIN
 171             FORMAT(1X,3F20.10)
                 WRITE(61,*) 'AT ',RATDATA(IDPT)
     1,' MINUMUM FOR ',I,' IS ',PARSPARE(I)
             ENDIF
 119         CONTINUE
         IF(IERR.NE.0) WRITE(61,*) 'MINUIT ERR '
     1,REAL(RATDATA(IDPT)),REAL(FMIN),IERR
c          write(*,*) 'datapoint finished'
121    CONTINUE
        CLOSE(3)
        IF(IDT.NE.0) THEN
          CLOSE(4)
          CLOSE(5)
          CLOSE(16)
          CLOSE(36)
        ENDIF
        DO 120 I=1,IPRT
         IF(IFIXRAT(I).EQ.1) CLOSE(20+I)
 120    CONTINUE
        RATDATA(IDPT)=TRUEDATAPOINT
        IFIT(IDPT)=ITRUEFIT
        RETURN
        END

C-------------------------- PARAMETER FIXING
      SUBROUTINE FIXVALSRAT(XVAL)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      DIMENSION XVAL(IPRT)
      IF(XVAL(IFINDPAR('temp')).LT.0D0) XVAL(IFINDPAR('temp'))=T
      IF(XVAL(IFINDPAR('lamq')).LT.0D0) XVAL(IFINDPAR('lamq'))=LAMQ
      IF(XVAL(IFINDPAR('lams')).LT.0D0) XVAL(IFINDPAR('lams'))=LAMS
      IF((ILAMQMUQ.GT.0).AND.(XVAL(IFINDPAR('lams')).LT.0D0))
     1 XVAL(IFINDPAR('lams'))=LAMSFUNC(T,LAMQ,LAMS)
      IF((ILAMQMUQ.GT.0).AND.(XVAL(IFINDPAR('lamq')).LT.0D0))
     1 XVAL(IFINDPAR('lamq'))=LAMQFUNC(T,LAMQ)
      IF(XVAL(IFINDPAR('gamq')).LT.0D0) XVAL(IFINDPAR('gamq'))=GAMQ
      IF((IGSGQ.EQ.0).AND.(XVAL(IFINDPAR('gams')).LT.0D0)) 
     1   XVAL(IFINDPAR('gams'))=GAMS
      IF(IGSGQ.GT.0) THEN
         IF(XVAL(IFINDPAR('gsgq')).LT.0D0)
     1   XVAL(IFINDPAR('gams'))=GAMS/GAMQ
      ENDIF
      IF(XVAL(IFINDPAR('lmi3')).LT.0D0) XVAL(IFINDPAR('lmi3'))=LMI3
      IF((ILAM3MU3.GT.0).AND.(XVAL(IFINDPAR('lmi3')).LT.0D0))
     1 XVAL(IFINDPAR('lmi3'))=T*DLOG(LMI3)
      IF(XVAL(IFINDPAR('norm')).LT.0D0) XVAL(IFINDPAR('norm'))=NORM
      IF(XVAL(IFINDPAR('lamc')).LT.0D0) XVAL(IFINDPAR('lamc'))=LAMC
      IF(XVAL(IFINDPAR('Ncbc')).LT.0D0) XVAL(IFINDPAR('Ncbc'))=NCBC
      IF(XVAL(IFINDPAR('dvol')).LT.0D0) XVAL(IFINDPAR('dvol'))=DVOL
      IF(XVAL(IFINDPAR('gam3')).LT.0D0) XVAL(IFINDPAR('gam3'))=GAM3
      IF(XVAL(IFINDPAR('tc2t')).LT.0D0) XVAL(IFINDPAR('tc2t'))=TC2T
c      IF(XVAL(IFINDPAR('temp')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('temp'))=T
c      ENDIF
c      IF(XVAL(IFINDPAR('lamq')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('lamq'))=LAMQ
c      ENDIF
c      IF(XVAL(IFINDPAR('lams')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('lams'))=LAMS
c      ENDIF
c      IF(XVAL(IFINDPAR('gamq')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('gamq'))=GAMQ
c      ENDIF
c      IF(XVAL(IFINDPAR('gams')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('gams'))=GAMS
c      ENDIF
c      IF(XVAL(IFINDPAR('lmi3')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('lmi3'))=LMI3
c      ENDIF
c      IF(XVAL(IFINDPAR('norm')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('norm'))=NORM
c      ENDIF
c      IF(XVAL(IFINDPAR('lamc')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('lamc'))=LAMC
c      ENDIF
c      IF(XVAL(IFINDPAR('Ncbc')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('Ncbc'))=NCBC
c      ENDIF
c      IF(XVAL(IFINDPAR('dvol')).GE.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('dvol'))=DVOL
c      ENDIF
c      IF(XVAL(IFINDPAR('gam3')).GT.0D0) THEN
c         CONTINUE
c      ELSE
c         XVAL(IFINDPAR('gam3'))=GAM3
c      ENDIF
c      write(*,*) 'aft fix ',xval
      T=XVAL(IFINDPAR('temp'))
      LAMQ=XVAL(IFINDPAR('lamq'))
      LAMS=XVAL(IFINDPAR('lams'))
      IF(ILAMSMUS.EQ.1) THEN
        LAMS=LAMSFUNC(T,LAMQ,LAMS)
      ENDIF
c      IF(ILAMQMUQ.EQ.1) THEN
c        LAMQ=LAMQFUNC(T,LAMQ)
c      ENDIF
      LMI3=XVAL(IFINDPAR('lmi3'))
      IF(ILAM3MU3.EQ.1) THEN
        LMI3=DEXP(LMI3/T)
      ENDIF

      NORM=XVAL(IFINDPAR('norm'))
      LAMC=XVAL(IFINDPAR('lamc'))
      NCBC=XVAL(IFINDPAR('Ncbc'))
      DVOL=XVAL(IFINDPAR('dvol'))
      GAM3=XVAL(IFINDPAR('gam3'))
      TC2T=XVAL(IFINDPAR('tc2t'))
      IF(IFIXRAT(IFINDPAR('gamq'))**2.LE.1) THEN
         GAMQ=XVAL(IFINDPAR('gamq'))
      ELSE
         GAMQ=XVAL(IFINDPAR('gamq'))*PICONDENS_MIN()
         write(*,*) 'ngamq ',XVAL(IFINDPAR('gamq')),T,GAM3,LMI3
     1 ,PICONDENS_MIN()
      ENDIF
      IF(IGSGQ.GT.0) GAMS=GAMQ*XVAL(IFINDPAR('gams'))
      IF(IGSGQ.EQ.0) GAMS=XVAL(IFINDPAR('gams'))
      DO 171 I=1,IPRT
 171     PARRAT(I)=XVAL(I)
      CHEMFACT=1D0
      RETURN
      END

      FUNCTION PICONDENS_MIN()
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      SQRTLMI3=SQRT(LMI3)
      TWOT=2D0*T
      CHARGMASS=DEXP(MHAD(IMATCHNAME(1,'pi0139plu'))/TWOT)
      PICONDENS_1=SQRTLMI3*CHARGMASS
      PICONDENS_2=CHARGMASS/SQRTLMI3
      PICONDENS_3=DEXP(MHAD(IMATCHNAME(1,'pi0135zer'))/TWOT)
     1/SQRT(DBLE(0.5)*(GAM3**2+1D0/GAM3**2))
      PICONDENS_MIN=PICONDENS_1
      IF(PICONDENS_2.LT.PICONDENS_MIN) PICONDENS_MIN=PICONDENS_2
      IF(PICONDENS_3.LT.PICONDENS_MIN) PICONDENS_MIN=PICONDENS_3
c      write(*,*) 'picondens ',PICONDENS_1,PICONDENS_2,PICONDENS_3
      RETURN
      END

      SUBROUTINE FCNRAT(IPAR,GRAD,FVAL,XVAL,IFLAG,F)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      EXTERNAL PRINTCHARMYIELDS
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      DIMENSION XVAL(IPRT),GRAD(IPRT)
      PENALTY=1D0
      CALL FIXVALSRAT(XVAL)
      CALL SOLVE_EXACT(XVAL)
      CALL FILL_CHEM(0,0)
      CALL CALCYIELDS
      FVAL=0D0
      IF(IWRITERAT.GT.0) THEN
         CALL PRINTCHARMYIELDS()
9711  FORMAT(/A27/)
         IF(IBOLTZ.EQ.1) THEN
              WRITE(IWRITERAT,9711) ' BOLTZMANN statistics used '
              WRITE(61,9711) ' BOLTZMANN statistics used '
         ELSE
              WRITE(IWRITERAT,9711) ' QUANTUM statistics used '
              WRITE(61,9711) ' QUANTUM statistics used '
         ENDIF
         WRITE(IWRITERAT,*) ' '
         WRITE(61,*) ' '
         WRITE(IWRITERAT,711) 
     1'TOP  ','BOTTOM','THEORY','EXP  ',' ERROR'
     1,'CHITERM','FEED-DOWN  '

         WRITE(61,711) 'TOP','BOTTOM','THEORY','EXP','ERROR','CHITERM'
     1,'FEED-DOWN'
C         IF(ILATEX.GT.0) THEN
C            WRITE(ILATEX,*) 'N.','&','PARTICLE','&','THEORY','&','EXP.'
C     1,'&','Error','&','$\chi$','\\ \hline'
C         ENDIF
 711     FORMAT(2A12,3A14,2A15)
      ENDIF
      DO 197 I=ISOLVMAX+1,IRATDAT
         RATTHEO(I)=FINDYIELDS(I)
         CHITRM(I)=0D0
         IF(IFIT(I).GT.0) CHITRM(I)=(RATTHEO(I)-RATDATA(I))/RATERR(I)
c         write(*,*) NAMDATA(I,1),' ',NAMDATA(I,2)
c     1,REAL(RATTHEO(I)),REAL(RATDATA(I)),REAL(RATERR(I)),REAL(CHITRM(I))
         FVAL=FVAL+CHITRM(I)**2
C----------------------------------------------
         IF(IWRITERAT.GT.0) THEN
            SMALLV=1.D-2
            LARGEV=1.D+3
            NIL=1.D-11
            IF(((DABS(RATTHEO(I)).LT.SMALLV).OR.(DABS(RATTHEO(I))
     1 .GT.LARGEV)).OR.((DABS(RATDATA(I)).GT.NIL).AND.
     1((DABS(RATDATA(I)).LT.SMALLV).OR.(DABS(RATDATA(I)).GT.LARGEV))))
     1 THEN
            WRITE(IWRITERAT,107) NAMDATA(I,1),NAMDATA(I,2)
     1,RATTHEO(I),RATDATA(I),RATERR(I),CHITRM(I),DECDATA(I)
            WRITE(61,107) NAMDATA(I,1),NAMDATA(I,2)
     1,RATTHEO(I),RATDATA(I),RATERR(I),CHITRM(I),DECDATA(I)
          ELSE
            WRITE(IWRITERAT,106) NAMDATA(I,1),NAMDATA(I,2)
     1,RATTHEO(I),RATDATA(I),RATERR(I),CHITRM(I),DECDATA(I)
            WRITE(61,106) NAMDATA(I,1),NAMDATA(I,2)
     1,RATTHEO(I),RATDATA(I),RATERR(I),CHITRM(I),DECDATA(I)
          ENDIF
         ENDIF
         IF(IPLOTRAT.GT.0) THEN
            IF((IFIT(I).GT.0).AND.(IFIT(I).LT.2)) 
     1      WRITE(11,*) I,RATTHEO(I)
            IF(IFIT(I).EQ.0) WRITE(12,*) I,RATTHEO(I)
            IF((IFIT(I).GE.0).AND.(IFIT(I).LT.2)) 
     1      WRITE(13,*) I,RATDATA(I),RATERR(I)
         ENDIF
 197  CONTINUE
 106  FORMAT(2A13,4F14.6,A12)
 107  FORMAT(2A13,4E14.6,A12)
      FVAL=FVAL/DBLE(IFDGRAT)      
C---------   PENALTY FUNCTION CALCULATION TO AVOID B-E CONDENSATION ------
      IF(IBOLTZ.LT.1) THEN
C       IF USING QUANTUM STATISTICS, CALCULATE THE PENALTY BASED ON HOW CLOSE
C       WE ARE TO THE B-E CONDENSATION LIMIT.
         IF(CHEMFACT.LT.1D0) THEN
               CHEMINV=1D0/CHEMFACT
               DEVIATION=CHEMINV-1D0
            IF(CHEMINV.LT.100) THEN
                 STEPFACT=1D0+DTANH(1D3*DEVIATION)
                 PENALTY=STEPFACT*CHEMINV**6
            ELSE
                PENALTY=2D16
            ENDIF
            IF(IWRITERAT.GT.0) THEN
       WRITE(10,*) 'WARNING: FIT IN UNPHYSICAL B-E CONDENSATIO REGION'
       WRITE(10,*) 'OF PARAMETER SPACE.'
       WRITE(10,*) 'CHEMICAL POTENTIALS RENORMALIZED WITH SPURIOUS'
       WRITE(10,*) 'PARAMETER FOR CONVERGENCE.  PARAMETER=',CHEMFACT
       WRITE(10,*) 'RELAX SOME PARAMETERS OR CHANGE INITIAL CONDITIONS'
       WRITE(10,*) 'TO ENSURE FIT IS PHYSICAL'
       WRITE(61,*) 'WARNING: FIT IN UNPHYSICAL B-E CONDENSATIO REGION'
       WRITE(61,*) 'OF PARAMETER SPACE.'
       WRITE(61,*) 'CHEMICAL POTENTIALS RENORMALIZED WITH SPURIOUS'
       WRITE(61,*) 'PARAMETER FOR CONVERGENCE.  PARAMETER=',CHEMFACT
       WRITE(61,*) 'RELAX SOME PARAMETERS OR CHANGE INITIAL CONDITIONS'
       WRITE(61,*) 'TO ENSURE FIT IS PHYSICAL'
            ENDIF
         ENDIF
C   WHEN WE ARE USING BOLTZMANN STATISTICS, ANY VALUE OF GAMMA_Q IS OK, SO WE SET PENALTY TO UNITY
      ELSE   
        PENALTY=1.D0
      ENDIF
c------------------------------------------------
c      IF(FVAL.LT.1D80) THEN
         FVAL=FVAL*PENALTY
         FVALBEFORE=FVAL
c           write(*,*) 'FVAL ',T,GAMQ,FVAL
c      ENDIF
      TBEFORE=T
c       IF(PENALTY.GT.1D0) write(*,*) 'fval ',GAMQ,fval,penalty
c      WRITE(*,*) 'FVALBEFORE ',T,FVALBEFORE
      RETURN
      END

      SUBROUTINE SOLVE_EXACT(XVAL)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      PARAMETER(ISOLVMX=10)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      PARAMETER(ISOLVWK=ISOLVMX**2+3*ISOLVMX)
      PARAMETER(IMXIT=50*ISOLVMX+3)
      DIMENSION XVAL(IPRT)
     1,XPARS(ISOLVMX),RESID(ISOLVMX),SOLVWK(ISOLVWK)
      EXTERNAL SOLVRAT
      DO 999 I=1,ISOLVMX
 999     XPARS(I)=0.D0
      IF(ISOLVMAX.GT.0) THEN
        DO 7110 I=1,ISOLVMAX
          RESID(I)=0D0
          XPARS(I)=PARRAT(ISOLVE(I))
 7110   CONTINUE
        CALL 
     1  DSNLEQ(ISOLVMAX,XPARS,RESID,AC,AC,IMXIT,0,IFAIL,SOLVRAT,SOLVWK)
        IF(IFAIL.GT.3)   THEN
c          WRITE(61,*) 'EQUATION SYSTEM FAILED ',IFAIL
c     1   ,' LEAVING PARAMETERS UNCHANGED'
          WRITE(61,*) 'EQUATION SYSTEM FAILED ',IFAIL
     1   ,' LEAVING PARAMETERS UNCHANGED '
        ELSE
         DO 7111 I=1,ISOLVMAX
            IF((XPARS(I).LT.ULMRAT(ISOLVE(I)))
     1      .AND.(XPARS(I).GT.LLMRAT(ISOLVE(I)))
     1      .AND.(IFREERAT.GT.0)) THEN
              PARRAT(ISOLVE(I))=XPARS(I)
              XVAL(ISOLVE(I))=XPARS(I)
            ENDIF
 7111    CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE SOLVRAT(IEQNS,XPARS,XEQ,I)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IPRT=12)
      COMMON /MIPARSRAT_NUM/ LLMRAT(IPRT),ULMRAT(IPRT)
     1,MNRRAT(IPRT),PARRAT(IPRT),PARSPARE(IPRT),PARORIG(IPRT)
     1,MNVALRAT(IPRT),STPRAT(IPRT),FVALBEFORE
     1,IFIXRAT(IPRT),IRATDAT,IFREERAT,IFDGRAT
     1,IWRITERAT,ILATEX,IPLOTRAT,I_NORM
     1,IERR
      PARAMETER(IRATMX=200)
      PARAMETER(ISOLVMX=10)
      CHARACTER*9 NAMDATA(IRATMX,2),WKF(IRATMX),DECDATA(IRATMX)
      COMMON /RATDATABLOCK/
     1 RATDATA(IRATMX),RATTHEO(IRATMX),CHITRM(IRATMX)
     1,RATERR(IRATMX),DECDATA
     1,NAMDATA,WKF,IFIT(IRATMX),ISOLVE(IRATMX),IRATIONW
     1,ISOLVMAX,IDATRATIOS,IWRITTEN(IRATMX)
      DIMENSION XPARS(ISOLVMX),XEQ(ISOLVMX)
      IF(IFREERAT.GT.0) PARRAT(ISOLVE(I))=XPARS(I)
c      write(*,*) 'xpars ',xpars
      CALL FIXVALSRAT(PARRAT)
      CALL FILL_CHEM(0,0)
      CALL CALCYIELDS
      YLD1=YLDPART(0,NAMDATA(I,1),I)
      XEQ(I)=YLD1-RATDATA(I)
      RETURN
      END
c---------------- THE THERMAL FUNCTIONS ----------------
       
      FUNCTION F_HAD(IPX)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3

      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
      PARAMETER(IKTRMMAX=100)
      PARAMETER(ITRMMAX=IKTRMMAX-5)
      DIMENSION KTERM(IHDMX,IKTRMMAX,6)
      EXTERNAL NONSING

C------------------------
      IP=IPX
      F_HAD=0D0
      TERM1=0D0
      ITERM=1
      IF(CHEM(IP).LE.0D0) THEN
        IF((XCH(IP).EQ.0D0).AND.(XACH(IP).EQ.0D0))
     1  WRITE(*,*) 'CHEM<0 FOR '
     1,NAM(IP),LAMQ,LAMS,GAMU,GAMD,GAMS,GAM3,CHEM(IP)
        GO TO 119
      ENDIF
C      write(*,*) 'start ',NAM(IP),' ',IEPN
c----------------------- numerical integral based evaluation (no widths)
C      INUMERICAL=1
      INUMERICAL=0
      IF((INUMERICAL.EQ.1).AND.((IEPN.EQ.0).OR.(IEPN.EQ.4))) THEN
        IF(WIDTH(IP).GT.0D0) THEN
           WRITE(*,*) 'WIDTH>0 AND NUMERICAL ',NAM(IP),' ',WIDTH(IP)
           CALL CRASHPROGRAM
        ENDIF
        TTERM=T
        IEXP=1
        IF(IEPN.EQ.4) IEXP=2
C        CONDENS=1D-1
C        IF(IBS(IP).GT.0) CONDENS=CHEM(IP)*DEXP(-MHAD(IP)/T)
C        IF(CONDENS.GT.0.9) THEN
C             MT2=10.
C             CHMTERM=T*DLOG(CHEM(IP))
C             CNTERM=COUNTERTERM(CHMTERM,MHAD(IP),MT2,IEXP)/T**IEXP       
             LOWLM=0D0
             UPLIM=1D1
             F_HAD=DGQUAD(NONSING,LOWLM,UPLIM,96)
c             F_HAD=DGAUSS(NONSING,LOWLM,UPLIM,AC)
c             write(*,*) 'f_had ',F_HAD
C        ENDIF
        GO TO 119
      ENDIF
C----------------------- usual Bessel-function series evaluation

 117  TTERM=T/DBLE(ITERM)
c debug 2 lines
      BTERM=IBS(IP)**(ITERM-1)
      COEFF=1D0
       IF(IEPN.GE.4) COEFF=ITERM
c      IF(IEPN.GE.4)  COEFF=DABS(DBINOM(DBLE(-2),ITERM-1))
c----------------------------------------------------------
c      IF(IEPN.GE.4) coeff2=DBINOM(DBLE(2+ITERM-1),ITERM)
C      if((iterm.gt.10).and.(Ieorn.ge.4)) write(*,*) ITERM,COEFF
c      IF(((GAMQ.GT.DBLE(1.5)).and.(ieorn.ge.4))) 
c     1WRITE(*,*) NAM(IP),' ',GAMQ,ITERM,BTERM*COEFF
c----------------------------------------------
      IF((TBEFORE.EQ.T).AND.(ITERM.LE.IKTRMMAX)
     1.AND.(KTERM(IP,ITERM,IEPN+1).NE.0D0)) THEN
         THTERM=KTERM(IP,ITERM,IEPN+1)
c         write(*,*) 'iterm: ',iterm,IKTRMMAX
      ELSE
c         if(ITERM.GT.IKTRMMAX) write(*,*) 'iterm is ',T,ITERM
         THTERM=THERMHAD(IP)
         IF((ITERM.LE.IKTRMMAX).AND.(IEPN.LE.5)) 
     1   KTERM(IP,ITERM,IEPN+1)=THTERM
      ENDIF
      IF(THTERM.GT.0D0) THEN
        TERM1=COEFF*THTERM
        DO 118 I=1,ITERM
 118      TERM1=TERM1*CHEM(IP)
      ELSE
         TERM1=0D0
      ENDIF
      IF(ITERM.EQ.1) THEN
         XTERM=TERM1
         IF(TERM1.LE.0D0) XTERM=1D0
         TERM0=XTERM
         TERMBFR=XTERM         
      ENDIF
      IF(TERM0.LE.0D0) THEN
c      WRITE(*,*) 'YIELD IS 0 FOR ',NAM(IP)
c      CALL CRASHPROGRAM
      ENDIF
      F_HAD=F_HAD+BTERM*TERM1
C--------------------- DEBUGGING----------------------
c      write(*,*) 'FR/BS ',NAM(IP),' ',IBS(IP),ITERM,BTERM
c      IF(mass.lt.0.2)
c     1 WRITE(*,*) 'TRM ',ieorn,ITERM
c     1,real(CHMTERM),real(TERM1/TERM0)
c     1,EHAD(XDEG(IP),TTERM,CHMTERM,MASS),
c     1T*DLOG(CHMTERM)*NHAD(XDEG(IP),TTERM,CHMTERM,MASS),
c     1PHAD(XDEG(IP),TTERM,CHMTERM,MASS),TTERM,term1
C-----------------------------------------------------
      IF(F_HAD.GT.0.D0) THEN
        ACTERM=ABS(TERM1)/ABS(F_HAD)
      ELSE
        ACTERM=0.D0
      ENDIF
      IF(((IBOLTZ.EQ.0).AND.(ACTERM.GT.AC).AND.(CHEMFACT.GT.ACX))
     1.OR.(F_HAD.LT.0D0)) THEN
         ITERM=ITERM+1
         IF((TERMBFR.LE.TERM1).AND
     1.(ITERM.GE.ITRMMAX).AND.(F_HAD.GT.0D0)) THEN
            CHEMFACT=ACX*CHEMFACT
         ELSEIF((ITERM.GE.ITRMMAX).AND.(F_HAD.LT.0D0)
     1   .AND.(TERMBFR.LE.TERM1)) THEN
c            WRITE(*,*) 'F_HAD<0 AT ITRMMAX ',NAM(IP),' ',CHEM(IP)
c     1      ,ITERM,GAMQ,GAMS,f_HAD
C            CALL CRASHPROGRAM
            CHEMFACT=ACX*CHEMFACT
            F_HAD=-F_HAD
         ELSE
            TERMBFR=TERM1
            GO TO 117
         ENDIF
      ENDIF
C---------------------- FLUCTUATIONS IN CANONICAL ENSEMBLE
     
c      write(*,*) 'icanonical ',ICANONICAL
      IF((ICANONICAL.GT.0).AND.(IEPN.EQ.4)) THEN
         IHALF=0
         IF((ICANONICAL.EQ.1).AND.(IBAR(IP).NE.0)) IHALF=1
      IF((ICANONICAL.EQ.2).AND.((XS(IP).GT.0.D0).OR.(XAS(IP).GT.0.D0)))
     1   IHALF=1
         IF(IHALF.GT.0) F_HAD=F_HAD/2D0
      ENDIF
C----------------------------------------------------
  119 F_HAD=NORM*NORMFACT*F_HAD
      IF(F_HAD.LT.0D0) THEN
         WRITE(*,*) 'F_HAD<0 FOR ',NAM(IP),' ',ITERM,CHEM(IP),T
     1,F_HAD
         CALL CRASHPROGRAM
      ENDIF
      RETURN
      END

      FUNCTION THERMHAD(IPX)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
      EXTERNAL F_HAD_INT,BOT_HAD_INT
      IP=IPX
      M0=MHAD(IP)
      IF(WIDTH(IP).LE.0D0) THEN
         ITOPBT=-1
         FHAD=BOLTZINT(M0)
      ELSE
c------- debug small width ----
c        A systematic effect is that threshold can sometimes
c        get shifted
c        width(ip)=DBLE(0.00001)
c-------------------------
         WDT1=(WIDTH(IP)**2)/4D0
         TOP=0D0
         BOT=0D0
         IDCTHERM=IDEC(IP)
         IF(IDEC(IP).LE.0) IDCTHERM=1
         DO 803 IDC=1,IDCTHERM
           MTRESH=M_TRESH(IP,IDC)
           LREL=L_REL(IP,IDC)+DBLE(0.5)
C----------------------------------------
           LIM1_A=MTRESH
           LIM2W=2D0*WIDTH(IP)
           LIM2_A=M0+LIM2W
           IF(LIM2_A.LT.LIM1_A) LIM2_A=LIM1_A+LIM2W
           LIM1_B=0D0
           LIM2_B=1D0
           MT2=LIM2_A
           BRANCH=BR(IP,IDC,1)
           IF(IDEC(IP).LE.0) BRANCH=1D0
           WDT=BRANCH*WDT1
C---------------------------------------
           ITOPBT=0
           TOP1=DGQUAD(F_HAD_INT,LIM1_A,LIM2_A,96)
           TOP2=DGQUAD(BOT_HAD_INT,LIM1_B,LIM2_B,96)
c           TOP1=DGAUSS(F_HAD_INT,LIM1_A,LIM2_A,AC)
c           TOP2=DGAUSS(BOT_HAD_INT,LIM1_B,LIM2_B,AC)
           ITOPBT=1
c           BOT1=DGAUSS(F_HAD_INT,LIM1_A,LIM2_A,AC)
c           BOT2=DGAUSS(BOT_HAD_INT,LIM1_B,LIM2_B,AC)

           BOT1=DGQUAD(F_HAD_INT,LIM1_A,LIM2_A,96)
           BOT2=DGQUAD(BOT_HAD_INT,LIM1_B,LIM2_B,96)
           TOP=TOP+TOP1+TOP2
           BOT=BOT+BOT1+BOT2
 803     CONTINUE
         IF((TOP.EQ.0D0).OR.(BOT.EQ.0D0)) FHAD=0D0
         IF((TOP.NE.0D0).AND.(BOT.NE.0D0)) FHAD=TOP/BOT
      ENDIF
      IF(FHAD.LE.0D0) THEN
C        WRITE(*,*)  'A YIELD=0 ',NAM(IP),' M,DEG= '
C     1,MHAD(IP),XDEG(IP),TTERM
C        CALL CRASHPROGRAM
      ENDIF
      THERMHAD=FHAD
      RETURN
      END

      FUNCTION BOT_HAD_INT(Z)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
      IF((ITOPBT.LT.1).AND.(Z.EQ.0D0)) THEN
         BOT_HAD_INT=0D0
      ELSE
         FACTOR=(1D0-(MTRESH*Z/MT2)**2)**LREL
         WDTM=WDT*FACTOR**2
         TOP=MT2*FACTOR
         BOT=(MT2-M0*Z)**2+WDTM*Z**2
         BOT_HAD_INT=TOP/BOT
         IF(ITOPBT.LT.1) BOT_HAD_INT=BOT_HAD_INT
     1   *BOLTZINT(MT2/Z)
      ENDIF
      RETURN
      END

      FUNCTION F_HAD_INT(MASS)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
c      PARAMETER(PIFACT=5.066059182116889E-002)
      FACTOR=(1D0-(MTRESH/MASS)**2)**LREL
      WDTM=WDT*FACTOR**2
      DECBOT=(MASS-M0)**2+WDTM
      IF(DECBOT.LE.0D0) THEN
         WRITE(*,*) 'DECBOT=0 ',MTRESH,MASS,LREL,FACTOR
         CALL CRASHPROGRAM
      ENDIF
      F_HAD_INT=FACTOR/DECBOT
c      write(*,*) 'f ',mass,wdt,factor,DECBOT
      IF(ITOPBT.LT.1) F_HAD_INT=F_HAD_INT*BOLTZINT(MASS)
      RETURN
      END

      FUNCTION BOLTZINT(MASS)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
      BOLTZINT=-1D0
      IF((IEPN.EQ.0).OR.(IEPN.EQ.4)) BOLTZINT=XDEG(IP)*NHAD(TTERM,MASS)
      IF((IEPN.EQ.1).OR.(IEPN.EQ.5)) BOLTZINT=XDEG(IP)*EHAD(TTERM,MASS)
      IF(IEPN.EQ.2) BOLTZINT=XDEG(IP)*PHAD(TTERM,MASS)
      IF(IEPN.EQ.3) BOLTZINT=XDEG(IP)*SHAD(T,TTERM,CHEM(IP),MASS)

c      if(IEPN.EQ.2) THEN
c        write(*,*) 'PHAD ',NAM(IP),TTERM,BOLTZINT
c      endif
      IF(BOLTZINT.LT.0D0) THEN
         WRITE(*,*) 'BOLTZINT<0 ',TTERM,MASS,XDEG(IP),IEPN,BOLTZINT
         CALL CRASHPROGRAM
      ENDIF
      RETURN
      END
C---------- AVERAGES -------------

      FUNCTION HADAV(IFLUCT,IWK,F)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
        COMMON /FLUCTS/ FLCTPR(IHDMX),FLCTST(IHDMX),
     1FLCTFN(IHDMX),IFLCTALL
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      EXTERNAL F
c      write(*,*) 'HADAV'
c GIVES THERMAL AVERAGE OF FUNCTION F, DEPENDANT ON HADRON PARAMETERS
      TOTAL=0D0
      IF(IFLUCT.EQ.0) IEXP=1
      IF(IFLUCT.GT.0) IEXP=2
      DO 117 I=1,IHADS
c        IF(MHAD(I).GT.DBLE(0.001)) THEN
         IF(IWK.LT.0) THEN
            IEPN=0
            IF(IFLUCT.GT.0) IEPN=4
            NVHAD=F_HAD(I)
         ELSEIF(IWK.LT.1) THEN  !!! 0 <= IWK < 1, then count primary yield
            IF(IFLUCT.EQ.0) NVHAD=YLDPR(I)
            IF(IFLUCT.GT.0) NVHAD=FLCTPR(I)
         ELSEIF(IWK.LT.3) THEN  !!!! 1 <= IWK < 3, then count particles, that do not decay strongly
           NVHAD=0D0
           ISTRONGDEC=IDEC(I)   !! number of strong decays. Initialize to the total number of decays of I-th particle 
           DO 118 ID=1,IDEC(I)
               IF(IWEAK(I,ID).GT.0) ISTRONGDEC=ISTRONGDEC-1   !! Subtract 1 for each decay that is not strong, i.e. is weak or electromagnetic.
118        CONTINUE
           IF(ISTRONGDEC.LE.0) NVHAD=YLDTOT(IFLUCT,1,I)  !! if there is no strong decay of I-th particle, count its yield.
         ELSE
           NVHAD=0D0
           IF((IDEC(I).LE.0).OR.(IWEAK(I,1).GE.1))
     1     NVHAD=YLDTOT(IFLUCT,0,I)
         ENDIF
         TOTAL=TOTAL+NVHAD*F(I)**IEXP
c          write(*,*) 'total ',IFLUCT,NVHAD,F(I)**IEXP,TOTAL
c         if(ifluct.eq.1)
c     1   write(*,*) 'hadav ',NAM(I),' ',IFLUCT,IWK,F(I)**IEXP,NVHAD
c        ENDIF
 117  CONTINUE
      HADAV=TOTAL
c      write(*,*) '>HADAV: hadav complete. TOTAL=',HADAV
       RETURN
       END

      FUNCTION HADCORREL(F1,F2,IDC)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      EXTERNAL F1,F2
      HADCORREL=0D0
      DO 297 IHX=1,IHADS
        IF(IDEC(IHX).GT.0) THEN
          DO 298 I=1,IDEC(IHX)
            IF(IBOD(IHX,I).EQ.2) THEN
              IF((IDEC(IPROD(IHX,I,1)).EQ.0)
     1        .AND.(IDEC(IPROD(IHX,I,2)).EQ.0)) THEN
                CORRTERM=BRFN(IHX,I,IDC,4,1)*
     1                  (F1(IPROD(IHX,I,1))*F2(IPROD(IHX,I,2))
     1                  +F1(IPROD(IHX,I,2))*F2(IPROD(IHX,I,1)))
                IF(CORRTERM.NE.0D0) THEN
                 HADCORREL=HADCORREL
     1+DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,2,1))
     1*CORRTERM*YLDTOT(0,1,IHX)
     1+BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,2,1)*(YLDTOT(1,1,IHX)
     1-YLDTOT(0,1,IHX))*CORRTERM**2
                ENDIF
          ENDIF
            ELSEIF(IBOD(IHX,I).EQ.3) THEN
              IF((IDEC(IPROD(IHX,I,1)).EQ.0)
     1        .AND.(IDEC(IPROD(IHX,I,2)).EQ.0)
     1        .AND.(IDEC(IPROD(IHX,I,3)).EQ.0)) THEN               
                CORR1=BRFN(IHX,I,IDC,4,1)*(
     1            F1(IPROD(IHX,I,1))*F2(IPROD(IHX,I,2))
     1           +F1(IPROD(IHX,I,2))*F2(IPROD(IHX,I,1)))
                CORR2=BRFN(IHX,I,IDC,4,1)*(
     1            F1(IPROD(IHX,I,1))*F2(IPROD(IHX,I,3))
     1           +F1(IPROD(IHX,I,3))*F2(IPROD(IHX,I,1)))
                CORR3=BRFN(IHX,I,IDC,4,1)*(
     1            F1(IPROD(IHX,I,2))*F2(IPROD(IHX,I,3))
     1           +F1(IPROD(IHX,I,3))*F2(IPROD(IHX,I,2)))
                IF(CORR1.NE.0D0) THEN
                 HADCORREL=HADCORREL
     1+DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,2,1))
     1*CORR1*YLDTOT(0,1,IHX)
     1+BRFN(IHX,I,IDC,2,1)*BRFN(IHX,I,IDC,1,1)*(YLDTOT(1,1,IHX)
     1-YLDTOT(0,1,IHX))*CORR1**2
                ENDIF
                IF(CORR2.NE.0D0) THEN
                 HADCORREL=HADCORREL
     1+DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,3,1))
     1*CORR2*YLDTOT(0,1,IHX)
     1+BRFN(IHX,I,IDC,3,1)*BRFN(IHX,I,IDC,1,1)*(YLDTOT(1,1,IHX)
     1-YLDTOT(0,1,IHX))*CORR2**2
                ENDIF
                IF(CORR3.NE.0D0) THEN
                 HADCORREL=HADCORREL
     1+DSQRT(BRFN(IHX,I,IDC,2,1)*BRFN(IHX,I,IDC,3,1))
     1*CORR3*YLDTOT(0,1,IHX)
     1+BRFN(IHX,I,IDC,3,1)*BRFN(IHX,I,IDC,2,1)*(YLDTOT(1,1,IHX)
     1-YLDTOT(0,1,IHX))*CORR3**2
                ENDIF
              ENDIF
            ELSE
               WRITE(*,*) 'WRONG IBOD FOR ',NAM(IHX),I,IBOD(IHX,I)
               CALL CRASHPROGRAM
            ENDIF
  298      CONTINUE
        ENDIF
 297  CONTINUE
       RETURN
       END

      FUNCTION PARTCORREL(NAM1,NAM2,IDC)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      CHARACTER*9 NAM1,NAM2
      DIMENSION IX1(2),IX2(2)

      DO 492 I=1,2
        IX1(I)=IMATCHPART(I,NAM1)
        IX2(I)=IMATCHPART(I,NAM2)
 492  CONTINUE

      IF(NAM1.EQ.NAM2) THEN
          PARTCORREL=YLDCALC(1,NAM1,IDC)
      ELSE
          PARTCORREL=0D0
      ENDIF

      DO 395 IJ1=1,2
         I1=IX1(IJ1)
         DO 396 IJ2=1,2
            I2=IX2(IJ2)
      IF((IX1(IJ1).GT.0).AND.(IX2(IJ2).GT.0)) THEN
      
      IF(I1.NE.I2) THEN

      DO 297 IHX=1,IHADS
        IF(IDEC(IHX).GT.0) THEN
          DO 298 I=1,IDEC(IHX)
c            write(*,*) I,NAM(IHX),IDEC(I),iprod(ihx,i,1)
            IF(IBOD(IHX,I).EQ.2) THEN
               IF(((IPROD(IHX,I,1).EQ.I1).AND.(IPROD(IHX,I,2).EQ.I2))
     1        .OR.((IPROD(IHX,I,1).EQ.I2).AND.(IPROD(IHX,I,2).EQ.I1))) 
     1       PARTCORREL=PARTCORREL+BRFN(IHX,I,IDC,4,1)*
     1(DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,2,1))*YLDTOT(0,1,IHX))
C          if(nam1.ne.nam2) write(*,*) NAM1,' ',NAM2,' ',NAM(IHX),
C     1BRFN(IHX,I,IDC,4,1)
c     1+BRFN(IHX,I,IDC,2,1)*BRFN(IHX,I,IDC,1,1)
c     1*(YLDTOT(1,1,IHX)-YLDTOT(0,1,IHX)))
            ELSEIF(IBOD(IHX,I).EQ.3) THEN
               IF(((IPROD(IHX,I,1).EQ.I1).AND.(IPROD(IHX,I,2).EQ.I2))
     1        .OR.((IPROD(IHX,I,1).EQ.I2).AND.(IPROD(IHX,I,2).EQ.I1)))
     1       PARTCORREL=PARTCORREL+BRFN(IHX,I,IDC,4,1)*
     1(DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,2,1))*YLDTOT(0,1,IHX))
c     1+BRFN(IHX,I,IDC,2,1)*BRFN(IHX,I,IDC,1,1))
c     1*(YLDTOT(1,1,IHX)-YLDTOT(0,1,IHX))
               IF(((IPROD(IHX,I,1).EQ.I1).AND.(IPROD(IHX,I,3).EQ.I2))
     1        .OR.((IPROD(IHX,I,1).EQ.I2).AND.(IPROD(IHX,I,3).EQ.I1))) 
     1       PARTCORREL=PARTCORREL+BRFN(IHX,I,IDC,4,1)*
     1(DSQRT(BRFN(IHX,I,IDC,1,1)*BRFN(IHX,I,IDC,3,1))*YLDTOT(0,1,IHX))
c     1+BRFN(IHX,I,IDC,3,1)*BRFN(IHX,I,IDC,1,1)
c     1*(YLDTOT(1,1,IHX)-YLDTOT(0,1,IHX)))
               IF(((IPROD(IHX,I,3).EQ.I1).AND.(IPROD(IHX,I,2).EQ.I2))
     1        .OR.((IPROD(IHX,I,3).EQ.I2).AND.(IPROD(IHX,I,2).EQ.I1))) 
     1       PARTCORREL=PARTCORREL+BRFN(IHX,I,IDC,4,1)*
     1(DSQRT(BRFN(IHX,I,IDC,2,1)*BRFN(IHX,I,IDC,3,1))*YLDTOT(0,1,IHX))
c     1+BRFN(IHX,I,IDC,3,1)*BRFN(IHX,I,IDC,2,1)
c     1*(YLDTOT(1,1,IHX)-YLDTOT(0,1,IHX)))
            ELSE
               WRITE(*,*) 'WRONG IBOD FOR ',NAM(IHX),I,IBOD(IHX,I)
               CALL CRASHPROGRAM
            ENDIF
  298      CONTINUE
        ENDIF
 297  CONTINUE
      
      ENDIF
      ENDIF
 396  CONTINUE
 395  CONTINUE

       RETURN
       END

      FUNCTION STRANGENESS(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      STRANGENESS=DBLE(XS(IHAD))
c      WRITE(*,*) 'STRANGENESS FOR ',NAM(IHAD),' ',STRANGENESS
      RETURN
      END

      FUNCTION ANTISTRANGENESS(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      ANTISTRANGENESS=XAS(IHAD)
      RETURN
      END

       FUNCTION ANTIQUARKS(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      ANTIQUARKS=XAU(IHAD)+XAD(IHAD)
c      write(*,*) 'antiquarks ',NAM(IHAD),ANTIQUARKS

c      WRITE(*,*) 'STRANGENESS FOR ',NAM(IHAD),' ',STRANGENESS
      RETURN
      END

      FUNCTION NEGATIVES(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NEGATIVES=0D0
      IF(ICHARGE(IHAD).LT.0D0) NEGATIVES=1D0
c      WRITE(*,*) 'STRANGENESS FOR ',NAM(IHAD),' ',STRANGENESS
      RETURN
      END

      FUNCTION POSITIVES(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      POSITIVES=0D0
      IF(ICHARGE(IHAD).GT.0D0) POSITIVES=1D0
c      WRITE(*,*) 'POSITIVNESS CHARGE FOR ',NAM(IHAD),' ',POSITIVES
      RETURN
      END

      FUNCTION NEGCHARGE(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NEGCHARGE=0D0
      IF(ICHARGE(IHAD).LT.0D0) NEGCHARGE=-DBLE(ICHARGE(IHAD))
c      write(*,*) 'negcharge ',NAM(IHAD),' ',negcharge
      RETURN
      END

      FUNCTION POSCHARGE(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      POSCHARGE=0D0
      IF(ICHARGE(IHAD).GT.0D0) POSCHARGE=DBLE(ICHARGE(IHAD))
c      write(*,*) 'poscharge ',NAM(IHAD),' ',poscharge
      RETURN
      END

      FUNCTION NEUTMULTI(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NEUTMULTI=0D0
      IF(ICHARGE(IHAD).EQ.0D0) NEUTMULTI=1D0
c      WRITE(*,*) 'STRANGENESS FOR ',NAM(IHAD),' ',STRANGENESS
      RETURN
      END

      FUNCTION TOTSTRANGE(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      TOTSTRANGE=dble(XS(IHAD)+XAS(IHAD))
      RETURN
      END

      FUNCTION TOTU(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      TOTU=XU(IHAD)+XAU(IHAD)
      RETURN
      END

      FUNCTION TOTD(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      TOTD=XD(IHAD)+XAD(IHAD)
      RETURN
      END

      FUNCTION TOTLIGHT(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      TOTLIGHT=TOTU(IHAD)+TOTD(IHAD)
      RETURN
      END

      FUNCTION TOT_Q_QGP(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      TOT_Q_QGP=TOT_U_QGP(IHAD)+TOT_D_QGP(IHAD)
      RETURN
      END

      FUNCTION QUARKFRACTION(XQ)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      QUARKFRACTION=0D0
         IF(XQ.GT.1D0) THEN
            QUARKFRACTION=XQ/INT(XQ)
         ELSEIF(XQ.GT.0D0) THEN
            QUARKFRACTION=XQ
         ENDIF
      RETURN
      END




      FUNCTION TOTSTRQGP(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /FRACS/ FRACU,FRACD,FRACS,FRACAU,FRACAD,FRACAS,IQS,IAQS
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      IQS=INT(XU(IHAD)+XD(IHAD)+XS(IHAD))
      IAQS=INT(XAU(IHAD)+XAD(IHAD)+XAS(IHAD))
      IF(IMIX(IHAD).LT.2) THEN
        TOTSTRQGP=TOTSTRANGE(IHAD)
      ELSE
        TOTSTRQGP=0D0
        CALL FILL_FRACS(IHAD)
        DO 177 IQ=1,IQS
          IF((FRACU.GT.0D0).OR.(FRACD.GT.0D0).OR.(FRACS.GT.0D0)) THEN
           TOTSTRQGP=TOTSTRQGP+FRACS*GS2/(FRACU*GU2+FRACD*GD2+FRACS*GS2)
          ENDIF
 177    CONTINUE
        DO 178 IAQ=1,IAQS
         IF((FRACAU.GT.0D0).OR.(FRACAD.GT.0D0).OR.(FRACAS.GT.0D0)) THEN
       TOTSTRQGP=TOTSTRQGP+FRACAS*GS2/(FRACAU*GU2+FRACAD*GD2+FRACAS*GS2)
         ENDIF
 178    CONTINUE    
      ENDIF
      RETURN
      END


      FUNCTION TOT_U_QGP(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /FRACS/ FRACU,FRACD,FRACS,FRACAU,FRACAD,FRACAS,IQS,IAQS
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      IQS=INT(XU(IHAD)+XD(IHAD)+XS(IHAD))
      IAQS=INT(XAU(IHAD)+XAD(IHAD)+XAS(IHAD))
      IF(IMIX(IHAD).EQ.0) THEN
        TOT_U_QGP=TOTD(IHAD)
      ELSE
        TOT_U_QGP=0D0
        CALL FILL_FRACS(IHAD)
        DO 177 IQ=1,IQS
          IF((FRACU.GT.0D0).OR.(FRACD.GT.0D0).OR.(FRACS.GT.0D0)) THEN
           TOT_U_QGP=TOT_U_QGP+FRACU*GU2/(FRACU*GU2+FRACD*GD2+FRACS*GS2)
          ENDIF
 177    CONTINUE
        DO 178 IAQ=1,IAQS
         IF((FRACAU.GT.0D0).OR.(FRACAD.GT.0D0).OR.(FRACAS.GT.0D0)) THEN
       TOT_U_QGP=TOT_U_QGP+FRACAU*GU2/(FRACAU*GU2+FRACAD*GD2+FRACAS*GS2)
         ENDIF
 178    CONTINUE    
      ENDIF
      RETURN
      END

      FUNCTION TOT_D_QGP(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /FRACS/ FRACU,FRACD,FRACS,FRACAU,FRACAD,FRACAS,IQS,IAQS
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      IQS=INT(XU(IHAD)+XD(IHAD)+XS(IHAD))
      IAQS=INT(XAU(IHAD)+XAD(IHAD)+XAS(IHAD))
      IF(IMIX(IHAD).EQ.1) THEN
        TOT_D_QGP=TOTD(IHAD)
      ELSE
        TOT_D_QGP=0D0
        CALL FILL_FRACS(IHAD)
        DO 177 IQ=1,IQS
          IF((FRACU.GT.0D0).OR.(FRACD.GT.0D0).OR.(FRACS.GT.0D0)) THEN
           TOT_D_QGP=TOT_D_QGP+FRACD*GD2/(FRACU*GU2+FRACD*GD2+FRACS*GS2)
          ENDIF
 177    CONTINUE
        DO 178 IAQ=1,IAQS
         IF((FRACAU.GT.0D0).OR.(FRACAD.GT.0D0).OR.(FRACAS.GT.0D0)) THEN
c         write(*,*) 'fracau ',nam(ihad),' ',fracau,gu2,fracad,gd2,fracas,gs2
       TOT_D_QGP=TOT_D_QGP+FRACAD*GD2/(FRACAU*GU2+FRACAD*GD2+FRACAS*GS2)
         ENDIF
 178    CONTINUE    
      ENDIF
c      write(*,*) nam(ihad),' ended'
      RETURN
      END

      SUBROUTINE FILL_FRACS(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /FRACS/ FRACU,FRACD,FRACS,FRACAU,FRACAD,FRACAS,IQS,IAQS
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
C
        IQS=INT(XS(IHAD)+XU(IHAD)+XD(IHAD))
        IAQS=INT(XAS(IHAD)+XAU(IHAD)+XAD(IHAD))
        FRACU=QUARKFRACTION(XU(IHAD))
        FRACAU=QUARKFRACTION(XAU(IHAD))
        FRACD=QUARKFRACTION(XD(IHAD))
        FRACAD=QUARKFRACTION(XAD(IHAD))
        FRACS=QUARKFRACTION(XS(IHAD))
        FRACAS=QUARKFRACTION(XAS(IHAD))
      RETURN
      END


      FUNCTION NETSTRANGE(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NETSTRANGE=XS(IHAD)-XAS(IHAD)
      RETURN
      END

      FUNCTION TOTCHARM(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      TOTCHARM=dble(XCH(IHAD)+XACH(IHAD))
      RETURN
      END

      FUNCTION NETCHARM(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NETCHARM=dble(XCH(IHAD)-XACH(IHAD))
      RETURN
      END

      FUNCTION CHARGEHAD(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      CHARGEHAD=DABS(DBLE(ICHARGE(IHAD)))
      RETURN
      END

      FUNCTION MULTIHAD(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      MULTIHAD=1D0
      RETURN
      END


      FUNCTION NETCHARGE(IHAD)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NETCHARGE=DBLE(ICHARGE(IHAD))
      RETURN
      END

      FUNCTION BARHAD(IHAD)    
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      BARHAD=DABS(DBLE(IBAR(IHAD)))
      RETURN
      END

      FUNCTION NETBAR(IHAD)    
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      NETBAR=DBLE(IBAR(IHAD))
c      write(*,*) NAM(IHAD),' HAS BARYON N. ',NETBAR
      RETURN
      END

      FUNCTION TOTBULK(IFLUCT,IEPNX,IEXACTNUM)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(MMIN=1D-3)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      TOTBULK=0D0
      IEPN=IEPNX
      IEXP=1
      IF(IFLUCT.GE.1) THEN
         IEPN=5
         IEXP=2
      ENDIF
      DO 198 I=1,IHADS
         IF(MHAD(I).GT.MMIN) THEN
c           write(*,*) 'i,iexactnum ',I,IEXACTNUM
           IF(IEXACTNUM.NE.1) THEN
                 TOTBULK=TOTBULK+F_HAD(I)**IEXP
           ELSE 
                TOTBULK=TOTBULK+HADANAL(I)**IEXP
           ENDIF
         ENDIF
 198  CONTINUE
      IEPN=0
      RETURN
      END      

      FUNCTION HADANAL(IX)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(MMIN=1D-3)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      COMMON /HADANALCOMM/ IPH
      EXTERNAL HADANAL_INT
      IPH=IX
      PITWO=PI/2.D0
      FACTNORM=NORM*NORMFACT*MHAD(IPH)**3
      IF(IEPN.EQ.3) THEN
         MU=T*DLOG(CHEM(IPH))
         IEPN=0
         NDENS=DGAUSS(HADANAL_INT,0D0,PITWO,AC)
         NDENS_NUM=F_HAD(IPH)/FACTNORM
         IEPN=1
         EDENS=DGAUSS(HADANAL_INT,0D0,PITWO,AC)
         EDENS_NUM=F_HAD(IPH)/FACTNORM
         IEPN=2
         PDENS=DGAUSS(HADANAL_INT,0D0,PITWO,AC)
         PDENS_NUM=F_HAD(IPH)/FACTNORM
         ANSWER=(EDENS-MU*NDENS+PDENS)/T
         if(ANSWER.LT.0.D0) write(*,*) 'S<0 ',EDENS,PDENS,NDENS,PITWO
c         write(*,*) 'nums ',IX
c     1,EDENS/EDENS_NUM,PDENS/PDENS_NUM,NDENS/NDENS_NUM
         IEPN=3
       ELSE
         ANSWER=DGAUSS(HADANAL_INT,0D0,PITWO,AC)
      ENDIF
      HADANAL=XDEG(IPH)*NORM*NORMFACT*ANSWER*MHAD(IPH)**3
      IF(HADANAL.LT.0.D0) THEN
         write(*,*) 'hadanal<0 ',nam(iph),' ',AC
c     1,hadanal,ibs(iph),iepn,xdeg(iph),norm,normfact,answer,mhad(iph)
         STOP
      ENDIF
      RETURN
      END

      FUNCTION HADANAL_INT(THETA)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
        COMMON /YIELDS/ YLDPR(IHDMX),YLDST(IHDMX),
     1YLDFN(IHDMX),YLDCH(IHDMX),IEPN
         EXTERNAL NHAD,EHAD,NETSTRANGE,STRANGENESS,NEGATIVES,NEUTMULTI
     1,TOTSTRANGE,CHARGEHAD,NETCHARGE,BARHAD,NETBAR,MULTIHAD,POSITIVES
     1,ANTISTRANGENESS,ANTIQUARKS,TOTCHARM,NETCHARM,TOTLIGHT,TOTU,TOTD
     1,TOT_U_QGP,TOT_D_QGP,TOTSTRQGP,TOT_Q_QGP,POSCHARGE,NEGCHARGE
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /HADANALCOMM/ IPH
      COSTH=DCOS(THETA)
      CHEMTERM=CHEM(IPH)*DEXP(-MHAD(IPH)/(T*COSTH))
      IBNOW=-IBS(IPH)
      IF((IEPN.EQ.0).OR.(IEPN.EQ.4).OR.(IEPN.EQ.1).OR.(IEPN.EQ.5)) THEN
         TERM=CHEMTERM/(1.D0+IBNOW*CHEMTERM)
         IF((IEPN.EQ.1).OR.(IEPN.EQ.5)) TERM=TERM*MHAD(IPH)/COSTH
      ELSE
         TERM=IBNOW*T*DLOG(1D0+IBNOW*CHEMTERM)
      ENDIF
      HADANAL_INT=TERM*(DTAN(THETA)/COSTH)**2
        if(HADANAL_INT.LT.0.D0) then
           write(*,*) 'hadanal_int<0 ',NAM(IPH),CHEMTERM,TERM,IEPN
           stop
        endif
c      write(*,*) THETA,hadanal_int
      RETURN
      END



C----------- ANALYTICAL FORMULAE


      FUNCTION EHAD(T,M)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      KTERM=3D0*(T/M)*K2(M/T)+DBESK1(M/T)
      EHAD=KTERM*M**3*T
c      write(*,*) 'ehad ',ehad
c      if(m.lt.0.2) write(*,*) 'ehad ',ehad
      RETURN
      END      

      FUNCTION SHAD(T0,T,CHEM,M)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
C      PARAMETER(PIFACT=5.066059182116889E-002)
c      if(m.lt.0.2) write(*,*) 'shad pars ',real(CHEM),real(M),real(T)
      MU=T0*DLOG(CHEM)
      EDENS=EHAD(T,M)
      NDENS=NHAD(T,M)
      PDENS=PHAD(T,M)
      SHAD=(EDENS-MU*NDENS+PDENS)/T0
      if(shad.lt.0.D0) then
         write(*,*) 'shad<0 ',T,T0,MU,pdens,edens,ndens
         stop
      endif
      RETURN
      END    

      FUNCTION PHAD(T,M)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
C      PARAMETER(PIFACT=5.066059182116889E-002)
c      if(m.lt.0.2) write(*,*) 'phad pars ',real(CHEM),real(M),real(T)
      K2TERM=K2(M/T)
      PHAD=K2TERM*(M**2)*(T**2)
c      if(m.lt.0.2) write(*,*) 'phad ',pHAD
      RETURN
      END    


      FUNCTION NHAD(T,M)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
C      PARAMETER(PIFACT=5.066059182116889E-002)
c      if(m.lt.0.2) write(*,*) 'nhad pars ',real(CHEM),real(M),real(T)
      K2TERM=K2(M/T)
c------------------------------
c  APPROXIMATION:
c      NHAD=CHEM*M**1.5*DEXP(-M/T)
c------------------------------
      NHAD=K2TERM*M**2*T
C      IF(NHAD.LE.0D0) WRITE(*,*) 'NHAD=0 ',T,M,NHAD
c      if(m.lt.0.2) write(*,*) 'nhad ',nHAD
      RETURN
      END     

      FUNCTION K2(A)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      K2=DBESK0(A)+2D0*DBESK1(A)/A
      RETURN
      END


      FUNCTION IFINDPAR(PARNAME2)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IPRT=12)
      CHARACTER*4 NAMRAT(IPRT),TITRAT(IPRT)
      COMMON /MIPARSRAT_NAM/ NAMRAT,TITRAT
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
      CHARACTER*4 PARNAME,PARNAME2
      PARNAME=PARNAME2
        IF((PARNAME.EQ.'mui3').AND.(ILAM3MU3.EQ.0)) PARNAME='lmi3'
        IF((PARNAME.EQ.'mu_b').AND.(ILAMQMUQ.EQ.0)) PARNAME='lamq'
        IF((PARNAME.EQ.'mu_s').AND.(ILAMSMUS.EQ.0)) PARNAME='lams'
        IF((PARNAME.EQ.'mu_c').AND.(ILAMCMUC.EQ.0)) PARNAME='lamc'
C-------------------------------------
        IF((PARNAME.EQ.'lmi3').AND.(ILAM3MU3.EQ.1)) PARNAME='mui3'
        IF((PARNAME.EQ.'lamq').AND.(ILAMQMUQ.EQ.1)) PARNAME='mu_b'
        IF((PARNAME.EQ.'lams').AND.(ILAMSMUS.EQ.1)) PARNAME='mu_s'
        IF((PARNAME.EQ.'lamc').AND.(ILAMCMUC.EQ.1)) PARNAME='mu_c'
c---------------------------------------------
      IF(PARNAME.EQ.'gsgq') THEN
         IGSGQ=1
         PARNAME='gams'
      ENDIF
      IF((PARNAME.EQ.'gams').AND.(IGSGQ.GT.0)) THEN
         PARNAME='gsgq'
      ENDIF
      IFINDPAR=-1
      DO 189 I=1,IPRT
         IF(PARNAME.EQ.NAMRAT(I)) THEN
         IFINDPAR=I
         ENDIF
189   CONTINUE
      IF(IFINDPAR.LT.0) THEN
         WRITE(*,*) 'FINDPAR: UNKNOWN THERMAL PARAMETER ',PARNAME
         WRITE(*,*) 'PARAMETER: ',PARNAME2
         CALL CRASHPROGRAM
      ENDIF
      RETURN
      END
c--------------------------------------------------------------
c    miscellanea  (formerly misc.f)
c--------------------------------------------------------------
        SUBROUTINE DATETIME(IUNIT)
         IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      CHARACTER*10 TIMECHAR,DATECHAR
       CALL DATE_AND_TIME(DATECHAR,TIMECHAR)
2333    FORMAT(A20,A2,'/',A2,'/',A4,8X,A7,A2,':',A2,':',A2)
        WRITE(IUNIT,2333) ' DATE: (DD/MM/YYYY) ',DATECHAR(7:8)
     1 ,DATECHAR(5:6),DATECHAR(1:4),'TIME : '
     1 ,TIMECHAR(1:2),TIMECHAR(3:4),TIMECHAR(5:6)
c--------------------- CHARACTER ----------------
c        CALL DATIMH(DATCHAR,TIMECHAR)
c        WRITE(IUNIT,*) 'DATE: ',DATCHAR,' TIME: ',TIMECHAR
c------------------------------------------------
        RETURN
        END


c-----------------CHEMICAL POTENTIALS--------------

       FUNCTION MUBFUNC(T,LAMQ)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       MUBFUNC=3D0*T*DLOG(LAMQ)      
       RETURN
       END

       FUNCTION MUSFUNC(T,LAMS,LAMQ)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       MUSFUNC=-T*DLOG(LAMS/LAMQ)      
       RETURN
       END
      
       FUNCTION MUCFUNC(T,LAMC,LAMQ)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
        IMPLICIT INTEGER(I)
       MUCFUNC=T*DLOG(LAMC*LAMQ)      
       RETURN
       END

       FUNCTION MUBOTFUNC(T,LAMB,LAMQ)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       MUBOTFUNC=-T*DLOG(LAMB/LAMQ)      
       RETURN
       END

       FUNCTION LAMQFUNC(T,MUB)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       LAMQFUNC=DEXP(MUB/(3D0*T))
       WRITE(*,*) 'lamqfunc ',T,MUB,LAMQFUNC
C       WRITE(61,*) 'MUB ',REAL(MUB),' LAMQ ',REAL(LAMQFUNC)
       RETURN
       END

       FUNCTION LAMSFUNC(T,LAMQ,MUS)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       MUB=3D0*T*DLOG(LAMQ)
       LAMSFUNC=DEXP((MUB-3D0*MUS)/(3D0*T))
c       WRITE(61,*) 'LAMQ,MUB ',REAL(LAMQ),REAL(MUB)
c     1,' MUS,LAMS ',REAL(MUS),REAL(LAMSFUNC)
       RETURN
       END 

C---------------------------------------------------

       DOUBLE PRECISION FUNCTION M_TRESH(IP,IDC)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
       COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL

       IF((IDEC(IP).EQ.0).OR.(WIDTH(IP).LE.0D0))
     1 THEN
         M_TRESH=MHAD(IP)-2D0*WIDTH(IP)
       ELSE
         M_TRESH=0D0
         DO 804 ID=1,IBOD(IP,IDC)
 804       M_TRESH=M_TRESH+MHAD(IPROD(IP,IDC,ID))
       ENDIF
       M_THRESH_MIN=MPI*DBLE(IBOD(IP,IDC))
       IF(M_TRESH.LT.M_THRESH_MIN) M_THRESH=M_THRESH_MIN
       IF(M_TRESH.LT.MHAD(IP)-2D0*WIDTH(IP).AND.(IWEAK(IP,IDC).GT.0))
     1 M_TRESH=MHAD(IP)-2D0*WIDTH(IP)
 108   CONTINUE
       if(M_TRESH.LE.0D0) THEN
c          write(*,*) 'M_TRESH<0 ',NAM(IP),' ',IDC,M_TRESH
          M_TRESH=M_TRESH+1D-1*WIDTH(IP)
          GO TO 108
       endif
       RETURN
       END

       DOUBLE PRECISION FUNCTION L_REL(IP,IDC)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)

       L_REL=DBLE(0.5)*DBLE(XDEG(IP)-1)
       DO 804 ID=1,IBOD(IP,IDC)
 804      L_REL=L_REL-DBLE(0.5)*DBLE(XDEG(IPROD(IP,IDC,ID))-1)
       L_REL=DABS(L_REL)
       RETURN
       END
C-------------- MISC. MISC.

      SUBROUTINE CRASHPROGRAM
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      WRITE(*,*) 'PROGRAM TERMINATED WITH ERROR' 
     1,' YOU MIGHT WANT TO CHECK sharerun.out'
     1,' OR LINE BEFORE THIS MESSAGE'
      WRITE(61,*) 'PROGRAM ABOUT TO CRASH!'
C      A=10.
c      WRITE(61,*) A,DLOG(A-A)
      STOP
      END


      INTEGER FUNCTION IAPPROX(X)
        IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      IF(X-1D00*INT(X).GE.DBLE(0.5)) IAPPROX=INT(X)+1
      IF(X-1D00*INT(X).LT.DBLE(0.5)) IAPPROX=INT(X)
      RETURN
      END


      SUBROUTINE FILL_CHEM(IVERBOSE,ICRASH)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      PARAMETER(IRSMAX=50)
      PARAMETER(IBODMX=3)
      PARAMETER(IRATMX2=200)
      PARAMETER(MMIN=1D-3)
      COMMON /HADDEC/ BR(IHDMX,IRSMAX,2),BRFN(IHDMX,IRSMAX,IRATMX2,4,2)
     1,IBOD(IHDMX,IRSMAX),IPROD(IHDMX,IRSMAX,IBODMX),IDEC(IHDMX)
     1,IWEAK(IHDMX,IRSMAX),IPI0(IHDMX,IRSMAX)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL
      COMMON /THERMEXPS/ PI,HC
     1,AC,ACX,TBEFORE,ILAMQMUQ,ILAMSMUS,ILAMCMUC,ILAM3MU3
c      CHEMFACT=1D0
c      write(*,*) 'chemfill start ',gam3
C      WRITE(61,*) 'FILLING POTENTIALS'
c--------------------------------
      GAMU=GAMQ*GAM3
      GAMD=GAMQ/GAM3
      GU2=GAMU**2
      GD2=GAMD**2
      GS2=GAMS**2
c----------------------------
 198  I=IHADS+2
 199  I=I-1
      IF(MHAD(I).GT.MMIN) THEN
C  charm particles are computed elsewhere, therefore skip them! Boltzmann statistics is used for them, therefore they cannot B-E condensate.
       IF((XCH(I).GT.0).OR.(XACH(I).GT.0)) GOTO 201
        CHEM(I)=CHEMFACT*CHEMPOT(I)
        IDC=1
        IF(IDEC(I).GT.0) IDC=IDEC(I)
        DO 200 ID=1,IDC
c           if(WIDTH(I).GT.0D0) WRITE(*,*) 'WIDTH ',NAM(I),'!=0 ',WIDTH(I)
          CONDENS=CHEM(I)*DEXP(-M_TRESH(I,ID)/T)
          IF(CONDENS.GT.1D0) THEN   
           IF(IVERBOSE.GT.0) 
     1      write(*,*) nam(i),' condenses ',M_TRESH(I,ID)
     1     ,LAMQ,LAMS,LMI3,GAMQ,GAMS,GAM3,CHEM(I),T,CONDENS
           CHEMFACT=(1-AC)*CHEMFACT/CONDENS
c          write(*,*) 'condens ',NAM(I),' ',chem(i)
c     1,CHEM(I)*DEXP(-M_TRESH(I,ID)/T),(1-AC),CHEMFACT
           IF(ICRASH.GT.0) CALL CRASHPROGRAM
           GO TO 198
          ENDIF
 200    CONTINUE
 201   CONTINUE
      ENDIF
      IF(I.GT.1) GO TO 199
C      write(*,*) 'chemfill compl'
      RETURN
      END

      FUNCTION CHEMPOT(IP)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
      PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      COMMON /THERMVALS/
     1T,GAMQ,GAMS,GAM3,LAMQ,LAMS,LAMC,NCBC,LMI3,CHEMFACT
     1,DVOL,NORM,GAMU,GAMD,REALGAMC
     1,GU2,GD2,GS2,NORMFACT,MPI,TC2T,ICONDENSE,IBOLTZ,IGSGQ,ICANONICAL

      IF((LAMQ.EQ.0D0).OR.(LAMS.EQ.0D0)
     1.OR.(LAMC.EQ.0D0).OR.(LMI3.EQ.0D0)) THEN
         WRITE(*,*) 'ONE OF THE FUGACITIES=0D0  LAMQ,LAMS,LAMC,LMI3='
     1,LAMQ,LAMS,LAMC,LMI3
         CALL CRASHPROGRAM
      ENDIF
      CHEMQ=1D0
      CHEMS=1D0
      CHEMC=1D0
      PHAS=1D0
      PHASC=1D0
      IF(LAMQ.NE.0D0) CHEMQ=LAMQ**INETQ(IP)
      IF(LAMS.NE.0D0) CHEMS=LAMS**(XS(IP)-XAS(IP))
      IF(LAMC.NE.0D0) CHEMC=LAMC**(XCH(IP)-XACH(IP))
c      write(*,*) 'chemq ',NAM(IP),' ' ,LAMQ,INETQ(IP),CHEMQ
      IF(REALGAMC.GT.0D0) THEN
         PHASC=REALGAMC**(XCH(IP)+XACH(IP))
      ELSE
         WRITE(*,*) 'CHARM PHASE SPACE OCCUPANCY=0 ',
     1   ' GAMC=',REALGAMC
        CALL CRASHPROGRAM
      ENDIF
      IF((GAMQ.GT.0D0).AND.(GAMS.GT.0D0)) THEN
       IF(IMIX(IP).EQ.0) THEN
         PHAS=GAMU**(XU(IP)+XAU(IP))*GAMD**(XD(IP)+XAD(IP))
     1*GAMS**(XS(IP)+XAS(IP))
c         write(*,*) 'phas ',gamu,xu(ip),xd(ip),gamd,xau(ip),xad(ip),phas
       ELSE
         IF((XU(IP).NE.XAU(IP))
     1   .OR.(XD(IP).NE.XAD(IP)).OR.(XS(IP).NE.XAS(IP))) THEN
            WRITE(*,*) 'MIXING NOT IN QQBAR STATE ',NAM(IP)
     1,XU(IP),XAU(IP),XD(IP),XAD(IP)
            CALL CRASHPROGRAM
         ENDIF
         IF(ABS(XU(IP)+XD(IP)+XS(IP)-1D0).GT.1D-2) THEN
            WRITE(*,*) 'MIXING NOT IN MESON ',NAM(IP)
            WRITE(*,*) 'U,D,S: ',XU(IP),XD(IP),XS(IP)
            CALL CRASHPROGRAM
         ENDIF
         PHAS=XU(IP)*GAMU**2+XD(IP)*GAMD**2+XS(IP)*GAMS**2
       ENDIF
      ELSE
        WRITE(*,*) 'EITHER LIGHT OR STRANGE PHASE SPACE OCCUPANCY=0 ',
     1   ' GAMQ=',GAMQ,' GAMS=',GAMS
        CALL CRASHPROGRAM
      ENDIF
      XISPN=DBLE(I2I3SPIN(IP))/2D0
      CHEMI=LMI3**XISPN  
      CHEMPOT=CHEMQ*CHEMS*PHAS*CHEMI*CHEMC*PHASC
c      write(*,*) 
c     1'chem ',nam(ip),LAMQ,CHEMQ,CHEMS,PHAS,CHEMI,chempot
      RETURN
      END

      SUBROUTINE RANDOM_INIT
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      DIMENSION ITMDT(3)
      CALL ITIME(ITMDT)
      WRITE(61,*) 'TIME (INITIALIZATION) ',ITMDT(1),ITMDT(2),ITMDT(3)
      CALL RM48IN(ITMDT(1)+ITMDT(2)+ITMDT(3),0,0)
      RETURN
      END

      FUNCTION NONSING(P)
       IMPLICIT DOUBLE PRECISION(A-H,J-Z)
       IMPLICIT INTEGER(I)
       PARAMETER(IHDMX=1000)
      CHARACTER*9 NAM(IHDMX)
      COMMON /HADRONS/ MHAD(IHDMX),WIDTH(IHDMX),CHEM(IHDMX)
     1,XU(IHDMX),XD(IHDMX),XS(IHDMX),XCH(IHDMX),XAU(IHDMX)
     1,XAD(IHDMX),XAS(IHDMX),XACH(IHDMX)
     1,XB(IHDMX),XAB(IHDMX)
     1,XDEG(IHDMX),NAM,IBAR(IHDMX),INETQ(IHDMX)
     1,I2ISPIN(IHDMX),I2I3SPIN(IHDMX),IPN(IHDMX),IMIX(IHDMX)
     1,IHADS,ICHARGE(IHDMX),IBS(IHDMX)
      COMMON /THISPART/ MTRESH,M0,LREL,WDT
     1,TTERM,MT2,IP,ITOPBT,IEXP
      P2=P**2
      E=DSQRT(P2+MHAD(IP)**2)
      EXPTRM=CHEM(IP)*DEXP(-E/TTERM)
      NONSING=P2*EXPTRM/(1D0-EXPTRM)**IEXP
      RETURN
      END


      SUBROUTINE EASTER()
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      WRITE(*,*) ""
      WRITE(*,*) "You have found a spherical chicken in the vacuum."
      WRITE(*,*) "After a while, it lays an Easter Egg... "
      WRITE(*,*) "You are amazed by its beauty and you keep "
     1 ,"staring at it."
      WRITE(*,*)"                                        "
      WRITE(*,*)"                 .....                  "
      WRITE(*,*)"              :+++++++++?..             "
      WRITE(*,*)"            +=+++++++=+++?=?            "
      WRITE(*,*)"          =+++======+++++????,          "
      WRITE(*,*)"         ~+===~======++++????I=.        "
      WRITE(*,*)"       .===::::::~====+++??+?II+        "
      WRITE(*,*)"       +=~:::::::~~===+++??+II777       "
      WRITE(*,*)"      +~::::::::~~~====++?+?II77IZ      "
      WRITE(*,*)"     .=:::::::::~~~~===+++?=II??+$      "
      WRITE(*,*)"    .==:::::::::~~~~===++??II7???$Z     "
      WRITE(*,*)"    .=::::::::::~~~====++??II777I$Z.    "
      WRITE(*,*)"    ==~~~~~~~::~~~~===+++??I777$$ZZZ    "
      WRITE(*,*)"    ==~~:~~~~~~~~~====++??II77$IZZZZ    "
      WRITE(*,*)"   .+=~~~~~~~~~~~====++???II??$$ZZZO    "
      WRITE(*,*)"   .+=~~~~~~~~======++???III7$$$ZZOO    "
      WRITE(*,*)"   ,++~~~=========+++???II77$$ZZZOO8    "
      WRITE(*,*)"   :++~=========++++??III77$$ZZZOO88    "
      WRITE(*,*)"   .+++=====++++++???II777$$ZZOO$O88    "
      WRITE(*,*)"   .????=++==++????III777$$ZZOOO8888.   "
      WRITE(*,*)"    I????????????III777$$$ZZO$O88888    "
      WRITE(*,*)"    ?I+II?+I?IIIII7777$$ZZZOO8888888    "
      WRITE(*,*)"    .?7+IIII77I7777$$77ZZOOO8Z888DD.    "
      WRITE(*,*)"    .7?7??777777$$$$$ZZOOOO8888DO8D     "
      WRITE(*,*)"     .$$$7$$$$$$$ZZZZOOOOOZOOOD888      "
      WRITE(*,*)"       7$$$$7ZZZO$$OOOOOO888D8888.      "
      WRITE(*,*)"       .ZZZZ$ZZZOOOOO888888OD888        "
      WRITE(*,*)"         ~ZZO7$$OOO888888DDD88..        "
      WRITE(*,*)" ...........OZO$888888888888............"
      WRITE(*,*)".....,,::~=+?I78888888888$7I?+=~~:,,...."
      WRITE(*,*)".....,,:~~=I7$ZO8DDDDDDD8OZZ$?+=~:,,,..."
      WRITE(*,*)"........,~~~~=====++++++++=====,........"
      WRITE(*,*)"      .::::::,:::::::::::::::::::       "
      WRITE(*,*)""
      WRITE(*,*) "... until you decide to press the Enter key"
      READ(*,*)
      RETURN
      END

      FUNCTION IREADCOMMENT(IUNIT)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      CHARACTER*1 COMMENT_TAG
      IREADCOMMENT=0
 136  READ(IUNIT,133,END=117) COMMENT_TAG
 133  FORMAT(A1)
      IF((COMMENT_TAG.EQ.'#').OR.(COMMENT_TAG.EQ.' ')) THEN
         GO TO 136
      ELSE
         IF(COMMENT_TAG.NE.'*') THEN
            BACKSPACE IUNIT
         ELSE
            IREADCOMMENT=1
         ENDIF
      ENDIF
      GO TO 118
 117    IREADCOMMENT=1
 118  CONTINUE
      RETURN
      END

      FUNCTION IFLTEST(FLTERM)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      CHARACTER*9 FLTERM
      IF(FLTERM(1:5).NE.'fluct') THEN
         IFLTEST=0
      ELSE
         IF(FLTERM.EQ.'fluct_yld') THEN
            IFLTEST=1
         ELSEIF(FLTERM.EQ.'fluct_dyn') THEN 
            IFLTEST=2 
C         ELSEIF(FLTERM.EQ.'fluct_dns') THEN 
C            IFLTEST=3
C         ELSEIF(FLTERM.EQ.'fluct_rat') THEN 
C            IFLTEST=4
C         ELSEIF(FLTERM.EQ.'fluct_dif') THEN
C            IFLTEST=5
         ELSEIF(FLTERM.EQ.'fluctdynv') THEN
            IFLTEST=6
C         ELSEIF(FLTERM.EQ.'fluctvdyn') THEN
C            IFLTEST=7
         ELSEIF(FLTERM.EQ.'fluctdnch') THEN
            IFLTEST=8
         ELSEIF(FLTERM.EQ.'fluctsgsm') THEN
            IFLTEST=9
         ELSE
            WRITE(*,*) 'UNKNOWN FLUCTUATION ',FLTERM
            CALL CRASHPROGRAM
         ENDIF
      ENDIF
      RETURN
      END


      FUNCTION FLCDYN(IFLUCT,TOT,STAT)
      IMPLICIT DOUBLE PRECISION(A-H,J-Z)
      IMPLICIT INTEGER(I)
      IF(IFLUCT.LE.1) THEN
        FLCDYN=TOT
      ELSEIF((IFLUCT.EQ.5).OR.(IFLUCT.EQ.2)
     1.OR.(IFLUCT.GE.6)) THEN
        FLCDYN=TOT-STAT
        IF(IFLUCT.EQ.2) FLCDYN=DSQRT(ABS(FLCDYN))
        IF((STAT.GT.TOT).AND.(IFLUCT.EQ.2)) FLCDYN=-FLCDYN
      ELSEIF(IFLUCT.EQ.3) THEN
        FLCDYN=ABS(SQRT(TOT)-SQRT(STAT))
      ELSEIF(IFLUCT.EQ.4) THEN
        FLCDYN=TOT/STAT
      ELSE
         WRITE(*,*) 'UNKOWN FLCDYN ',FLCDYN
      ENDIF
C      write(*,*) 'dyn ',ifluct,tot,stat,flcdyn
      RETURN
      END





